/* DUPLICATOR MYSQL SCRIPT CREATED ON : October 31, 2014, 9:45 pm */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) NOT NULL DEFAULT '',
  `comment_type` varchar(20) NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `hash` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8_unicode_ci NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL DEFAULT '',
  `link_name` varchar(255) NOT NULL DEFAULT '',
  `link_image` varchar(255) NOT NULL DEFAULT '',
  `link_target` varchar(25) NOT NULL DEFAULT '',
  `link_description` varchar(255) NOT NULL DEFAULT '',
  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL DEFAULT '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) NOT NULL DEFAULT '',
  `option_value` longtext NOT NULL,
  `autoload` varchar(20) NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=342 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=539 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_excerpt` text NOT NULL,
  `post_status` varchar(20) NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_password` varchar(20) NOT NULL DEFAULT '',
  `post_name` varchar(200) NOT NULL DEFAULT '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=148 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_revslider_css` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `handle` text NOT NULL,
  `settings` text,
  `hover` text,
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=48 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_revslider_layer_animations` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `handle` text NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_revslider_settings` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `general` text NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_revslider_sliders` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `title` tinytext NOT NULL,
  `alias` tinytext,
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_revslider_slides` (
  `id` int(9) NOT NULL AUTO_INCREMENT,
  `slider_id` int(9) NOT NULL,
  `slide_order` int(11) NOT NULL,
  `params` text NOT NULL,
  `layers` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `slug` varchar(200) NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `slug` (`slug`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) NOT NULL DEFAULT '',
  `user_pass` varchar(64) NOT NULL DEFAULT '',
  `user_nicename` varchar(50) NOT NULL DEFAULT '',
  `user_email` varchar(100) NOT NULL DEFAULT '',
  `user_url` varchar(100) NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("1", "1", "Mr WordPress", "", "https://wordpress.org/", "", "2014-09-16 17:32:31", "2014-09-16 17:32:31", "Hi, this is a comment.\nTo delete a comment, just log in and view the post&#039;s comments. There you will have the option to edit or delete them.", "0", "1", "", "", "0", "0");

/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("1", "20141031_parentingblog", "5454030407a9e1502141031214540", "20", "2014-10-31 21:45:57", "admin", "O:11:\"DUP_Package\":16:{s:2:\"ID\";i:1;s:4:\"Name\";s:22:\"20141031_parentingblog\";s:4:\"Hash\";s:29:\"5454030407a9e1502141031214540\";s:8:\"NameHash\";s:52:\"20141031_parentingblog_5454030407a9e1502141031214540\";s:7:\"Version\";s:5:\"0.5.8\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:72:\"/home1/anton241/public_html/blogsforsales.com/parenting/wp-snapshots/tmp\";s:8:\"StoreURL\";s:48:\"http://blogsforsales.com/parenting/wp-snapshots/\";s:8:\"ScanFile\";s:62:\"20141031_parentingblog_5454030407a9e1502141031214540_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":17:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";s:64:\"20141031_parentingblog_5454030407a9e1502141031214540_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:55:\"/home1/anton241/public_html/blogsforsales.com/parenting\";s:4:\"Size\";i:0;s:12:\"WarnFileSize\";a:0:{}s:12:\"WarnFileName\";a:0:{}s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:5:\"Links\";a:0:{}s:8:\"OmitDirs\";a:0:{}s:9:\"OmitFiles\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:22:\"20141031_parentingblog\";s:4:\"Hash\";s:29:\"5454030407a9e1502141031214540\";s:8:\"NameHash\";s:52:\"20141031_parentingblog_5454030407a9e1502141031214540\";s:7:\"Version\";s:5:\"0.5.8\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:72:\"/home1/anton241/public_html/blogsforsales.com/parenting/wp-snapshots/tmp\";s:8:\"StoreURL\";s:48:\"http://blogsforsales.com/parenting/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";r:15;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:66:\"20141031_parentingblog_5454030407a9e1502141031214540_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:30;}s:8:\"Database\";O:12:\"DUP_Database\":9:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:65:\"20141031_parentingblog_5454030407a9e1502141031214540_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;}}s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";r:45;s:8:\"Database\";r:57;}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://blogsforsales.com/parenting", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "http://blogsforsales.com/parenting", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "Parenting Blog", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "mail@yourmail.com", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "1", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("29", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:9:{i:0;s:43:\"animated-gif-resize/animated-gif-resize.php\";i:1;s:36:\"contact-form-7/wp-contact-form-7.php\";i:2;s:25:\"duplicator/duplicator.php\";i:3;s:19:\"jetpack/jetpack.php\";i:4;s:27:\"js_composer/js_composer.php\";i:5;s:33:\"privacy-policy/privacy-policy.php\";i:6;s:23:\"revslider/revslider.php\";i:7;s:39:\"td-social-counter/td-social-counter.php\";i:8;s:27:\"wp-super-cache/wp-cache.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("37", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("38", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("39", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("40", "recently_edited", "", "no");
INSERT INTO `wp_options` VALUES("41", "template", "Newspaper", "yes");
INSERT INTO `wp_options` VALUES("42", "stylesheet", "Newspaper", "yes");
INSERT INTO `wp_options` VALUES("43", "comment_whitelist", "", "yes");
INSERT INTO `wp_options` VALUES("44", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("45", "comment_registration", "1", "yes");
INSERT INTO `wp_options` VALUES("46", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("47", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("48", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("49", "db_version", "29630", "yes");
INSERT INTO `wp_options` VALUES("50", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("51", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("52", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("53", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("54", "show_on_front", "page", "yes");
INSERT INTO `wp_options` VALUES("55", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("56", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("57", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("58", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("59", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("60", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("61", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("62", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("63", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("64", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("65", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("66", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("67", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("68", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("69", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("70", "close_comments_for_old_posts", "", "yes");
INSERT INTO `wp_options` VALUES("71", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("72", "thread_comments", "", "yes");
INSERT INTO `wp_options` VALUES("73", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("74", "page_comments", "", "yes");
INSERT INTO `wp_options` VALUES("75", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("76", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("77", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("78", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("79", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("80", "widget_text", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:273:\"<iframe src=\"http://rcm-na.amazon-adsystem.com/e/cm?t=parenting045-20&o=1&p=12&l=ur1&category=baby&banner=0NZY3146JAC39SPTJC82&f=ifr&linkID=B5EXTFL35TCRQLMC\" width=\"300\" height=\"250\" scrolling=\"no\" border=\"0\" marginwidth=\"0\" style=\"border:none;\" frameborder=\"0\"></iframe>\r\n\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("81", "widget_rss", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("82", "uninstall_plugins", "a:1:{s:27:\"wp-super-cache/wp-cache.php\";s:23:\"wpsupercache_deactivate\";}", "no");
INSERT INTO `wp_options` VALUES("83", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("84", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("85", "page_on_front", "16", "yes");
INSERT INTO `wp_options` VALUES("86", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("88", "initial_db_version", "29630", "yes");
INSERT INTO `wp_options` VALUES("89", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("90", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("91", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("92", "widget_recent-comments", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("93", "widget_archives", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("94", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("95", "sidebars_widgets", "a:8:{s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:19:\"wp_inactive_widgets\";a:0:{}s:10:\"td-default\";a:4:{i:0;s:19:\"td_ad_box_widget-70\";i:1;s:19:\"td_social_widget-71\";i:2;s:6:\"text-2\";i:3;s:19:\"td_block4_widget-72\";}s:12:\"td-top-right\";a:0:{}s:11:\"td-footer-1\";a:1:{i:0;s:10:\"calendar-2\";}s:11:\"td-footer-2\";a:1:{i:0;s:19:\"td_block4_widget-74\";}s:11:\"td-footer-3\";a:1:{i:0;s:31:\"td_popular_categories_widget-75\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("96", "cron", "a:11:{i:1414794963;a:1:{s:14:\"mm_cron_hourly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1414795264;a:1:{s:20:\"jetpack_clean_nonces\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1414800000;a:1:{s:11:\"wp_cache_gc\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1414819956;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1414827509;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1414834563;a:2:{s:13:\"mm_cron_daily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:18:\"mm_cron_twicedaily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1414863175;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1414863940;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1415180163;a:1:{s:14:\"mm_cron_weekly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1417210563;a:1:{s:15:\"mm_cron_monthly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:7:\"monthly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2635200;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("98", "_transient_random_seed", "982888cda79f87a8b65c57527e0996a7", "yes");
INSERT INTO `wp_options` VALUES("99", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-4.0.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-4.0.zip\";s:10:\"no_content\";s:68:\"https://downloads.wordpress.org/release/wordpress-4.0-no-content.zip\";s:11:\"new_bundled\";s:69:\"https://downloads.wordpress.org/release/wordpress-4.0-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"4.0\";s:7:\"version\";s:3:\"4.0\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.8\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1414791926;s:15:\"version_checked\";s:3:\"4.0\";s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("104", "_site_transient_timeout_browser_47501a773fe850ef5105e7eb40e53b58", "1411493576", "yes");
INSERT INTO `wp_options` VALUES("105", "_site_transient_browser_47501a773fe850ef5105e7eb40e53b58", "a:9:{s:8:\"platform\";s:9:\"Macintosh\";s:4:\"name\";s:6:\"Safari\";s:7:\"version\";s:5:\"7.0.6\";s:10:\"update_url\";s:28:\"http://www.apple.com/safari/\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/safari.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/safari.png\";s:15:\"current_version\";s:1:\"5\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("110", "can_compress_scripts", "1", "yes");
INSERT INTO `wp_options` VALUES("123", "recently_activated", "a:2:{s:19:\"jetpack/jetpack.php\";i:1414575409;s:40:\"mojo-marketplace-hg/mojo-marketplace.php\";i:1414575409;}", "yes");
INSERT INTO `wp_options` VALUES("125", "ossdl_off_cdn_url", "http://blogsforsales.com/parenting", "yes");
INSERT INTO `wp_options` VALUES("126", "ossdl_off_include_dirs", "wp-content,wp-includes", "yes");
INSERT INTO `wp_options` VALUES("127", "ossdl_off_exclude", ".php", "yes");
INSERT INTO `wp_options` VALUES("128", "ossdl_cname", "", "yes");
INSERT INTO `wp_options` VALUES("129", "jetpack_activated", "1", "yes");
INSERT INTO `wp_options` VALUES("130", "jetpack_options", "a:2:{s:7:\"version\";s:16:\"3.1.1:1410889264\";s:11:\"old_version\";s:16:\"3.1.1:1410889264\";}", "yes");
INSERT INTO `wp_options` VALUES("135", "wpsupercache_start", "1410889364", "yes");
INSERT INTO `wp_options` VALUES("136", "wpsupercache_count", "0", "yes");
INSERT INTO `wp_options` VALUES("137", "supercache_stats", "a:3:{s:9:\"generated\";i:1410890650;s:10:\"supercache\";a:5:{s:7:\"expired\";i:0;s:12:\"expired_list\";a:0:{}s:6:\"cached\";i:0;s:11:\"cached_list\";a:0:{}s:2:\"ts\";i:1410890650;}s:7:\"wpcache\";a:3:{s:6:\"cached\";i:0;s:7:\"expired\";i:0;s:5:\"fsize\";s:3:\"0KB\";}}", "yes");
INSERT INTO `wp_options` VALUES("148", "_transient_twentyfourteen_category_count", "1", "yes");
INSERT INTO `wp_options` VALUES("150", "jpstart_wizard_has_run", "1", "yes");
INSERT INTO `wp_options` VALUES("151", "_transient_timeout_mm_test", "1416994562", "no");
INSERT INTO `wp_options` VALUES("152", "_transient_mm_test", "a:2:{s:4:\"name\";s:18:\"spam-prevention-v1\";s:3:\"key\";s:32:\"a736d113a8bda8c8e934a9b2bd73b7b4\";}", "no");
INSERT INTO `wp_options` VALUES("153", "mm_previous_tests", "a:1:{i:0;s:18:\"spam-prevention-v1\";}", "yes");
INSERT INTO `wp_options` VALUES("158", "mm_master_aff", "hostgator", "yes");
INSERT INTO `wp_options` VALUES("159", "mm_install_date", "Oct 29, 2014", "yes");
INSERT INTO `wp_options` VALUES("160", "_site_transient_timeout_browser_efdd8e8dfc89de8875254f2e96f2eeb2", "1415180164", "yes");
INSERT INTO `wp_options` VALUES("161", "_site_transient_browser_efdd8e8dfc89de8875254f2e96f2eeb2", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:7:\"Firefox\";s:7:\"version\";s:4:\"32.0\";s:10:\"update_url\";s:23:\"http://www.firefox.com/\";s:7:\"img_src\";s:50:\"http://s.wordpress.org/images/browsers/firefox.png\";s:11:\"img_src_ssl\";s:49:\"https://wordpress.org/images/browsers/firefox.png\";s:15:\"current_version\";s:2:\"16\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("162", "mm_cron", "a:3:{s:5:\"daily\";a:1:{s:14:\"plugin_version\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:14:\"plugin_version\";s:2:\"el\";s:5:\"0.5.9\";}}s:6:\"weekly\";a:1:{s:10:\"wp_version\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:10:\"wp_version\";s:2:\"el\";s:3:\"4.0\";}}s:7:\"monthly\";a:3:{s:12:\"plugin_count\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:12:\"plugin_count\";s:2:\"el\";i:3;}s:11:\"theme_count\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:11:\"theme_count\";s:2:\"el\";i:3;}s:13:\"current_theme\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:13:\"current_theme\";s:2:\"el\";s:14:\"twentyfourteen\";}}}", "yes");
INSERT INTO `wp_options` VALUES("163", "_site_transient_timeout_ghu-1eda13567dd0e7ce35b07e674764d1ef", "1414578967", "yes");
INSERT INTO `wp_options` VALUES("164", "_site_transient_ghu-1eda13567dd0e7ce35b07e674764d1ef", "O:8:\"stdClass\":11:{s:4:\"name\";s:20:\"mojo-marketplace.php\";s:4:\"path\";s:20:\"mojo-marketplace.php\";s:3:\"sha\";s:40:\"b1607a43af0070495b2a64a627dc90c6924ad87c\";s:4:\"size\";i:1979;s:3:\"url\";s:112:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/contents/mojo-marketplace.php?ref=hg-production\";s:8:\"html_url\";s:94:\"https://github.com/mojoness/mojo-marketplace-wp-plugin/blob/hg-production/mojo-marketplace.php\";s:7:\"git_url\";s:115:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/git/blobs/b1607a43af0070495b2a64a627dc90c6924ad87c\";s:4:\"type\";s:4:\"file\";s:7:\"content\";s:2684:\"PD9waHAKLyoKUGx1Z2luIE5hbWU6IE1PSk8gTWFya2V0cGxhY2UKRGVzY3Jp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\nZF9hY3Rpb24oICdhZG1pbl9pbml0JywgJ21tX2xvYWRfdXBkYXRlcicgKTs=\n\";s:8:\"encoding\";s:6:\"base64\";s:6:\"_links\";O:8:\"stdClass\":3:{s:4:\"self\";s:112:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/contents/mojo-marketplace.php?ref=hg-production\";s:3:\"git\";s:115:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/git/blobs/b1607a43af0070495b2a64a627dc90c6924ad87c\";s:4:\"html\";s:94:\"https://github.com/mojoness/mojo-marketplace-wp-plugin/blob/hg-production/mojo-marketplace.php\";}}", "yes");
INSERT INTO `wp_options` VALUES("165", "_site_transient_timeout_ghu-aca1a99da826e8036f3bd23a2dafb4ea", "1414578967", "yes");
INSERT INTO `wp_options` VALUES("166", "_site_transient_ghu-aca1a99da826e8036f3bd23a2dafb4ea", "O:8:\"stdClass\":3:{s:11:\"total_count\";i:1;s:18:\"incomplete_results\";b:0;s:5:\"items\";a:1:{i:0;O:8:\"stdClass\":68:{s:2:\"id\";i:16290496;s:4:\"name\";s:26:\"mojo-marketplace-wp-plugin\";s:9:\"full_name\";s:35:\"mojoness/mojo-marketplace-wp-plugin\";s:5:\"owner\";O:8:\"stdClass\":17:{s:5:\"login\";s:8:\"mojoness\";s:2:\"id\";i:1278255;s:10:\"avatar_url\";s:51:\"https://avatars.githubusercontent.com/u/1278255?v=2\";s:11:\"gravatar_id\";s:0:\"\";s:3:\"url\";s:37:\"https://api.github.com/users/mojoness\";s:8:\"html_url\";s:27:\"https://github.com/mojoness\";s:13:\"followers_url\";s:47:\"https://api.github.com/users/mojoness/followers\";s:13:\"following_url\";s:60:\"https://api.github.com/users/mojoness/following{/other_user}\";s:9:\"gists_url\";s:53:\"https://api.github.com/users/mojoness/gists{/gist_id}\";s:11:\"starred_url\";s:60:\"https://api.github.com/users/mojoness/starred{/owner}{/repo}\";s:17:\"subscriptions_url\";s:51:\"https://api.github.com/users/mojoness/subscriptions\";s:17:\"organizations_url\";s:42:\"https://api.github.com/users/mojoness/orgs\";s:9:\"repos_url\";s:43:\"https://api.github.com/users/mojoness/repos\";s:10:\"events_url\";s:54:\"https://api.github.com/users/mojoness/events{/privacy}\";s:19:\"received_events_url\";s:53:\"https://api.github.com/users/mojoness/received_events\";s:4:\"type\";s:12:\"Organization\";s:10:\"site_admin\";b:0;}s:7:\"private\";b:0;s:8:\"html_url\";s:54:\"https://github.com/mojoness/mojo-marketplace-wp-plugin\";s:11:\"description\";s:58:\"WordPress plugin that has shortcodes, widgets and themes. \";s:4:\"fork\";b:0;s:3:\"url\";s:64:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin\";s:9:\"forks_url\";s:70:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/forks\";s:8:\"keys_url\";s:78:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/keys{/key_id}\";s:17:\"collaborators_url\";s:93:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/collaborators{/collaborator}\";s:9:\"teams_url\";s:70:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/teams\";s:9:\"hooks_url\";s:70:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/hooks\";s:16:\"issue_events_url\";s:87:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/issues/events{/number}\";s:10:\"events_url\";s:71:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/events\";s:13:\"assignees_url\";s:81:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/assignees{/user}\";s:12:\"branches_url\";s:82:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/branches{/branch}\";s:8:\"tags_url\";s:69:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/tags\";s:9:\"blobs_url\";s:80:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/git/blobs{/sha}\";s:12:\"git_tags_url\";s:79:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/git/tags{/sha}\";s:12:\"git_refs_url\";s:79:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/git/refs{/sha}\";s:9:\"trees_url\";s:80:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/git/trees{/sha}\";s:12:\"statuses_url\";s:79:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/statuses/{sha}\";s:13:\"languages_url\";s:74:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/languages\";s:14:\"stargazers_url\";s:75:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/stargazers\";s:16:\"contributors_url\";s:77:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/contributors\";s:15:\"subscribers_url\";s:76:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/subscribers\";s:16:\"subscription_url\";s:77:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/subscription\";s:11:\"commits_url\";s:78:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/commits{/sha}\";s:15:\"git_commits_url\";s:82:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/git/commits{/sha}\";s:12:\"comments_url\";s:82:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/comments{/number}\";s:17:\"issue_comment_url\";s:89:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/issues/comments/{number}\";s:12:\"contents_url\";s:81:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/contents/{+path}\";s:11:\"compare_url\";s:88:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/compare/{base}...{head}\";s:10:\"merges_url\";s:71:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/merges\";s:11:\"archive_url\";s:87:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/{archive_format}{/ref}\";s:13:\"downloads_url\";s:74:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/downloads\";s:10:\"issues_url\";s:80:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/issues{/number}\";s:9:\"pulls_url\";s:79:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/pulls{/number}\";s:14:\"milestones_url\";s:84:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/milestones{/number}\";s:17:\"notifications_url\";s:104:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/notifications{?since,all,participating}\";s:10:\"labels_url\";s:78:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/labels{/name}\";s:12:\"releases_url\";s:78:\"https://api.github.com/repos/mojoness/mojo-marketplace-wp-plugin/releases{/id}\";s:10:\"created_at\";s:20:\"2014-01-27T19:47:10Z\";s:10:\"updated_at\";s:20:\"2014-09-04T17:03:04Z\";s:9:\"pushed_at\";s:20:\"2014-10-10T17:48:53Z\";s:7:\"git_url\";s:56:\"git://github.com/mojoness/mojo-marketplace-wp-plugin.git\";s:7:\"ssh_url\";s:54:\"git@github.com:mojoness/mojo-marketplace-wp-plugin.git\";s:9:\"clone_url\";s:58:\"https://github.com/mojoness/mojo-marketplace-wp-plugin.git\";s:7:\"svn_url\";s:54:\"https://github.com/mojoness/mojo-marketplace-wp-plugin\";s:8:\"homepage\";N;s:4:\"size\";i:1267;s:16:\"stargazers_count\";i:2;s:14:\"watchers_count\";i:2;s:8:\"language\";s:3:\"PHP\";s:10:\"has_issues\";b:1;s:13:\"has_downloads\";b:1;s:8:\"has_wiki\";b:1;s:9:\"has_pages\";b:0;s:11:\"forks_count\";i:1;s:10:\"mirror_url\";N;s:17:\"open_issues_count\";i:0;s:5:\"forks\";i:1;s:11:\"open_issues\";i:0;s:8:\"watchers\";i:2;s:14:\"default_branch\";s:6:\"master\";s:5:\"score\";d:19.904959999999999098463376867584884166717529296875;}}}", "yes");
INSERT INTO `wp_options` VALUES("167", "_site_transient_timeout_ghu-cd60ad3e4bd0d8706fc4a4f35f398ee5", "1414578967", "yes");
INSERT INTO `wp_options` VALUES("168", "_site_transient_ghu-cd60ad3e4bd0d8706fc4a4f35f398ee5", "no tags here", "yes");
INSERT INTO `wp_options` VALUES("169", "_site_transient_timeout_ghu-9bb54241f94b24d969f7f1e4865eb9ed", "1414578968", "yes");
INSERT INTO `wp_options` VALUES("170", "_site_transient_ghu-9bb54241f94b24d969f7f1e4865eb9ed", "O:8:\"stdClass\":2:{s:7:\"message\";s:9:\"Not Found\";s:17:\"documentation_url\";s:31:\"https://developer.github.com/v3\";}", "yes");
INSERT INTO `wp_options` VALUES("187", "wpsupercache_gc_time", "1414731157", "yes");
INSERT INTO `wp_options` VALUES("191", "privacy_policy_sitename", "Parenting Blog", "yes");
INSERT INTO `wp_options` VALUES("192", "privacy_policy_before_heading", "<h2>", "yes");
INSERT INTO `wp_options` VALUES("193", "privacy_policy_after_heading", "</h2>", "yes");
INSERT INTO `wp_options` VALUES("194", "privacy_policy_before_paragraph", "<p>", "yes");
INSERT INTO `wp_options` VALUES("195", "privacy_policy_after_paragraph", "</p>", "yes");
INSERT INTO `wp_options` VALUES("196", "privacy_policy_contact", "mail@yourmail.com", "yes");
INSERT INTO `wp_options` VALUES("197", "privacy_policy_title", "Privacy Policy", "yes");
INSERT INTO `wp_options` VALUES("198", "privacy_policy_slug", "privacy-policy", "yes");
INSERT INTO `wp_options` VALUES("199", "privacy_policy_pp_help", "1", "yes");
INSERT INTO `wp_options` VALUES("200", "privacy_policy_browser_help", "1", "yes");
INSERT INTO `wp_options` VALUES("201", "privacy_policy_credit", "1", "yes");
INSERT INTO `wp_options` VALUES("202", "WPLANG", "", "yes");
INSERT INTO `wp_options` VALUES("207", "_site_transient_timeout_wporg_theme_feature_list", "1414586300", "yes");
INSERT INTO `wp_options` VALUES("208", "_site_transient_wporg_theme_feature_list", "a:4:{s:6:\"Colors\";a:15:{i:0;s:5:\"black\";i:1;s:4:\"blue\";i:2;s:5:\"brown\";i:3;s:4:\"gray\";i:4;s:5:\"green\";i:5;s:6:\"orange\";i:6;s:4:\"pink\";i:7;s:6:\"purple\";i:8;s:3:\"red\";i:9;s:6:\"silver\";i:10;s:3:\"tan\";i:11;s:5:\"white\";i:12;s:6:\"yellow\";i:13;s:4:\"dark\";i:14;s:5:\"light\";}s:6:\"Layout\";a:9:{i:0;s:12:\"fixed-layout\";i:1;s:12:\"fluid-layout\";i:2;s:17:\"responsive-layout\";i:3;s:10:\"one-column\";i:4;s:11:\"two-columns\";i:5;s:13:\"three-columns\";i:6;s:12:\"four-columns\";i:7;s:12:\"left-sidebar\";i:8;s:13:\"right-sidebar\";}s:8:\"Features\";a:20:{i:0;s:19:\"accessibility-ready\";i:1;s:8:\"blavatar\";i:2;s:10:\"buddypress\";i:3;s:17:\"custom-background\";i:4;s:13:\"custom-colors\";i:5;s:13:\"custom-header\";i:6;s:11:\"custom-menu\";i:7;s:12:\"editor-style\";i:8;s:21:\"featured-image-header\";i:9;s:15:\"featured-images\";i:10;s:15:\"flexible-header\";i:11;s:20:\"front-page-post-form\";i:12;s:19:\"full-width-template\";i:13;s:12:\"microformats\";i:14;s:12:\"post-formats\";i:15;s:20:\"rtl-language-support\";i:16;s:11:\"sticky-post\";i:17;s:13:\"theme-options\";i:18;s:17:\"threaded-comments\";i:19;s:17:\"translation-ready\";}s:7:\"Subject\";a:3:{i:0;s:7:\"holiday\";i:1;s:13:\"photoblogging\";i:2;s:8:\"seasonal\";}}", "yes");
INSERT INTO `wp_options` VALUES("211", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1414791926;s:7:\"checked\";a:4:{s:9:\"Newspaper\";s:5:\"3.9.2\";s:14:\"twentyfourteen\";s:3:\"1.2\";s:14:\"twentythirteen\";s:3:\"1.3\";s:12:\"twentytwelve\";s:3:\"1.5\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("213", "current_theme", "Newspaper", "yes");
INSERT INTO `wp_options` VALUES("214", "theme_mods_Newspaper", "a:2:{i:0;b:0;s:18:\"nav_menu_locations\";a:3:{s:8:\"top-menu\";i:9;s:11:\"footer-menu\";i:9;s:11:\"header-menu\";i:9;}}", "yes");
INSERT INTO `wp_options` VALUES("215", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("216", "td_008", "a:132:{s:12:\"firstInstall\";s:14:\"themeInstalled\";s:15:\"tds_logo_upload\";s:87:\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/logo-top.png\";s:13:\"logo_upload_r\";s:87:\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/logo-top.png\";s:11:\"td_ad_spots\";a:2:{s:15:\"demo sidebar ad\";a:5:{s:4:\"name\";s:15:\"demo sidebar ad\";s:1:\"p\";s:134:\"<a href=\"#\"><img src=\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/ad_sidebar/ads-300.jpg\" alt=\"\" /></a>\";s:2:\"tp\";s:134:\"<a href=\"#\"><img src=\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/ad_sidebar/ads-200.jpg\" alt=\"\" /></a>\";s:2:\"tl\";s:134:\"<a href=\"#\"><img src=\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/ad_sidebar/ads-250.jpg\" alt=\"\" /></a>\";s:1:\"m\";s:134:\"<a href=\"#\"><img src=\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/ad_sidebar/ads-300.jpg\" alt=\"\" /></a>\";}s:11:\"demo top ad\";a:5:{s:4:\"name\";s:11:\"demo top ad\";s:1:\"p\";s:0:\"\";s:2:\"tp\";s:130:\"<a href=\"#\"><img src=\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/ad_top/ads-468.jpg\" alt=\"\" /></a>\";s:2:\"tl\";s:130:\"<a href=\"#\"><img src=\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/ad_top/ads-468.jpg\" alt=\"\" /></a>\";s:1:\"m\";s:130:\"<a href=\"#\"><img src=\"http://blogsforsales.com/parenting/wp-content/themes/Newspaper/images/demo/ad_top/ads-728.jpg\" alt=\"\" /></a>\";}}s:15:\"tds_top_ad_spot\";s:22:\"Ad spot -- demo top ad\";s:20:\"tds_footer_copyright\";s:29:\"Copyright 2014 Parenting Blog\";s:16:\"category_options\";a:3:{i:5;a:1:{s:10:\"tdc_layout\";s:1:\"6\";}i:6;a:2:{s:10:\"tdc_layout\";s:1:\"6\";s:15:\"tdc_sidebar_pos\";s:10:\"no_sidebar\";}i:7;a:1:{s:10:\"tdc_layout\";s:1:\"4\";}}s:16:\"tds_header_style\";s:1:\"2\";s:22:\"tds_transparent_header\";s:0:\"\";s:20:\"tds_header_align_top\";s:0:\"\";s:12:\"tds_top_menu\";s:4:\"hide\";s:17:\"tds_data_top_menu\";s:0:\"\";s:20:\"tds_data_time_format\";s:0:\"\";s:19:\"tds_menu_icon_color\";s:0:\"\";s:13:\"tds_snap_menu\";s:0:\"\";s:17:\"tds_logo_upload_r\";s:0:\"\";s:18:\"tds_favicon_upload\";s:0:\"\";s:12:\"tds_logo_alt\";s:0:\"\";s:14:\"tds_logo_title\";s:0:\"\";s:15:\"tds_ios_icon_76\";s:0:\"\";s:16:\"tds_ios_icon_114\";s:0:\"\";s:16:\"tds_ios_icon_120\";s:0:\"\";s:16:\"tds_ios_icon_144\";s:0:\"\";s:16:\"tds_ios_icon_152\";s:0:\"\";s:23:\"tds_inline_ad_paragraph\";s:0:\"\";s:19:\"tds_inline_ad_align\";s:0:\"\";s:22:\"tds_footer_widget_cols\";s:0:\"\";s:22:\"tds_footer_copy_symbol\";s:0:\"\";s:15:\"tds_p_show_date\";s:0:\"\";s:16:\"tds_p_show_views\";s:0:\"\";s:19:\"tds_p_show_comments\";s:0:\"\";s:25:\"tds_p_enable_7_days_count\";s:0:\"\";s:13:\"tds_show_tags\";s:0:\"\";s:19:\"tds_show_author_box\";s:0:\"\";s:18:\"tds_show_next_prev\";s:0:\"\";s:29:\"tds_disable_comments_sidewide\";s:0:\"\";s:26:\"tds_disable_comments_pages\";s:0:\"\";s:20:\"tds_breadcrumbs_show\";s:0:\"\";s:25:\"tds_breadcrumbs_show_home\";s:0:\"\";s:27:\"tds_breadcrumbs_show_parent\";s:0:\"\";s:28:\"tds_breadcrumbs_show_article\";s:0:\"\";s:23:\"tds_show_featured_image\";s:0:\"\";s:30:\"tds_featured_image_placeholder\";s:0:\"\";s:31:\"tds_featured_image_view_setting\";s:0:\"\";s:23:\"tds_crop_features_image\";s:0:\"\";s:20:\"tds_similar_articles\";s:0:\"\";s:25:\"tds_similar_articles_type\";s:0:\"\";s:26:\"tds_similar_articles_count\";s:0:\"\";s:15:\"tds_social_show\";s:0:\"\";s:19:\"tds_like_tweet_show\";s:0:\"\";s:38:\"tds_more_articles_on_post_pages_enable\";s:0:\"\";s:49:\"tds_more_articles_on_post_pages_distance_from_top\";s:0:\"\";s:39:\"tds_more_articles_on_post_pages_display\";s:0:\"\";s:46:\"tds_more_articles_on_post_pages_display_module\";s:0:\"\";s:38:\"tds_more_articles_on_post_pages_number\";s:0:\"\";s:44:\"tds_more_articles_on_post_pages_time_to_wait\";s:0:\"\";s:19:\"tds_404_page_layout\";s:0:\"\";s:23:\"tds_archive_page_layout\";s:0:\"\";s:23:\"tds_archive_sidebar_pos\";s:0:\"\";s:19:\"tds_archive_sidebar\";s:0:\"\";s:26:\"tds_attachment_sidebar_pos\";s:0:\"\";s:22:\"tds_attachment_sidebar\";s:0:\"\";s:22:\"tds_author_page_layout\";s:0:\"\";s:22:\"tds_author_sidebar_pos\";s:0:\"\";s:18:\"tds_author_sidebar\";s:0:\"\";s:23:\"tds_bbpress_sidebar_pos\";s:0:\"\";s:19:\"tds_bbpress_sidebar\";s:0:\"\";s:20:\"tds_home_page_layout\";s:0:\"\";s:20:\"tds_home_sidebar_pos\";s:0:\"\";s:16:\"tds_home_sidebar\";s:0:\"\";s:24:\"tds_category_page_layout\";s:0:\"\";s:24:\"tds_category_sidebar_pos\";s:0:\"\";s:20:\"tds_category_sidebar\";s:0:\"\";s:20:\"tds_page_sidebar_pos\";s:0:\"\";s:16:\"tds_page_sidebar\";s:0:\"\";s:22:\"tds_search_page_layout\";s:0:\"\";s:22:\"tds_search_sidebar_pos\";s:0:\"\";s:18:\"tds_search_sidebar\";s:0:\"\";s:19:\"tds_tag_page_layout\";s:0:\"\";s:19:\"tds_tag_sidebar_pos\";s:0:\"\";s:15:\"tds_tag_sidebar\";s:0:\"\";s:19:\"tds_woo_sidebar_pos\";s:0:\"\";s:15:\"tds_woo_sidebar\";s:0:\"\";s:24:\"tds_timeline_sidebar_pos\";s:0:\"\";s:20:\"tds_timeline_sidebar\";s:0:\"\";s:25:\"tds_site_background_image\";s:0:\"\";s:26:\"tds_site_background_repeat\";s:0:\"\";s:30:\"tds_site_background_position_x\";s:0:\"\";s:30:\"tds_site_background_attachment\";s:0:\"\";s:22:\"tds_stretch_background\";s:0:\"\";s:17:\"tds_excerpts_type\";s:0:\"\";s:22:\"tds_wp_default_excerpt\";s:0:\"\";s:22:\"tds_mod2_title_excerpt\";s:0:\"\";s:24:\"tds_mod2_content_excerpt\";s:0:\"\";s:22:\"tds_mod3_title_excerpt\";s:0:\"\";s:22:\"tds_mod4_title_excerpt\";s:0:\"\";s:22:\"tds_mod5_title_excerpt\";s:0:\"\";s:24:\"tds_mod5_content_excerpt\";s:0:\"\";s:22:\"tds_mod6_title_excerpt\";s:0:\"\";s:24:\"tds_mod7_content_excerpt\";s:0:\"\";s:22:\"tds_mod8_title_excerpt\";s:0:\"\";s:24:\"tds_mod8_content_excerpt\";s:0:\"\";s:22:\"tds_mod9_title_excerpt\";s:0:\"\";s:24:\"tds_mod9_content_excerpt\";s:0:\"\";s:28:\"tds_mod_search_title_excerpt\";s:0:\"\";s:30:\"tds_mod_search_content_excerpt\";s:0:\"\";s:15:\"tds_theme_color\";s:0:\"\";s:25:\"tds_site_background_color\";s:0:\"\";s:18:\"tds_top_menu_color\";s:0:\"\";s:21:\"tds_header_wrap_color\";s:0:\"\";s:19:\"tds_logo_text_color\";s:0:\"\";s:14:\"tds_menu_color\";s:0:\"\";s:14:\"tds_link_color\";s:0:\"\";s:20:\"tds_link_hover_color\";s:0:\"\";s:16:\"tds_footer_color\";s:0:\"\";s:21:\"tds_footer_text_color\";s:0:\"\";s:23:\"tds_footer_bottom_color\";s:0:\"\";s:28:\"tds_footer_bottom_text_color\";s:0:\"\";s:14:\"tds_custom_css\";s:0:\"\";s:26:\"tds_responsive_css_desktop\";s:0:\"\";s:33:\"tds_responsive_css_ipad_landscape\";s:0:\"\";s:32:\"tds_responsive_css_ipad_portrait\";s:0:\"\";s:24:\"tds_responsive_css_phone\";s:0:\"\";s:12:\"td_analytics\";s:0:\"\";s:14:\"tds_responsive\";s:0:\"\";s:16:\"tds_mobile_swipe\";s:0:\"\";s:6:\"td_ads\";a:1:{s:6:\"header\";a:10:{s:7:\"ad_code\";s:172:\"<a href=\\\"http://.anton343.hop.clickbank.net./\\\"><img src=\\\"http://eliminateparentingstress.com/wp-content/uploads/2014/09/1.jpg\\\" alt=\\\"\\\" height=\\\"px\\\" width=\\\"px\\\"/></a>\";s:9:\"disable_m\";s:0:\"\";s:6:\"m_size\";s:0:\"\";s:10:\"disable_tl\";s:0:\"\";s:7:\"tl_size\";s:0:\"\";s:10:\"disable_tp\";s:0:\"\";s:7:\"tp_size\";s:0:\"\";s:9:\"disable_p\";s:0:\"\";s:6:\"p_size\";s:0:\"\";s:15:\"current_ad_type\";s:5:\"other\";}}s:23:\"td_translation_map_user\";a:94:{s:16:\"View all results\";s:0:\"\";s:10:\"No results\";s:0:\"\";s:4:\"Home\";s:0:\"\";s:10:\"Categories\";s:0:\"\";s:5:\"CLOSE\";s:0:\"\";s:4:\"Page\";s:0:\"\";s:3:\"All\";s:0:\"\";s:2:\"by\";s:0:\"\";s:9:\"Load more\";s:0:\"\";s:17:\"View all posts in\";s:0:\"\";s:16:\"Previous article\";s:0:\"\";s:12:\"Next article\";s:0:\"\";s:6:\"Author\";s:0:\"\";s:25:\"More articles from author\";s:0:\"\";s:16:\"SIMILAR ARTICLES\";s:0:\"\";s:6:\"source\";s:0:\"\";s:6:\"SOURCE\";s:0:\"\";s:3:\"via\";s:0:\"\";s:3:\"VIA\";s:0:\"\";s:8:\"Continue\";s:0:\"\";s:5:\"Name:\";s:0:\"\";s:6:\"Email:\";s:0:\"\";s:8:\"Website:\";s:0:\"\";s:8:\"Comment:\";s:0:\"\";s:13:\"Leave a Reply\";s:0:\"\";s:12:\"Post Comment\";s:0:\"\";s:12:\"Cancel reply\";s:0:\"\";s:5:\"Reply\";s:0:\"\";s:25:\"Log in to leave a comment\";s:0:\"\";s:11:\"NO COMMENTS\";s:0:\"\";s:9:\"1 COMMENT\";s:0:\"\";s:8:\"COMMENTS\";s:0:\"\";s:15:\"Review overview\";s:0:\"\";s:7:\"Summary\";s:0:\"\";s:26:\"404 Error - page not found\";s:0:\"\";s:16:\"OUR LATEST POSTS\";s:0:\"\";s:60:\"We_re sorry, but the page you are looking for doesn_t exist.\";s:0:\"\";s:17:\"You can go to the\";s:0:\"\";s:8:\"homepage\";s:0:\"\";s:7:\"Authors\";s:0:\"\";s:9:\"Posts by \";s:0:\"\";s:5:\"POSTS\";s:0:\"\";s:9:\"Posts in \";s:0:\"\";s:4:\"Tags\";s:0:\"\";s:4:\"TAGS\";s:0:\"\";s:17:\"Posts tagged with\";s:0:\"\";s:3:\"Tag\";s:0:\"\";s:16:\"Daily Archives: \";s:0:\"\";s:18:\"Monthly Archives: \";s:0:\"\";s:17:\"Yearly Archives: \";s:0:\"\";s:8:\"Archives\";s:0:\"\";s:15:\"LATEST ARTICLES\";s:0:\"\";s:14:\"search results\";s:0:\"\";s:6:\"Search\";s:0:\"\";s:62:\"If you_re not happy with the results, please do another search\";s:0:\"\";s:10:\"Contact us\";s:0:\"\";s:7:\"Contact\";s:0:\"\";s:36:\"Page %CURRENT_PAGE% of %TOTAL_PAGES%\";s:0:\"\";s:4:\"Next\";s:0:\"\";s:4:\"Prev\";s:0:\"\";s:26:\"No results for your search\";s:0:\"\";s:19:\"No posts to display\";s:0:\"\";s:6:\"LOG IN\";s:0:\"\";s:6:\"Log In\";s:0:\"\";s:8:\"REGISTER\";s:0:\"\";s:8:\"Register\";s:0:\"\";s:12:\"Send My Pass\";s:0:\"\";s:21:\"Forgot your password?\";s:0:\"\";s:14:\"Please wait...\";s:0:\"\";s:27:\"User or password incorrect!\";s:0:\"\";s:28:\"Email or username incorrect!\";s:0:\"\";s:16:\"Email incorrect!\";s:0:\"\";s:29:\"User or email already exists!\";s:0:\"\";s:75:\"Please check you email (index or spam folder), the password was sent there.\";s:0:\"\";s:24:\"Email address not found!\";s:0:\"\";s:41:\"Your password is reset, check your email.\";s:0:\"\";s:33:\"Welcome! Login in to your account\";s:0:\"\";s:23:\"Register for an account\";s:0:\"\";s:21:\"Recover your password\";s:0:\"\";s:13:\"your username\";s:0:\"\";s:13:\"your password\";s:0:\"\";s:10:\"your email\";s:0:\"\";s:35:\"A password will be e-mailed to you.\";s:0:\"\";s:6:\"Logout\";s:0:\"\";s:16:\"Search the forum\";s:0:\"\";s:6:\"Forums\";s:0:\"\";s:4:\"Like\";s:0:\"\";s:4:\"Fans\";s:0:\"\";s:6:\"Follow\";s:0:\"\";s:9:\"Followers\";s:0:\"\";s:9:\"Subscribe\";s:0:\"\";s:11:\"Subscribers\";s:0:\"\";s:12:\"MORE STORIES\";s:0:\"\";s:8:\"Timeline\";s:0:\"\";}s:8:\"td_fonts\";a:0:{}s:18:\"td_fonts_js_buffer\";s:0:\"\";s:19:\"td_fonts_css_buffer\";s:0:\"\";s:18:\"td_fonts_css_files\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("218", "wpcf7", "a:1:{s:7:\"version\";s:5:\"4.0.1\";}", "yes");
INSERT INTO `wp_options` VALUES("219", "revslider_checktables", "1", "yes");
INSERT INTO `wp_options` VALUES("220", "revslider-static-css", ".tp-caption a {\ncolor:#ff7302;\ntext-shadow:none;\n-webkit-transition:all 0.2s ease-out;\n-moz-transition:all 0.2s ease-out;\n-o-transition:all 0.2s ease-out;\n-ms-transition:all 0.2s ease-out;\n}\n\n.tp-caption a:hover {\ncolor:#ffa902;\n}", "yes");
INSERT INTO `wp_options` VALUES("221", "revslider-update-check-short", "1414788805", "yes");
INSERT INTO `wp_options` VALUES("222", "widget_td_ad_box_widget", "a:2:{i:70;a:1:{s:9:\"spot_name\";s:26:\"Ad spot -- demo sidebar ad\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("223", "widget_td_social_widget", "a:2:{i:71;a:8:{s:12:\"custom_title\";s:14:\"STAY CONNECTED\";s:8:\"facebook\";s:1:\"#\";s:7:\"youtube\";s:1:\"#\";s:6:\"github\";s:1:\"#\";s:6:\"google\";s:1:\"#\";s:11:\"googledrive\";s:1:\"#\";s:10:\"googlemaps\";s:1:\"#\";s:6:\"paypal\";s:1:\"#\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("224", "widget_td_block4_widget", "a:3:{i:72;a:3:{s:4:\"sort\";s:0:\"\";s:12:\"custom_title\";s:6:\"LATEST\";s:5:\"limit\";s:1:\"5\";}i:74;a:3:{s:4:\"sort\";s:8:\"featured\";s:12:\"custom_title\";s:8:\"FEATURED\";s:5:\"limit\";s:1:\"3\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("225", "widget_footer_logo_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("226", "widget_td_popular_categories_widget", "a:2:{i:75;a:2:{s:5:\"limit\";i:7;s:12:\"custom_title\";s:18:\"POPULAR CATEGORIES\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("230", "rewrite_rules", "a:68:{s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:39:\"index.php?&page_id=16&cpage=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:20:\"([^/]+)(/[0-9]+)?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("232", "revslider-valid-notice", "false", "yes");
INSERT INTO `wp_options` VALUES("235", "td_social_api_v3_last_val", "a:3:{s:8:\"facebook\";a:5:{s:5:\"count\";i:105838;s:8:\"ok_count\";i:105838;s:9:\"timestamp\";i:1414617862;s:7:\"expires\";i:10800;s:3:\"uid\";s:11:\"themeforest\";}s:7:\"twitter\";a:4:{s:9:\"timestamp\";i:1414617863;s:5:\"count\";i:0;s:3:\"uid\";s:6:\"envato\";s:7:\"expires\";i:10800;}s:7:\"youtube\";a:5:{s:5:\"count\";i:1147934;s:8:\"ok_count\";i:1147934;s:9:\"timestamp\";i:1414617863;s:7:\"expires\";i:10800;s:3:\"uid\";s:9:\"jonlajoie\";}}", "yes");
INSERT INTO `wp_options` VALUES("247", "revslider-latest-version", "4.6.3", "yes");
INSERT INTO `wp_options` VALUES("248", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("251", "wpb_js_composer_license_activation_notified", "yes", "yes");
INSERT INTO `wp_options` VALUES("252", "wpb_js_composer_templates_slashes_updated", "yes", "yes");
INSERT INTO `wp_options` VALUES("253", "wpb_js_templates", "a:1:{i:0;a:2:{s:4:\"name\";s:0:\"\";s:8:\"template\";s:0:\"\";}}", "yes");
INSERT INTO `wp_options` VALUES("258", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("260", "widget_calendar", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("287", "_transient_timeout_plugin_slugs", "1414878330", "no");
INSERT INTO `wp_options` VALUES("288", "_transient_plugin_slugs", "a:12:{i:0;s:19:\"akismet/akismet.php\";i:1;s:43:\"animated-gif-resize/animated-gif-resize.php\";i:2;s:36:\"contact-form-7/wp-contact-form-7.php\";i:3;s:25:\"duplicator/duplicator.php\";i:4;s:9:\"hello.php\";i:5;s:19:\"jetpack/jetpack.php\";i:6;s:40:\"mojo-marketplace-hg/mojo-marketplace.php\";i:7;s:33:\"privacy-policy/privacy-policy.php\";i:8;s:23:\"revslider/revslider.php\";i:9;s:39:\"td-social-counter/td-social-counter.php\";i:10;s:27:\"js_composer/js_composer.php\";i:11;s:27:\"wp-super-cache/wp-cache.php\";}", "no");
INSERT INTO `wp_options` VALUES("313", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1414832011", "no");
INSERT INTO `wp_options` VALUES("314", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:51:\"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"https://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Oct 2014 20:59:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"http://wordpress.org/?v=4.1-alpha-30122\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Watch WordCamp San Francisco Livestream\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2014/10/wcsf-livestream/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/news/2014/10/wcsf-livestream/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Oct 2014 20:18:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"WordCamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3341\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:381:\"WordCamp San Francisco is the official annual WordPress conference, gathering the community every year since 2006. This is the time when Matt Mullenweg addresses the community in his annual State of the Word presentation – a recap of  the year in WordPress and giving us a glimpse into its future. This year the speaker lineup is stellar. There will be talks by [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Nikolay Bachiyski\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1975:\"<p><a title=\"2014 edition\" href=\"http://2014.sf.wordcamp.org\">WordCamp San Francisco</a> is the official annual WordPress conference, gathering the community every year <a title=\"An old website for a WordPress long time ago\" href=\"http://2006.sf.wordcamp.org\">since 2006</a>. This is the time when Matt Mullenweg addresses the community in his annual <a href=\"http://wordpress.tv/?s=state+of+the+word\">State of the Word</a> presentation – a recap of  the year in WordPress and giving us a glimpse into its future.</p>\n<p>This year the speaker lineup is stellar. There will be talks by three of the lead WordPress developers: <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-andrew-nacin\">Andrew Nacin</a>, <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-helen-hou-sandi\">Helen Hou-Sandí</a>, and <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-mark-jaquith\">Mark Jaquith</a>. We’re also looking forward to speakers like <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-jenny-lawson\">Jenny Lawson</a>, also known as The Bloggess, and <a href=\"http://2014.sf.wordcamp.org/speaker/chris-lema/\">Chris Lema</a>. If you’re at all interested in the web, you will appreciate the appearance of <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-jeff-veen\">Jeff Veen</a> – one of the creators of Google Analytics and co-founder of Typekit.</p>\n<p>Even though San Francisco is far far away for most of you, you can still be part of the fun and watch all presentations in real-time via livestream:</p>\n<p><a href=\"http://2014.sf.wordcamp.org/tickets/\">Get a livestream ticket and watch all talks from WordCamp San Francisco live</a></p>\n<p>If you hurry, you can get one of the special livestream tickets, including a WordCamp San Francisco 2104 t-shirt. You can find all the technical details and start times <a href=\"http://2014.sf.wordcamp.org/live-stream/\">at the WordCamp San Francisco website</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/10/wcsf-livestream/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 4.0 “Benny”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wordpress.org/news/2014/09/benny/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://wordpress.org/news/2014/09/benny/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Sep 2014 17:05:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3296\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:370:\"Version 4.0 of WordPress, named “Benny” in honor of jazz clarinetist and bandleader Benny Goodman, is available for download or update in your WordPress dashboard. While 4.0 is just another number for us after 3.9 and before 4.1, we feel we&#8217;ve put a little extra polish into it. This release brings you a smoother writing and management experience [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:23544:\"<p>Version 4.0 of WordPress, named “Benny” in honor of jazz clarinetist and bandleader <a href=\"http://en.wikipedia.org/wiki/Benny_Goodman\">Benny Goodman</a>, is available <a href=\"https://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. While 4.0 is just another number for us after 3.9 and before 4.1, we feel we&#8217;ve put a little extra polish into it. This release brings you a smoother writing and management experience we think you&#8217;ll enjoy.</p>\n<div id=\"v-bUdzKMro-1\" class=\"video-player\"><embed id=\"v-bUdzKMro-1-video\" src=\"https://v0.wordpress.com/player.swf?v=1.03&amp;guid=bUdzKMro&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" title=\"Introducing WordPress 4.0 &quot;Benny&quot;\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<hr />\n<h2 style=\"text-align: center\">Manage your media with style</h2>\n<p><img class=\"alignnone size-full wp-image-3316\" src=\"https://wordpress.org/news/files/2014/09/media.jpg\" alt=\"Media Library\" width=\"1000\" height=\"586\" />Explore your uploads in a beautiful, endless grid. A new details preview makes viewing and editing any amount of media in sequence a snap.</p>\n<hr />\n<h2 style=\"text-align: center\">Working with embeds has never been easier</h2>\n<div style=\"width: 632px; \" class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<video class=\"wp-video-shortcode\" id=\"video-3296-1\" width=\"632\" height=\"445\" autoplay=\"true\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"//s.w.org/images/core/4.0/embed.mp4?_=1\" /><source type=\"video/webm\" src=\"//s.w.org/images/core/4.0/embed.webm?_=1\" /><source type=\"video/ogg\" src=\"//s.w.org/images/core/4.0/embed.ogv?_=1\" /><a href=\"//s.w.org/images/core/4.0/embed.mp4\">//s.w.org/images/core/4.0/embed.mp4</a></video></div>\n<p>Paste in a YouTube URL on a new line, and watch it magically become an embedded video. Now try it with a tweet. Oh yeah — embedding has become a visual experience. The editor shows a true preview of your embedded content, saving you time and giving you confidence.</p>\n<p>We’ve expanded the services supported by default, too — you can embed videos from CollegeHumor, playlists from YouTube, and talks from TED. <a href=\"https://codex.wordpress.org/Embeds\">Check out all of the embeds</a> that WordPress supports.</p>\n<hr />\n<h2 style=\"text-align: center\">Focus on your content</h2>\n<div style=\"width: 632px; \" class=\"wp-video\"><video class=\"wp-video-shortcode\" id=\"video-3296-2\" width=\"632\" height=\"356\" autoplay=\"true\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"//s.w.org/images/core/4.0/focus.mp4?_=2\" /><source type=\"video/webm\" src=\"//s.w.org/images/core/4.0/focus.webm?_=2\" /><source type=\"video/ogg\" src=\"//s.w.org/images/core/4.0/focus.ogv?_=2\" /><a href=\"//s.w.org/images/core/4.0/focus.mp4\">//s.w.org/images/core/4.0/focus.mp4</a></video></div>\n<p>Writing and editing is smoother and more immersive with an editor that expands to fit your content as you write, and keeps the formatting tools available at all times.</p>\n<hr />\n<h2 style=\"text-align: center\">Finding the right plugin</h2>\n<p><img class=\"aligncenter size-large wp-image-3309\" src=\"https://wordpress.org/news/files/2014/09/add-plugin1-1024x600.png\" alt=\"Add plugins\" width=\"692\" height=\"405\" /></p>\n<p>There are more than 30,000 free and open source plugins in the WordPress plugin directory. WordPress 4.0 makes it easier to find the right one for your needs, with new metrics, improved search, and a more visual browsing experience.</p>\n<hr />\n<h2 style=\"text-align: center\">The Ensemble</h2>\n<p>This release was led by <a href=\"http://helenhousandi.com\">Helen Hou-Sandí</a>, with the help of these fine individuals. There are 275 contributors with props in this release, a new high. Pull up some Benny Goodman on your music service of choice, as a bandleader or in one of his turns as a classical clarinetist, and check out some of their profiles:</p>\n<p><a href=\"https://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/viper007bond\">Alex Mills (Viper007Bond)</a>, <a href=\"https://profiles.wordpress.org/tellyworth\">Alex Shiels</a>, <a href=\"https://profiles.wordpress.org/alexanderrohmann\">Alexander Rohmann</a>, <a href=\"https://profiles.wordpress.org/aliso\">Alison Barrett</a>, <a href=\"https://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"https://profiles.wordpress.org/amit\">Amit Gupta</a>, <a href=\"https://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"https://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/andrezrv\">Andres Villarreal</a>, <a href=\"https://profiles.wordpress.org/zamfeer\">Andrew Mowe</a>, <a href=\"https://profiles.wordpress.org/sumobi\">Andrew Munro (sumobi)</a>, <a href=\"https://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"https://profiles.wordpress.org/ankit-k-gupta\">Ankit K Gupta</a>, <a href=\"https://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"https://profiles.wordpress.org/arnee\">arnee</a>, <a href=\"https://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"https://profiles.wordpress.org/filosofo\">Austin Matzko</a>, <a href=\"https://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"https://profiles.wordpress.org/kau-boy\">Bernhard Kau</a>, <a href=\"https://profiles.wordpress.org/boonebgorges\">Boone Gorges</a>, <a href=\"https://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"https://profiles.wordpress.org/bramd\">Bram Duvigneau</a>, <a href=\"https://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/brianlayman\">Brian Layman</a>, <a href=\"https://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"https://profiles.wordpress.org/camdensegal\">Camden Segal</a>, <a href=\"https://profiles.wordpress.org/sixhours\">Caroline Moore</a>, <a href=\"https://profiles.wordpress.org/mackensen\">Charles Fulton</a>, <a href=\"https://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"https://profiles.wordpress.org/chrico\">ChriCo</a>, <a href=\"https://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"https://profiles.wordpress.org/chrisl27\">chrisl27</a>, <a href=\"https://profiles.wordpress.org/caxelsson\">Christian Axelsson</a>, <a href=\"https://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"https://profiles.wordpress.org/boda1982\">Christopher Spires</a>, <a href=\"https://profiles.wordpress.org/clifgriffin\">Clifton Griffin</a>, <a href=\"https://profiles.wordpress.org/jupiterwise\">Corey McKrill</a>, <a href=\"https://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"https://profiles.wordpress.org/extendwings\">Daisuke Takahashi</a>, <a href=\"https://profiles.wordpress.org/ghost1227\">Dan Griffiths</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"https://profiles.wordpress.org/danielhuesken\">Daniel Husken</a>, <a href=\"https://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"https://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"https://profiles.wordpress.org/dkotter\">Darin Kotter</a>, <a href=\"https://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"https://profiles.wordpress.org/dllh\">Daryl L. L. Houston (dllh)</a>, <a href=\"https://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"https://profiles.wordpress.org/dlh\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dnaber-de\">David Naber</a>, <a href=\"https://profiles.wordpress.org/davidthemachine\">DavidTheMachine</a>, <a href=\"https://profiles.wordpress.org/debaat\">DeBAAT</a>, <a href=\"https://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/donncha\">Donncha O Caoimh</a>, <a href=\"https://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/dustyn\">Dustyn Doyle</a>, <a href=\"https://profiles.wordpress.org/eddiemoya\">Eddie Moya</a>, <a href=\"https://profiles.wordpress.org/oso96_2000\">Eduardo Reveles</a>, <a href=\"https://profiles.wordpress.org/edwin-at-studiojoyocom\">Edwin Siebel</a>, <a href=\"https://profiles.wordpress.org/ehg\">ehg</a>, <a href=\"https://profiles.wordpress.org/tmeister\">Enrique Chavez</a>, <a href=\"https://profiles.wordpress.org/erayalakese\">erayalakese</a>, <a href=\"https://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"https://profiles.wordpress.org/ebinnion\">Eric Binnion</a>, <a href=\"https://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"https://profiles.wordpress.org/ejdanderson\">Evan Anderson</a>, <a href=\"https://profiles.wordpress.org/eherman24\">Evan Herman</a>, <a href=\"https://profiles.wordpress.org/fab1en\">Fab1en</a>, <a href=\"https://profiles.wordpress.org/fahmiadib\">Fahmi Adib</a>, <a href=\"https://profiles.wordpress.org/feedmeastraycat\">feedmeastraycat</a>, <a href=\"https://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"https://profiles.wordpress.org/garhdez\">garhdez</a>, <a href=\"https://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"https://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"https://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/garza\">garza</a>, <a href=\"https://profiles.wordpress.org/gauravmittal1995\">gauravmittal1995</a>, <a href=\"https://profiles.wordpress.org/gavra\">Gavrisimo</a>, <a href=\"https://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"https://profiles.wordpress.org/vancoder\">Grant Mangham</a>, <a href=\"https://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"https://profiles.wordpress.org/bordoni\">Gustavo Bordoni</a>, <a href=\"https://profiles.wordpress.org/harrym\">harrym</a>, <a href=\"https://profiles.wordpress.org/hebbet\">hebbet</a>, <a href=\"https://profiles.wordpress.org/hinnerk\">Hinnerk Altenburg</a>, <a href=\"https://profiles.wordpress.org/hlashbrooke\">Hugh Lashbrooke</a>, <a href=\"https://profiles.wordpress.org/iljoja\">iljoja</a>, <a href=\"https://profiles.wordpress.org/imath\">imath</a>, <a href=\"https://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/issuu\">issuu</a>, <a href=\"https://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"https://profiles.wordpress.org/jacklenox\">Jack Lenox</a>, <a href=\"https://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"https://profiles.wordpress.org/jacobdubail\">Jacob Dubail</a>, <a href=\"https://profiles.wordpress.org/janhenkg\">JanHenkG</a>, <a href=\"https://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/jwenerd\">Jared Wenerd</a>, <a href=\"https://profiles.wordpress.org/jaza613\">Jaza613</a>, <a href=\"https://profiles.wordpress.org/jeffstieler\">Jeff Stieler</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"https://profiles.wordpress.org/slimndap\">Jeroen Schmit</a>, <a href=\"https://profiles.wordpress.org/jerrysarcastic\">Jerry Bates (jerrysarcastic)</a>, <a href=\"https://profiles.wordpress.org/jesin\">Jesin A</a>, <a href=\"https://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"https://profiles.wordpress.org/engelen\">Jesper van Engelen</a>, <a href=\"https://profiles.wordpress.org/jesper800\">Jesper van Engelen</a>, <a href=\"https://profiles.wordpress.org/jessepollak\">Jesse Pollak</a>, <a href=\"https://profiles.wordpress.org/jgadbois\">jgadbois</a>, <a href=\"https://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"https://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/jkudish\">Joey Kudish</a>, <a href=\"https://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/johnzanussi\">John Zanussi</a>, <a href=\"https://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"https://profiles.wordpress.org/jonnyauk\">jonnyauk</a>, <a href=\"https://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"https://profiles.wordpress.org/softmodeling\">Jordi Cabot</a>, <a href=\"https://profiles.wordpress.org/jjeaton\">Josh Eaton</a>, <a href=\"https://profiles.wordpress.org/tai\">JOTAKI Taisuke</a>, <a href=\"https://profiles.wordpress.org/juliobox\">Julio Potier</a>, <a href=\"https://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"https://profiles.wordpress.org/jtsternberg\">Justin Sternberg</a>, <a href=\"https://profiles.wordpress.org/greenshady\">Justin Tadlock</a>, <a href=\"https://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"https://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"https://profiles.wordpress.org/ixkaito\">Kaito</a>, <a href=\"https://profiles.wordpress.org/kapeels\">kapeels</a>, <a href=\"https://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/kevinlangleyjr\">Kevin Langley</a>, <a href=\"https://profiles.wordpress.org/kworthington\">Kevin Worthington</a>, <a href=\"https://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"https://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"https://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"https://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"https://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"https://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/krogsgard\">krogsgard</a>, <a href=\"https://profiles.wordpress.org/kurtpayne\">Kurt Payne</a>, <a href=\"https://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"https://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"https://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"https://profiles.wordpress.org/layotte\">Lew Ayotte</a>, <a href=\"https://profiles.wordpress.org/lritter\">lritter</a>, <a href=\"https://profiles.wordpress.org/lukecarbis\">Luke Carbis</a>, <a href=\"https://profiles.wordpress.org/lgedeon\">Luke Gedeon</a>, <a href=\"https://profiles.wordpress.org/m_i_n\">m_i_n</a>, <a href=\"https://profiles.wordpress.org/funkatronic\">Manny Fleurmond</a>, <a href=\"https://profiles.wordpress.org/targz-1\">Manuel Schmalstieg</a>, <a href=\"https://profiles.wordpress.org/clorith\">Marius (Clorith)</a>, <a href=\"https://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"https://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"https://profiles.wordpress.org/sivel\">Matt Martz</a>, <a href=\"https://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"https://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"https://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"https://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"https://profiles.wordpress.org/mattheweppelsheimer\">Matthew Eppelsheimer</a>, <a href=\"https://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"https://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/meekyhwang\">meekyhwang</a>, <a href=\"https://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"https://profiles.wordpress.org/mdawaffe\">Michael Adams (mdawaffe)</a>, <a href=\"https://profiles.wordpress.org/michalzuber\">michalzuber</a>, <a href=\"https://profiles.wordpress.org/midxcat\">midxcat</a>, <a href=\"https://profiles.wordpress.org/mauteri\">Mike Auteri</a>, <a href=\"https://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"https://profiles.wordpress.org/mikejolley\">Mike Jolley</a>, <a href=\"https://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"https://profiles.wordpress.org/mikemanger\">Mike Manger</a>, <a href=\"https://profiles.wordpress.org/mnelson4\">Mike Nelson</a>, <a href=\"https://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/mikeyarce\">Mikey Arce</a>, <a href=\"https://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"https://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"https://profiles.wordpress.org/usermrpapa\">Mr Papa</a>, <a href=\"https://profiles.wordpress.org/mrmist\">mrmist</a>, <a href=\"https://profiles.wordpress.org/m_uysl\">Mustafa Uysal</a>, <a href=\"https://profiles.wordpress.org/muvimotv\">MuViMoTV</a>, <a href=\"https://profiles.wordpress.org/nabil_kadimi\">nabil_kadimi</a>, <a href=\"https://profiles.wordpress.org/namibia\">Namibia</a>, <a href=\"https://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"https://profiles.wordpress.org/nd987\">nd987</a>, <a href=\"https://profiles.wordpress.org/neil_pie\">Neil Pie</a>, <a href=\"https://profiles.wordpress.org/niallkennedy\">Niall Kennedy</a>, <a href=\"https://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"https://profiles.wordpress.org/schoenwaldnils\">Nils Schonwald</a>, <a href=\"https://profiles.wordpress.org/ninos-ego\">Ninos</a>, <a href=\"https://profiles.wordpress.org/nvwd\">Nowell VanHoesen</a>, <a href=\"https://profiles.wordpress.org/compute\">Patrick Hesselberg</a>, <a href=\"https://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/pdclark\">Paul Clark</a>, <a href=\"https://profiles.wordpress.org/paulschreiber\">Paul Schreiber</a>, <a href=\"https://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"https://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"https://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"https://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"https://profiles.wordpress.org/philipjohn\">Philip John</a>, <a href=\"https://profiles.wordpress.org/senlin\">Piet Bos</a>, <a href=\"https://profiles.wordpress.org/psoluch\">Piotr Soluch</a>, <a href=\"https://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"https://profiles.wordpress.org/purzlbaum\">purzlbaum</a>, <a href=\"https://profiles.wordpress.org/rachelbaker\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/rclations\">RC Lations</a>, <a href=\"https://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"https://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"https://profiles.wordpress.org/rob1n\">rob1n</a>, <a href=\"https://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"https://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"https://profiles.wordpress.org/harmr\">RobertHarm</a>, <a href=\"https://profiles.wordpress.org/rohan013\">Rohan Rawat</a>, <a href=\"https://profiles.wordpress.org/rhurling\">Rouven Hurling</a>, <a href=\"https://profiles.wordpress.org/ruudjoyo\">Ruud Laan</a>, <a href=\"https://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"https://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/sammybeats\">Sam Brodie</a>, <a href=\"https://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"https://profiles.wordpress.org/sathishn\">Sathish Nagarajan</a>, <a href=\"https://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/greglone\">ScreenfeedFr</a>, <a href=\"https://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"https://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"https://profiles.wordpress.org/nessworthy\">Sean Nessworthy</a>, <a href=\"https://profiles.wordpress.org/sergejmueller\">Sergej Muller</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/shanebp\">shanebp</a>, <a href=\"https://profiles.wordpress.org/sharonaustin\">Sharon Austin</a>, <a href=\"https://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"https://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"https://profiles.wordpress.org/simonp303\">simonp303</a>, <a href=\"https://profiles.wordpress.org/slobodanmanic\">Slobodan Manic</a>, <a href=\"https://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"https://profiles.wordpress.org/sphoid\">sphoid</a>, <a href=\"https://profiles.wordpress.org/stephdau\">Stephane Daury</a>, <a href=\"https://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/stompweb\">Steven Jones</a>, <a href=\"https://profiles.wordpress.org/strangerstudios\">strangerstudios</a>, <a href=\"https://profiles.wordpress.org/5um17\">Sumit Singh</a>, <a href=\"https://profiles.wordpress.org/t4k1s\">t4k1s</a>, <a href=\"https://profiles.wordpress.org/iamtakashi\">Takashi Irie</a>, <a href=\"https://profiles.wordpress.org/taylorde\">Taylor Dewey</a>, <a href=\"https://profiles.wordpress.org/thomasvanderbeek\">Thomas van der Beek</a>, <a href=\"https://profiles.wordpress.org/tillkruess\">Till</a>, <a href=\"https://profiles.wordpress.org/codenameeli\">Tim \'Eli\' Dalbey</a>, <a href=\"https://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"https://profiles.wordpress.org/tjnowell\">Tom J Nowell</a>, <a href=\"https://profiles.wordpress.org/willmot\">Tom Willmot</a>, <a href=\"https://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"https://profiles.wordpress.org/torresga\">torresga</a>, <a href=\"https://profiles.wordpress.org/liljimmi\">Tracy Levesque</a>, <a href=\"https://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"https://profiles.wordpress.org/treyhunner\">treyhunner</a>, <a href=\"https://profiles.wordpress.org/umeshsingla\">Umesh Kumar</a>, <a href=\"https://profiles.wordpress.org/vinod-dalvi\">Vinod Dalvi</a>, <a href=\"https://profiles.wordpress.org/vlajos\">vlajos</a>, <a href=\"https://profiles.wordpress.org/voldemortensen\">voldemortensen</a>, <a href=\"https://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/winterdev\">winterDev</a>, <a href=\"https://profiles.wordpress.org/wojtekszkutnik\">Wojtek Szkutnik</a>, <a href=\"https://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"https://profiles.wordpress.org/katzwebdesign\">Zack Katz</a>, <a href=\"https://profiles.wordpress.org/tollmanz\">Zack Tollman</a>, and <a href=\"https://profiles.wordpress.org/zoerooney\">Zoe Rooney</a>. Also thanks to <a href=\"http://michaelpick.wordpress.com/\">Michael Pick</a> for producing the release video, and Helen with <a href=\"http://adriansandi.com\">Adrián Sandí</a> for the music.</p>\n<p>If you want to follow along or help out, check out <a href=\"https://make.wordpress.org/\">Make WordPress</a> and our <a href=\"https://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress. See you soon for version 4.1!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wordpress.org/news/2014/09/benny/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 4.0 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2014/08/wordpress-4-0-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"https://wordpress.org/news/2014/08/wordpress-4-0-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Aug 2014 12:20:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3287\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:321:\"The first release candidate for WordPress 4.0 is now available! In RC 1, we’ve made refinements to what we&#8217;ve been working on for this release. Check out the Beta 1 announcement post for more details on those features. We hope to ship WordPress 4.0 next week, but we need your help to get there. If you [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2134:\"<p>The first release candidate for WordPress 4.0 is now available!</p>\n<p>In RC 1, we’ve made refinements to what we&#8217;ve been working on for this release. Check out the <a href=\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/\">Beta 1 announcement post</a> for more details on those features. We hope to ship WordPress 4.0 <em>next week</em>, but we need your help to get there. If you haven’t tested 4.0 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"https://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>To test WordPress 4.0 RC1, try the <a href=\"https://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.0-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 4.0, visit the awesome About screen in your dashboard (<strong><img src=\"https://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar).</p>\n<p><strong>Developers,</strong> please test your plugins and themes against WordPress 4.0 and update your plugin&#8217;s <em>Tested up to</em> version in the readme to 4.0 before next week. If you find compatibility problems, please be sure to post any issues to the support forums so we can figure those out before the final release. You also may want to <a href=\"https://make.wordpress.org/core/2014/08/21/introducing-plugin-icons-in-the-plugin-installer/\">give your plugin an icon</a>, which we launched last week and will appear in the dashboard along with banners.</p>\n<p><em>It is almost time</em><br />\n<em> For the 4.0 release</em><br />\n<em> And its awesomeness</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://wordpress.org/news/2014/08/wordpress-4-0-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.0 Beta 4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/08/wordpress-4-0-beta-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://wordpress.org/news/2014/08/wordpress-4-0-beta-4/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 15 Aug 2014 05:06:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3280\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:353:\"The fourth and likely final beta for WordPress 4.0 is now available. We&#8217;ve made more than 250 changes in the past month, including: Further improvements to the editor scrolling experience, especially when it comes to the second column of boxes. Better handling of small screens in the media library modals. A separate bulk selection mode [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2003:\"<p>The fourth and likely final beta for WordPress 4.0 is now available. We&#8217;ve made <a href=\"https://core.trac.wordpress.org/log?rev=29496&amp;stop_rev=29229&amp;limit=300\">more than 250 changes</a> in the past month, including:</p>\n<ul>\n<li>Further improvements to the editor scrolling experience, especially when it comes to the second column of boxes.</li>\n<li>Better handling of small screens in the media library modals.</li>\n<li>A separate bulk selection mode for the media library grid view.</li>\n<li>Improvements to the installation language selector.</li>\n<li>Visual tweaks to plugin details and customizer panels.</li>\n</ul>\n<p><strong>We need your help</strong>. We’re still aiming for a release this month, which means the next week will be critical for identifying and squashing bugs. If you’re just joining us, please see <a href=\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/\">the Beta 1 announcement post</a> for what to look out for.</p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums, where friendly moderators are standing by. <b>Plugin developers</b><strong>,</strong> if you haven’t tested WordPress 4.0 yet, now is the time — and be sure to update the “tested up to” version for your plugins so they’re listed as compatible with 4.0.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.0, try the <a href=\"https://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.0-beta4.zip\">download the beta here</a> (zip).</p>\n<p><em>We are working hard</em><br />\n<em>To finish up 4.0<br />\n</em><em>Will you help us too?</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/news/2014/08/wordpress-4-0-beta-4/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 3.9.2 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2014/08/wordpress-3-9-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/news/2014/08/wordpress-3-9-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 06 Aug 2014 19:04:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3269\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:377:\"WordPress 3.9.2 is now available as a security release for all previous versions. We strongly encourage you to update your sites immediately. This release fixes a possible denial of service issue in PHP&#8217;s XML processing, reported by Nir Goldshlager of the Salesforce.com Product Security Team. It  was fixed by Michael Adams and Andrew Nacin of the WordPress [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2353:\"<p>WordPress 3.9.2 is now available as a security release for all previous versions. We strongly encourage you to update your sites immediately.</p>\n<p>This release fixes a possible denial of service issue in PHP&#8217;s XML processing, reported by <a href=\"https://twitter.com/nirgoldshlager\">Nir Goldshlager</a> of the Salesforce.com Product Security Team. It  was fixed by Michael Adams and Andrew Nacin of the WordPress security team and David Rothstein of the <a href=\"https://www.drupal.org/SA-CORE-2014-004\">Drupal security team</a>. This is the first time our two projects have coordinated joint security releases.</p>\n<p>WordPress 3.9.2 also contains other security changes:</p>\n<ul>\n<li>Fixes a possible but unlikely code execution when processing widgets (WordPress is not affected by default), discovered by <a href=\"http://www.buayacorp.com/\">Alex Concha</a> of the WordPress security team.</li>\n<li>Prevents information disclosure via XML entity attacks in the external GetID3 library, reported by <a href=\"http://onsec.ru/en/\">Ivan Novikov</a> of ONSec.</li>\n<li>Adds protections against brute attacks against CSRF tokens, reported by <a href=\"http://systemoverlord.com/\">David Tomaschik</a> of the Google Security Team.</li>\n<li>Contains some additional security hardening, like preventing cross-site scripting that could be triggered only by administrators.</li>\n</ul>\n<p>We appreciated responsible disclosure of these issues directly to our security team. For more information, see the <a href=\"https://codex.wordpress.org/Version_3.9.2\">release notes</a> or consult the <a href=\"https://core.trac.wordpress.org/log/branches/3.9?stop_rev=29383&amp;rev=29411\">list of changes</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 3.9.2</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now&#8221;.</p>\n<p>Sites that support automatic background updates will be updated to WordPress 3.9.2 within 12 hours. (If you are still on WordPress 3.8.3 or 3.7.3, you will also be updated to 3.8.4 or 3.7.4. We don&#8217;t support older versions, so please update to 3.9.2 for the latest and greatest.)</p>\n<p>Already testing WordPress 4.0? The third beta is <a href=\"https://wordpress.org/wordpress-4.0-beta3.zip\">now available</a> (zip) and it contains these security fixes.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/08/wordpress-3-9-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.0 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Jul 2014 21:15:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3261\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:374:\"WordPress 4.0 Beta 2 is now available for download and testing. This is software still in development, so we don’t recommend that you run it on a production site. To get the beta, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can download the beta here (zip). For more of what’s new in version 4.0, check out [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1745:\"<p>WordPress 4.0 Beta 2 is now available for download and testing. This is software still in development, so we don’t recommend that you run it on a production site. To get the beta, try the <a href=\"https://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.0-beta2.zip\">download the beta here</a> (zip).</p>\n<p>For more of what’s new in version 4.0, <a href=\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/\">check out the Beta 1 blog post</a>. Some of the changes in Beta 2 include:</p>\n<ul>\n<li>Further refinements for the the plugin installation and media library experiences.</li>\n<li>Updated TinyMCE, which now includes better indentation for lists and the restoration of the color picker.</li>\n<li>Cookies are now tied to a session internally, so if you have trouble logging in, <a href=\"https://core.trac.wordpress.org/ticket/20276\">#20276</a> may be the culprit.</li>\n<li>Various bug fixes (there were <a href=\"https://core.trac.wordpress.org/log?rev=29228&amp;stop_rev=29060&amp;limit=200\">nearly 170 changes</a> since last week).</li>\n</ul>\n<p>If you think you’ve found a bug, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a bug report, <a href=\"https://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=4.0\">everything we’ve fixed</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.0 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 10 Jul 2014 10:17:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3248\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"WordPress 4.0 Beta 1 is now available! This software is still in development, so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.0, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4031:\"<p>WordPress 4.0 Beta 1 is now available!</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.0, try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.0-beta1.zip\">download the beta here</a> (zip).</p>\n<p>4.0 is due out next month, but to get there, we need your help testing what we&#8217;ve been working on:</p>\n<ul>\n<li><strong>Previews of <a href=\"https://codex.wordpress.org/Embeds\">embedding via URLs</a></strong> in the visual editor and the &#8220;Insert from URL&#8221; tab in the media modal. Try pasting a URL (such as a <a href=\"http://wordpress.tv/\">WordPress.tv</a> or YouTube video) onto its own line in the visual editor. (<a href=\"https://core.trac.wordpress.org/ticket/28195\">#28195</a>, <a href=\"https://core.trac.wordpress.org/ticket/15490\">#15490</a>)</li>\n<li>The <strong>Media Library</strong> now has a &#8220;grid&#8221; view in addition to the existing list view. Clicking on an item takes you into a modal where you can see a larger preview and edit information about that attachment, and you can navigate between items right from the modal without closing it. (<a href=\"https://core.trac.wordpress.org/ticket/24716\">#24716</a>)</li>\n<li>We&#8217;re freshening up the <strong>plugin install experience</strong>. You&#8217;ll see some early visual changes as well as more information when searching for plugins and viewing details. (<a href=\"https://core.trac.wordpress.org/ticket/28785\">#28785</a>, <a href=\"https://core.trac.wordpress.org/ticket/27440\">#27440</a>)</li>\n<li><strong>Selecting a language</strong> when you run the installation process. (<a href=\"https://core.trac.wordpress.org/ticket/28577\">#28577</a>)</li>\n<li>The <strong>editor</strong> intelligently resizes and its top and bottom bars pin when needed. Browsers don&#8217;t like to agree on where to put things like cursors, so if you find a bug here, please also let us know your browser and operating system. (<a href=\"https://core.trac.wordpress.org/ticket/28328\">#28328</a>)</li>\n<li>We&#8217;ve made some improvements to how your keyboard and cursor interact with <strong>TinyMCE views</strong> such as the gallery preview. Much like the editor resizing and scrolling improvements, knowing about your setup is particularly important for bug reports here. (<a href=\"https://core.trac.wordpress.org/ticket/28595\">#28595</a>)</li>\n<li><strong>Widgets in the Customizer</strong> are now loaded in a separate panel. (<a href=\"https://core.trac.wordpress.org/ticket/27406\">#27406</a>)</li>\n<li>We&#8217;ve also made some changes to some <strong>formatting</strong> functions, so if you see quotes curling in the wrong direction, please file a bug report.</li>\n</ul>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=4.0\">everything we’ve fixed</a> so far.</p>\n<p><strong>Developers:</strong> Never fear, we haven&#8217;t forgotten you. There&#8217;s plenty for you, too &#8211; more on that in upcoming posts. In the meantime, check out the <a href=\"https://make.wordpress.org/core/2014/07/08/customizer-improvements-in-4-0/#customizer-panels\">API for panels in the Customizer</a>.</p>\n<p>Happy testing!</p>\n<p><em>Plugins, editor</em><br />\n<em>Media, things in between</em><br />\n<em>Please help look for bugs</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.9.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2014/05/wordpress-3-9-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/news/2014/05/wordpress-3-9-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 May 2014 18:40:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3241\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:385:\"After three weeks and more than 9 million downloads of WordPress 3.9, we&#8217;re pleased to announce that WordPress 3.9.1 is now available. This maintenance release fixes 34 bugs in 3.9, including numerous fixes for multisite networks, customizing widgets while previewing themes, and the updated visual editor. We&#8217;ve also made some improvements to the new audio/video [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3106:\"<p>After three weeks and more than 9 million downloads of <a title=\"WordPress 3.9 “Smith”\" href=\"https://wordpress.org/news/2014/04/smith/\">WordPress 3.9</a>, we&#8217;re pleased to announce that WordPress 3.9.1 is now available.</p>\n<p>This maintenance release fixes 34 bugs in 3.9, including numerous fixes for multisite networks, customizing widgets while previewing themes, and the updated visual editor. We&#8217;ve also made some improvements to the new audio/video playlists feature and made some adjustments to improve performance. For a full list of changes, consult the <a href=\"https://core.trac.wordpress.org/query?milestone=3.9.1\">list of tickets</a> and the <a href=\"https://core.trac.wordpress.org/log/branches/3.9?rev=28353&amp;stop_rev=28154\">changelog</a>.</p>\n<p>If you are one of the millions already running WordPress 3.9, we&#8217;ve started rolling out automatic background updates for 3.9.1. For sites <a href=\"https://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 3.9.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Thanks to all of these fine individuals for contributing to 3.9.1: <a href=\"https://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"https://profiles.wordpress.org/ehg\">Chris Blower</a>, <a href=\"https://profiles.wordpress.org/jupiterwise\">Corey McKrill</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"https://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/feedmeastraycat\">feedmeastraycat</a>, <a href=\"https://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"https://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"https://profiles.wordpress.org/imath\">imath</a>, <a href=\"https://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"https://profiles.wordpress.org/m_i_n\">m_i_n</a>, <a href=\"https://profiles.wordpress.org/clorith\">Marius Jensen</a>, <a href=\"https://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/dimadin\">Milan Dinić</a>, <a href=\"https://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/SergeyBiryukov\">Sergey Biryukov</a>, and <a href=\"https://profiles.wordpress.org/westonruter\">Weston Ruter</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/05/wordpress-3-9-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.9 “Smith”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wordpress.org/news/2014/04/smith/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://wordpress.org/news/2014/04/smith/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 18:33:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3154\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:411:\"Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist Jimmy Smith, is available for download or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love. A smoother media editing experience Improved visual editing The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:23556:\"<p>Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist <a href=\"http://en.wikipedia.org/wiki/Jimmy_Smith_(musician)\">Jimmy Smith</a>, is available <a href=\"https://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love.</p>\n<div id=\"v-sAiXhCfV-1\" class=\"video-player\"><embed id=\"v-sAiXhCfV-1-video\" src=\"https://v0.wordpress.com/player.swf?v=1.03&amp;guid=sAiXhCfV&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<h2 class=\"about-headline-callout\" style=\"text-align: center\">A smoother media editing experience</h2>\n<div>\n<p><img class=\"alignright wp-image-3168\" src=\"//wordpress.org/news/files/2014/04/editor1-300x233.jpg\" alt=\"editor\" width=\"228\" height=\"177\" /></p>\n<h3>Improved visual editing</h3>\n<p>The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the visual editor from your word processor without wasting time to clean up messy styling. (Yeah, we’re talking about you, Microsoft Word.)</p>\n</div>\n<div style=\"clear: both\"></div>\n<div>\n<p><img class=\"alignright wp-image-3170\" src=\"//wordpress.org/news/files/2014/04/image1-300x233.jpg\" alt=\"image\" width=\"228\" height=\"178\" /></p>\n<h3>Edit images easily</h3>\n<p>With quicker access to crop and rotation tools, it’s now much easier to edit your images while editing posts. You can also scale images directly in the editor to find just the right fit.</p>\n</div>\n<div style=\"clear: both\"></div>\n<div>\n<p><img class=\"alignright wp-image-3187\" src=\"//wordpress.org/news/files/2014/04/dragdrop1-300x233.jpg\" alt=\"dragdrop\" width=\"228\" height=\"178\" /></p>\n<h3>Drag and drop your images</h3>\n<p>Uploading your images is easier than ever. Just grab them from your desktop and drop them in the editor.</p>\n</div>\n<div style=\"clear: both\"></div>\n<hr />\n<h2 style=\"text-align: center\">Gallery previews</h2>\n<p><img class=\"aligncenter size-full wp-image-3169\" src=\"//wordpress.org/news/files/2014/04/gallery1.jpg\" alt=\"gallery\" width=\"980\" height=\"550\" /></p>\n<p>Galleries display a beautiful grid of images right in the editor, just like they do in your published post.</p>\n<hr />\n<h2 style=\"text-align: center\">Do more with audio and video</h2>\n\n<a href=\'https://wordpress.org/news/files/2014/04/AintMisbehavin.mp3\'>Ain\'t Misbehavin\'</a>\n<a href=\'https://wordpress.org/news/files/2014/04/DavenportBlues.mp3\'>Davenport Blues</a>\n<a href=\'https://wordpress.org/news/files/2014/04/JellyRollMorton-BuddyBoldensBlues.mp3\'>Buddy Bolden\'s Blues</a>\n<a href=\'https://wordpress.org/news/files/2014/04/Johnny_Hodges_Orchestra-Squaty_Roo-1941.mp3\'>Squaty Roo</a>\n<a href=\'https://wordpress.org/news/files/2014/04/Louisiana_Five-Dixie_Blues-1919.mp3\'>Dixie Blues</a>\n<a href=\'https://wordpress.org/news/files/2014/04/WolverineBlues.mp3\'>Wolverine Blues</a>\n\n<p>Images have galleries; now we’ve added simple audio and video playlists, so you can showcase your music and clips.</p>\n<hr />\n<h2 style=\"text-align: center\">Live widget and header previews</h2>\n<div style=\"width: 692px; \" class=\"wp-video\"><video class=\"wp-video-shortcode\" id=\"video-3154-3\" width=\"692\" height=\"448\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"//wordpress.org/news/files/2014/04/widgets.mp4?_=3\" /><a href=\"//wordpress.org/news/files/2014/04/widgets.mp4\">//wordpress.org/news/files/2014/04/widgets.mp4</a></video></div>\n<p>Add, edit, and rearrange your site’s widgets right in the theme customizer. No “save and surprise” — preview your changes live and only save them when you’re ready.</p>\n<p>The improved header image tool also lets you upload, crop, and manage headers while customizing your theme.</p>\n<hr />\n<h2 style=\"text-align: center\">Stunning new theme browser</h2>\n<p><img class=\"aligncenter size-full wp-image-3172\" src=\"//wordpress.org/news/files/2014/04/theme1.jpg\" alt=\"theme\" width=\"1003\" height=\"558\" /><br />\nLooking for a new theme should be easy and fun. Lose yourself in the boundless supply of free WordPress.org themes with the beautiful new theme browser.</p>\n<hr />\n<h2 style=\"text-align: center\">The Crew</h2>\n<p>This release was led by <a href=\"http://nacin.com/\">Andrew Nacin</a> and <a href=\"http://www.getsource.net/\">Mike Schroder</a>, with the help of these fine individuals. There are 267 contributors with props in this release, a new high:</p>\n<p><a href=\"https://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/kawauso\">Adam Harley (Kawauso)</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/adelval\">adelval</a>, <a href=\"https://profiles.wordpress.org/ajay\">Ajay</a>, <a href=\"https://profiles.wordpress.org/akeda\">Akeda Bagus</a>, <a href=\"https://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/tellyworth\">Alex Shiels</a>, <a href=\"https://profiles.wordpress.org/aliso\">Alison Barrett</a>, <a href=\"https://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"https://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"https://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"https://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/rarst\">Andrey \"Rarst\" Savchenko</a>, <a href=\"https://profiles.wordpress.org/andykeith\">Andy Keith</a>, <a href=\"https://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"https://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"https://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"https://profiles.wordpress.org/barry\">Barry</a>, <a href=\"https://profiles.wordpress.org/toszcze\">Bartosz Romanowski</a>, <a href=\"https://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"https://profiles.wordpress.org/bcworkz\">bcworkz</a>, <a href=\"https://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"https://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"https://profiles.wordpress.org/bigdawggi\">bigdawggi</a>, <a href=\"https://profiles.wordpress.org/bobbravo2\">Bob Gregor</a>, <a href=\"https://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"https://profiles.wordpress.org/bradt\">Brad Touesnard</a>, <a href=\"https://profiles.wordpress.org/bradparbs\">bradparbs</a>, <a href=\"https://profiles.wordpress.org/bramd\">Bram Duvigneau</a>, <a href=\"https://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/brasofilo\">brasofilo</a>, <a href=\"https://profiles.wordpress.org/bravokeyl\">bravokeyl</a>, <a href=\"https://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"https://profiles.wordpress.org/cgaffga\">cgaffga</a>, <a href=\"https://profiles.wordpress.org/chiragswadia\">Chirag Swadia</a>, <a href=\"https://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"https://profiles.wordpress.org/ehg\">Chris Blower</a>, <a href=\"https://profiles.wordpress.org/cmmarslender\">Chris Marslender</a>, <a href=\"https://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"https://profiles.wordpress.org/chrisscott\">Chris Scott</a>, <a href=\"https://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"https://profiles.wordpress.org/chrisguitarguy\">chrisguitarguy</a>, <a href=\"https://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"https://profiles.wordpress.org/ciantic\">ciantic</a>, <a href=\"https://profiles.wordpress.org/antorome\">Comparativa de Bancos</a>, <a href=\"https://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"https://profiles.wordpress.org/corvannoorloos\">Cor van Noorloos</a>, <a href=\"https://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"https://profiles.wordpress.org/cramdesign\">cramdesign</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"https://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"https://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"https://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"https://profiles.wordpress.org/eightface\">Dave Kellam (eightface)</a>, <a href=\"https://profiles.wordpress.org/dpe415\">DaveE</a>, <a href=\"https://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"https://profiles.wordpress.org/davidanderson\">David Anderson</a>, <a href=\"https://profiles.wordpress.org/davidmarichal\">David Marichal</a>, <a href=\"https://profiles.wordpress.org/denis-de-bernardy\">Denis de Bernardy</a>, <a href=\"https://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"https://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"https://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"https://profiles.wordpress.org/eatingrules\">eatingrules</a>, <a href=\"https://profiles.wordpress.org/plocha\">edik</a>, <a href=\"https://profiles.wordpress.org/oso96_2000\">Eduardo Reveles</a>, <a href=\"https://profiles.wordpress.org/eliorivero\">Elio Rivero</a>, <a href=\"https://profiles.wordpress.org/enej\">enej</a>, <a href=\"https://profiles.wordpress.org/ericlewis\">Eric Lewis</a>, <a href=\"https://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"https://profiles.wordpress.org/evarlese\">Erica Varlese</a>, <a href=\"https://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"https://profiles.wordpress.org/ejdanderson\">Evan Anderson</a>, <a href=\"https://profiles.wordpress.org/fahmiadib\">Fahmi Adib</a>, <a href=\"https://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"https://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"https://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"https://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"https://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/genkisan\">genkisan</a>, <a href=\"https://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"https://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"https://profiles.wordpress.org/vancoder\">Grant Mangham</a>, <a href=\"https://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"https://profiles.wordpress.org/tivnet\">Gregory Karpinsky (@tivnet)</a>, <a href=\"https://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"https://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"https://profiles.wordpress.org/helen\">Helen Hou-Sandí</a>, <a href=\"https://profiles.wordpress.org/ippetkov\">ippetkov</a>, <a href=\"https://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"https://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"https://profiles.wordpress.org/_jameslee\">jameslee</a>, <a href=\"https://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"https://profiles.wordpress.org/jaycc\">JayCC</a>, <a href=\"https://profiles.wordpress.org/jeffsebring\">Jeff Sebring</a>, <a href=\"https://profiles.wordpress.org/jenmylo\">Jen</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jesin\">Jesin A</a>, <a href=\"https://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"https://profiles.wordpress.org/jnielsendotnet\">jnielsendotnet</a>, <a href=\"https://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"https://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"https://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"https://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"https://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"https://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"https://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"https://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"https://profiles.wordpress.org/jstraitiff\">jstraitiff</a>, <a href=\"https://profiles.wordpress.org/juliobox\">Julio Potier</a>, <a href=\"https://profiles.wordpress.org/kopepasah\">Justin Kopepasah</a>, <a href=\"https://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"https://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"https://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"https://profiles.wordpress.org/kasparsd\">Kaspars</a>, <a href=\"https://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/kerikae\">kerikae</a>, <a href=\"https://profiles.wordpress.org/kworthington\">Kevin Worthington</a>, <a href=\"https://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"https://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"https://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"https://profiles.wordpress.org/klihelp\">klihelp</a>, <a href=\"https://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"https://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"https://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"https://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"https://profiles.wordpress.org/ldebrouwer\">ldebrouwer</a>, <a href=\"https://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"https://profiles.wordpress.org/lpointet\">lpointet</a>, <a href=\"https://profiles.wordpress.org/spmlucas\">Lucas Karpiuk</a>, <a href=\"https://profiles.wordpress.org/lkwdwrd\">Luke Woodward</a>, <a href=\"https://profiles.wordpress.org/nofearinc\">Mario Peshev</a>, <a href=\"https://profiles.wordpress.org/mark8barnes\">Mark Barnes</a>, <a href=\"https://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"https://profiles.wordpress.org/marventus\">Marventus</a>, <a href=\"https://profiles.wordpress.org/iammattthomas\">Matt (Thomas) Miklic</a>, <a href=\"https://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"https://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"https://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"https://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"https://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"https://profiles.wordpress.org/mattonomics\">mattonomics</a>, <a href=\"https://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"https://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"https://profiles.wordpress.org/mcadwell\">mcadwell</a>, <a href=\"https://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"https://profiles.wordpress.org/meloniq\">meloniq</a>, <a href=\"https://profiles.wordpress.org/michael-arestad\">Michael Arestad</a>, <a href=\"https://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"https://profiles.wordpress.org/mcsf\">Miguel Fonseca</a>, <a href=\"https://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"https://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"https://profiles.wordpress.org/mikemanger\">Mike Manger</a>, <a href=\"https://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"https://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/mikecorkum\">mikecorkum</a>, <a href=\"https://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"https://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"https://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"https://profiles.wordpress.org/mor10\">Morten Rand-Hendriksen</a>, <a href=\"https://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"https://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"https://profiles.wordpress.org/nendeb55\">nendeb55</a>, <a href=\"https://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/nicolealleyinteractivecom\">Nicole Arnold</a>, <a href=\"https://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"https://profiles.wordpress.org/nivijah\">Nivi Jah</a>, <a href=\"https://profiles.wordpress.org/nunomorgadinho\">Nuno Morgadinho</a>, <a href=\"https://profiles.wordpress.org/olivm\">olivM</a>, <a href=\"https://profiles.wordpress.org/jbkkd\">Omer Korner</a>, <a href=\"https://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"https://profiles.wordpress.org/patricknami\">patricknami</a>, <a href=\"https://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/djpaul\">Paul Gibbs</a>, <a href=\"https://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"https://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"https://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"https://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"https://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"https://profiles.wordpress.org/nprasath002\">Prasath Nadarajah</a>, <a href=\"https://profiles.wordpress.org/prettyboymp\">prettyboymp</a>, <a href=\"https://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"https://profiles.wordpress.org/rachelbaker\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"https://profiles.wordpress.org/ramonchiara\">ramonchiara</a>, <a href=\"https://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"https://profiles.wordpress.org/rhyswynne\">Rhys Wynne</a>, <a href=\"https://profiles.wordpress.org/ricardocorreia\">Ricardo Correia</a>, <a href=\"https://profiles.wordpress.org/richard2222\">Richard</a>, <a href=\"https://profiles.wordpress.org/theorboman\">Richard Sweeney</a>, <a href=\"https://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"https://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"https://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"https://profiles.wordpress.org/robmiller\">robmiller</a>, <a href=\"https://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"https://profiles.wordpress.org/romaimperator\">romaimperator</a>, <a href=\"https://profiles.wordpress.org/roothorick\">roothorick</a>, <a href=\"https://profiles.wordpress.org/ruudjoyo\">Ruud Laan</a>, <a href=\"https://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"https://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/salcode\">Sal Ferrarello</a>, <a href=\"https://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"https://profiles.wordpress.org/sandyr\">Sandeep</a>, <a href=\"https://profiles.wordpress.org/scottlee\">Scott Lee</a>, <a href=\"https://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/greglone\">ScreenfeedFr</a>, <a href=\"https://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"https://profiles.wordpress.org/sdasse\">sdasse</a>, <a href=\"https://profiles.wordpress.org/bootsz\">Sean Butze</a>, <a href=\"https://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"https://profiles.wordpress.org/nessworthy\">Sean Nessworthy</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/shahpranaf\">shahpranaf</a>, <a href=\"https://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"https://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"https://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"https://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"https://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"https://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"https://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"https://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"https://profiles.wordpress.org/sonjanyc\">sonjanyc</a>, <a href=\"https://profiles.wordpress.org/spencerfinnell\">Spencer Finnell</a>, <a href=\"https://profiles.wordpress.org/piontkowski\">Spencer Piontkowski</a>, <a href=\"https://profiles.wordpress.org/stephcook22\">stephcook22</a>, <a href=\"https://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"https://profiles.wordpress.org/sbruner\">Steve Bruner</a>, <a href=\"https://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"https://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"https://profiles.wordpress.org/tanner-m\">Tanner Moushey</a>, <a href=\"https://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"https://profiles.wordpress.org/tbrams\">tbrams</a>, <a href=\"https://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"https://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"https://profiles.wordpress.org/willmot\">Tom Willmot</a>, <a href=\"https://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"https://profiles.wordpress.org/topquarky\">topquarky</a>, <a href=\"https://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"https://profiles.wordpress.org/toru\">Toru Miki</a>, <a href=\"https://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"https://profiles.wordpress.org/umeshsingla\">Umesh Kumar</a>, <a href=\"https://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"https://profiles.wordpress.org/varunagw\">VarunAgw</a>, <a href=\"https://profiles.wordpress.org/wawco\">wawco</a>, <a href=\"https://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/wokamoto\">wokamoto</a>, <a href=\"https://profiles.wordpress.org/xsonic\">xsonic</a>, <a href=\"https://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"https://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, <a href=\"https://profiles.wordpress.org/zbtirrell\">Zach Tirrell</a>, and <a href=\"https://profiles.wordpress.org/vanillalounge\">Ze Fontainhas</a>. Also thanks to <a href=\"http://michaelpick.wordpress.com/\">Michael Pick</a> for producing the release video.</p>\n<p>If you want to follow along or help out, check out <a href=\"https://make.wordpress.org/\">Make WordPress</a> and our <a href=\"https://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress. See you soon for version 4.0!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wordpress.org/news/2014/04/smith/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.9 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"https://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 09:47:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3151\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:356:\"The second release candidate for WordPress 3.9 is now available for testing. If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the first release candidate, and those changes are all helpfully summarized in our weekly post on the development blog. Probably the biggest fixes are to live [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2273:\"<p>The second release candidate for WordPress 3.9 is now available for testing.</p>\n<p>If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the <a title=\"WordPress 3.9 Release Candidate\" href=\"//wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\">first release candidate</a>, and those changes are all helpfully summarized <a href=\"//make.wordpress.org/core/?p=10237\">in our weekly post</a> on the development blog. Probably the biggest fixes are to live widget previews and the new theme browser, along with some extra TinyMCE compatibility and some RTL fixes.</p>\n<p><strong>Plugin authors:</strong> Could you test your plugins against 3.9, and if they&#8217;re compatible, make sure they are marked as tested up to 3.9? It only takes a few minutes and this really helps make launch easier. Be sure to follow along the core development blog; we&#8217;ve been posting <a href=\"//make.wordpress.org/core/tag/3-9-dev-notes/\">notes for developers for 3.9</a>. (For example: <a href=\"//make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\">HTML5</a>, <a href=\"//make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\">symlinks</a>, <a href=\"//make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">MySQL</a>, <a href=\"//make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\">Plupload</a>.)</p>\n<p>To test WordPress 3.9 RC2, try the <a href=\"//wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"//wordpress.org/wordpress-3.9-RC2.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 3.9, visit the nearly complete About screen in your dashboard (<strong><img src=\"//i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and also check out <a title=\"WordPress 3.9 Beta 1\" href=\"//wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 post</a>.</p>\n<p><em>This is for testing,</em><br />\n<em>so not recommended for<br />\nproduction sites—yet.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"https://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:32:\"https://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 31 Oct 2014 20:53:31 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:37:\"https://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Fri, 24 Oct 2014 20:59:44 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20141017221016\";}", "no");
INSERT INTO `wp_options` VALUES("315", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1414832011", "no");
INSERT INTO `wp_options` VALUES("316", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1414788811", "no");
INSERT INTO `wp_options` VALUES("317", "_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c", "1414832012", "no");
INSERT INTO `wp_options` VALUES("318", "_transient_feed_867bd5c64f85878d03a060509cd2f92c", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WPTavern: Security Vulnerability Discovered and Patched in WP eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32794\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"http://wptavern.com/security-vulnerability-discovered-and-patched-in-wp-ecommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2510:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/WPeCommerceFeaturedImage.png\" rel=\"prettyphoto[32794]\"><img class=\"aligncenter size-full wp-image-32796\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/WPeCommerceFeaturedImage.png?resize=650%2C200\" alt=\"WP eCommerce Featured Image\" /></a></p>\n<p>If you use <a title=\"https://wordpress.org/plugins/wp-e-commerce/\" href=\"https://wordpress.org/plugins/wp-e-commerce/\">WP eCommerce</a>, you&#8217;ll want to update as soon as possible to fix a security vulnerability <a title=\"http://blog.sucuri.net/2014/10/security-advisory-medium-severity-wp-ecommerce-wordpress-plugin.html\" href=\"http://blog.sucuri.net/2014/10/security-advisory-medium-severity-wp-ecommerce-wordpress-plugin.html\">discovered by Sucuri</a>. According to the announcement, the vulnerability could be used by a malicious user to easily get access and modify private information on a site. Any website using WP eCommerce <strong>3.8.14.3</strong> or lower is at risk.</p>\n<p>A malicious attacker could use the exploit to export user names, addresses, and other private information. It also allows an attacker to modify orders e.g. non-paid to paid. The vulnerability is similar to the one suffered by MailPoet <a title=\"http://wptavern.com/wordpress-mailpoet-plugin-security-vulnerability-immediate-update-recommended\" href=\"http://wptavern.com/wordpress-mailpoet-plugin-security-vulnerability-immediate-update-recommended\">earlier this year</a>.</p>\n<blockquote><p>The plugin developers assumed that the WordPress’s <strong>admin_init</strong> hook was only called when the administrator was logged in and visited a page inside <strong>/wp-admin/</strong>. However, any call to <strong>/wp-admin/admin-post.php</strong> (or admin-ajax) also executes this hook without requiring the user to be authenticated.</p></blockquote>\n<p>Sucuri discovered the exploit during a routine audit of its <a title=\"http://sucuri.net/website-firewall/\" href=\"http://sucuri.net/website-firewall/\">firewall</a> service. After being disclosed to WP eCommerce earlier this week, the development team <a title=\"https://github.com/wp-e-commerce/WP-e-Commerce/commit/390c2ecc68027fbf21fb5d99a556d88c7bd8c05b\" href=\"https://github.com/wp-e-commerce/WP-e-Commerce/commit/390c2ecc68027fbf21fb5d99a556d88c7bd8c05b\">quickly patched</a> the exploit and released an update. Sucuri states details of the vulnerability will not be published until users have had time to update their sites.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Oct 2014 03:07:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WPTavern: WPWeekly Episode 168 – Recap of WordCamp San Francisco 2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=32762&preview_id=32762\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wptavern.com/wpweekly-episode-168-recap-of-wordcamp-san-francisco-2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2854:\"<p>In this episode of WordPress Weekly, <a title=\"http://marcuscouch.com/\" href=\"http://marcuscouch.com/\">Marcus Couch</a> and I dissect Matt Mullenweg&#8217;s <a title=\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\" href=\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\">State of the Word presentation</a> from WordCamp San Francisco. We discuss the global focus of WordPress 4.1, renaming the annual conference to WordCamp US, and the enhancements planned for the plugin and theme directories. The plugin picks of the week round out the show.</p>\n<h2>Stories Discussed:</h2>\n<p><a title=\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\" href=\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\">Matt Mullenweg’s State of the Word Highlights Internationalization, Mobile, and New Tools for WordPress Contributors</a><br />\n<a title=\"http://www.poststat.us/matt-mullenwegs-2014-state-word/\" href=\"http://www.poststat.us/matt-mullenwegs-2014-state-word/\">Matt Mullenweg’s 2014 State of the Word</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a title=\"https://wordpress.org/plugins/plugin-mover/\" href=\"https://wordpress.org/plugins/plugin-mover/\">Plugin Mover</a> enables you to move plugins out of sight without having to delete them.</p>\n<p><a title=\"https://wordpress.org/plugins/widget-importer-exporter/\" href=\"https://wordpress.org/plugins/widget-importer-exporter/\">Widget Importer and Exporter</a> is useful for moving widgets from one WordPress site to another, backing up widgets, and for theme developers to provide users with sample widgets.</p>\n<p><a title=\"https://wordpress.org/plugins/massive-visual-builder-page-layout-builder/\" href=\"https://wordpress.org/plugins/massive-visual-builder-page-layout-builder/\">Massive Visual Page Builder</a> enables users to visually build Pages using a wide selection of shortcodes.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, November 5th 9:30 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #168:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Oct 2014 03:03:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"WPTavern: AppPresser Debuts Reactor: A WordPress-Powered Mobile App Creator Built with the WP JSON REST API\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32729\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:116:\"http://wptavern.com/apppresser-debuts-reactor-a-wordpress-powered-mobile-app-creator-built-with-the-wp-json-rest-api\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5619:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/reactor.jpg\" rel=\"prettyphoto[32729]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/reactor.jpg?resize=846%2C400\" alt=\"reactor\" class=\"aligncenter size-full wp-image-32769\" /></a></p>\n<p>The folks behind <a href=\"https://apppresser.com\" target=\"_blank\">AppPresser</a>, the first mobile app development framework for WordPress, generated some buzz at <a href=\"http://2014.sf.wordcamp.org/\" target=\"_blank\">WordCamp San Francisco</a> with live demos of their upcoming <a href=\"https://apppresser.com/reactor-behind-scenes/\" target=\"_blank\">Reactor</a> product.</p>\n<p>When AppPresser was <a href=\"http://wptavern.com/apppresser-launches-first-mobile-app-development-framework-for-wordpress\" target=\"_blank\">launched</a> in January, it was groundbreaking in terms of demonstrating the power of WordPress as an application platform. However, it was not as user-friendly as the team hoped, with the necessity of installing multiple plugins and sending your app away to get built before you can test it on mobile. Customizing the app through AppPresser often left customers, especially non-developers, confused and in need of support.</p>\n<p>After seeing a live demo of Reactor, it seems likely that this new product will someday be the official successor of AppPresser. Reactor provides a hosted app-building experience that is far easier to use.</p>\n<h3>Reactor Will Provide a Hosted App Creation Service Using the WP JSON REST API</h3>\n<p><a href=\"http://modemlooper.me/\" target=\"_blank\">Ryan Fugate</a>, an AppPresser developer involved with building Reactor, said that the forthcoming WP JSON REST API was instrumental in the decision to build Reactor. &#8220;The API allows you to create much better performance in your apps, as well as offline capabilities.&#8221; Content created in Reactor is cached, stored in your app, and available offline.</p>\n<p>Any plugin that creates its own endpoints for the WP API can easily have its data pulled in and integrated with Reactor. In other words, instead of AppPresser having to create complicated add-ons for every plugin out there, the plugins can make themselves available to talk to Reactor via support for the new WP API.</p>\n<p>&#8220;We are currently building in support for WooCommerce and will be adding lots more plugins as they add support for the API,&#8221; Fugate told the Tavern.</p>\n<p>Since app creation with Reactor is provided as a hosted service, the team can offer a more consistent experience for its customers. &#8220;Building our own customized experience is a much better experience for the user,&#8221; Fugate said. &#8220;It allows us to integrate things like the build process and push notifications, which would not have been possible otherwise.&#8221;</p>\n<p>After testing Reactor, the single most useful feature that stands out is the live preview of your app as you are building it, as you can see in the demo video below. Instead of shipping your app off to be built with Phonegap, you can actually have it built automatically and scan a QR code to download it to your phone for testing.</p>\n<p><span class=\"embed-youtube\"></span></p>\n<h3>Will AppPresser &#8220;Classic&#8221; Be Phased Out in the Future?</h3>\n<p>Based on the live demo of Reactor that I saw, its features leave the original AppPresser product in the dust. There are so many distinct advantages to using Reactor that it is likely to render the original obsolete. Reactor includes:</p>\n<ul>\n<li>Pre-made page templates and features</li>\n<li>Design customization</li>\n<li>Build and preview your app without touching app files</li>\n<li>WordPress and non-WP content</li>\n<li>Integrated push notifications</li>\n<li>Automatic app building</li>\n<li>App stats</li>\n<li>Faster performance</li>\n<li>Offline capabilities</li>\n</ul>\n<p>Those who purchased the original AppPresser product will be eager to know if Reactor will soon be replacing it. The AppPresser team is committed to continuing support for the original product and won&#8217;t be retiring it anytime soon, according to Fugate:</p>\n<blockquote><p>AppPresser &#8216;classic&#8217; is still a very useful product for certain projects. For example, the BuddyPress integration is very solid, and some people may need to load custom content that isn&#8217;t available through the WP API.  Projects like the Dallas Museum of Art app by Webdev studios is a great example of a project for AppPresser classic.  </p>\n<p>Reactor has a lot of advantages though, so we&#8217;d recommend most people give it a try first.  We will still continue to sell and support AppPresser classic for the foreseeable future.</p></blockquote>\n<p>AppPresser may opt to grandfather in customers who purchased the original product, but the team hasn&#8217;t yet announced their plans. Access to Reactor will be offered for a monthly fee.</p>\n<p>The new service may be more cost-effective for customers who integrate push notifications with their apps, since many currently pay $50/month to a 3rd party service. Reactor integrates its own push notifications, which lowers the overall cost for apps that require them.</p>\n<p>The new WordPress-powered app creation service is an excellent example of what is possible for developers to build using the upcoming WP JSON REST API. <a href=\"https://apppresser.com\" target=\"_blank\">AppPresser</a> continues to innovate in the app space with virtually no competition from other companies, but that may change as others discover the power of the new API. The team hopes to have Reactor launched by the end of the year.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Oct 2014 23:23:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"WPTavern: Where Will WordCamp US be Held?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32740\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wptavern.com/where-will-wordcamp-usa-be-held\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2350:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/WordCampUSAFeaturedImage.png\" rel=\"prettyphoto[32740]\"><img class=\"size-full wp-image-32754\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/WordCampUSAFeaturedImage.png?resize=640%2C276\" alt=\"WordCamp USA Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/vgrigoriu/363904283/\">vgrigoriu</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>During the <a title=\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\" href=\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\">State of the Word</a> at WordCamp San Francisco, Matt Mullenweg announced that the event will be renamed to WordCamp US and will no longer be held in the Mission Bay conference center. The announcement doesn&#8217;t eliminate San Francisco, California from being the host city but it doesn&#8217;t seem likely as venues to hold more than 1,000 people are hard to come by or too expensive. The idea of WordCamp US is similar to <a href=\"http://wptavern.com/wordpress-beyond-boundaries-a-recap-of-wordcamp-europe-2014\" target=\"_blank\">WordCamp Europe</a> in that it would change host cities every year.</p>\n<p>I asked several WCSF attendees where they think the first WordCamp US will be held. The most common answers include the following cities:</p>\n<ul>\n<li>Houston, TX</li>\n<li>Las Vegas, NV</li>\n<li>Miami, FL</li>\n</ul>\n<p>Houston is a likely candidate as it&#8217;s the <a title=\"http://en.wikipedia.org/wiki/Matt_Mullenweg\" href=\"http://en.wikipedia.org/wiki/Matt_Mullenweg\">birth place of Mullenweg</a>, co-creator of the open source WordPress project. With the annual WordPress conference not tied to San Francisco anymore, it gives him an opportunity to host it in his hometown.</p>\n<p>Las Vegas has numerous venue locations that can hold upwards of a few thousand people. Food choices are plentiful and the weather is usually pretty nice. Miami is an international destination with easy access from Europe.</p>\n<p>Which US city do you think will host the first WordCamp US and which city would you <strong>like to see</strong> host it? Let us know in the comments.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Oct 2014 21:24:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WPTavern: WPWeekly Episode 167 – Preview of WordCamp San Francisco 2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=32509&preview_id=32509\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wptavern.com/wpweekly-episode-167-preview-of-wordcamp-san-francisco-2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3586:\"<p>In this episode of WordPress Weekly, <a title=\"http://marcuscouch.com/\" href=\"http://marcuscouch.com/\">Marcus Couch</a> and I dive into the news of the week. We have a lengthy discussion on the subject of niche admin themes for WordPress and what it might be like once the <a title=\"https://wordpress.org/plugins/json-rest-api/\" href=\"https://wordpress.org/plugins/json-rest-api/\">REST API</a> is added to core. After discussing the news, we talked about WordCamp San Francisco and the sessions we&#8217;re most looking forward to attending. We wrapped up the show with the plugin picks of the week.</p>\n<h2>Stories Discussed:</h2>\n<p><a title=\"http://wptavern.com/the-first-rate-and-review-a-plugin-day-is-a-success\" href=\"http://wptavern.com/the-first-rate-and-review-a-plugin-day-is-a-success\">The First “Rate and Review a Plugin Day” is a Success</a><br />\n<a title=\"http://wptavern.com/jason-schuller-to-re-enter-wordpress-theme-market-with-niche-admin-designs\" href=\"http://wptavern.com/jason-schuller-to-re-enter-wordpress-theme-market-with-niche-admin-designs\">Jason Schuller to Re-Enter WordPress Theme Market with Niche Admin Designs</a><br />\n<a title=\"http://wptavern.com/easily-edit-a-post-or-page-using-the-slash-edit-plugin\" href=\"http://wptavern.com/easily-edit-a-post-or-page-using-the-slash-edit-plugin\">Easily Edit a Post or Page Using The Slash Edit Plugin</a><br />\n<a title=\"http://wptavern.com/comparing-the-photo-publishing-experience-of-wordpress-for-ios-to-facebook-and-twitter\" href=\"http://wptavern.com/comparing-the-photo-publishing-experience-of-wordpress-for-ios-to-facebook-and-twitter\">Comparing The Photo Publishing Experience of WordPress For iOS to Facebook and Twitter</a><br />\n<a title=\"http://wptavern.com/tickets-still-available-to-watch-the-wordcamp-san-francisco-live-stream\" href=\"http://wptavern.com/tickets-still-available-to-watch-the-wordcamp-san-francisco-live-stream\">Tickets Still Available to Watch The WordCamp San Francisco Live Stream</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a title=\"https://wordpress.org/plugins/circles-gallery/\" href=\"https://wordpress.org/plugins/circles-gallery/\">Circles Gallery</a> is a dynamic new gallery plugin that presents things in a circular view. It has three different ways to present a gallery.</p>\n<p><a title=\"https://wordpress.org/plugins/cp-polls/\" href=\"https://wordpress.org/plugins/cp-polls/\">CP Polls</a> is a plugin that enables you to publish a poll into a page/post and optionally display statistics of the results. You can receive email notifications every time a vote is added or opt to receive Excel reports periodically.</p>\n<p><a title=\"https://wordpress.org/plugins/gravity-forms-entry-expiration/\" href=\"https://wordpress.org/plugins/gravity-forms-entry-expiration/\">Gravity Forms Entry Expiration</a> allows you to automatically delete Gravity Forms entries older than a defined time frame.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, October 29th 9:30 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #167:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Oct 2014 21:15:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WPTavern: Jetpack 3.2 Released, Introduces New Site Logo Feature for Theme Developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32332\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://wptavern.com/jetpack-3-2-released-introduces-new-site-logo-feature-for-theme-developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3893:\"<p>Jetpack 3.2 was quietly released yesterday with a host of new enhancements for self-hosted WordPress sites. Following up on 3.1&#8217;s total re-branding of the plugin, 3.2 comes with speed improvements and better caching for related posts.</p>\n<p>This release introduces the new &#8216;Site Logo&#8217; feature that was <a href=\"http://wptavern.com/wordpress-com-moves-to-standardize-theme-support-for-logos\" target=\"_blank\">added to WordPress.com themes</a> in late July. The goal is to increase data portability across themes and standardize the way themes present logo upload.</p>\n<p>The Site Logo feature has been added to Jetpack&#8217;s theme tools for any theme that opts to support it. It allows themes to optionally display the site’s title and tagline along with the logo and brings a new way for self-hosted WordPress sites to enjoy logo portability.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/site-icon.png\" rel=\"prettyphoto[32332]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/site-icon.png?resize=346%2C146\" alt=\"site-icon\" class=\"alignright size-full wp-image-32710\" /></a>You&#8217;ll also find a new Site Icon feature in this release, which lets you create an icon for your site that will be displayed as a favicon. If you don&#8217;t already have a favicon in place, this is an easy way to add one.</p>\n<p>The previous release introduced the Portfolio Custom Post Type as the first of many planned custom content types. According to the <a href=\"https://wordpress.org/plugins/jetpack/changelog/\" target=\"_blank\">changelog</a>, Jetpack 3.2 adds a new Testimonials content type. In order to turn it on, one might expect to navigate to ‘Settings’ → &#8216;Writing&#8217; → &#8216;Your Custom Content Types&#8217;, which is where the portfolio one is located. However, this feature is based on theme support and must be declared during <code>after_setup_theme</code>:</p>\n<pre class=\"brush: php; title: ; notranslate\">add_theme_support( \'jetpack-testimonial\' );</pre>\n<p>The Testimonials feature was actually added in a previous release, though not highly publicized.</p>\n<p>Additional enhancements in Jetpack 3.2 include:</p>\n<ul>\n<li>Improvements to API endpoints</li>\n<li>oEmbed sources (Twitter, SoundCloud, Instagram, DailyMotion, Vine)</li>\n<li>Indicators to make it easier to see which modules are active</li>\n<li>Improved debug tool</li>\n<li>Added &#8220;Remember Me&#8221; functionality to Single Sign On</li>\n<li>Improved accessibility</li>\n<li>Additional filters added for Widget Visibility</li>\n</ul>\n<p>The release notes also include a few bug fixes, most notably the removal of the Google+ module. Since <a href=\"http://wptavern.com/google-authorship-is-officially-dead-wordpress-authorship-plugins-are-now-obsolete\" target=\"_blank\">Google Authorship is now officially dead</a>, Jetpack 3.2 sheds the dead weight of the authorship feature originally introduced in its 2.5 release.</p>\n<p>The plugin description page on WordPress.org is sporting a new tagline. Previously, it read: <em>&#8220;Supercharge your WordPress site with powerful features previously only available to WordPress.com users.&#8221;</em></p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/jetpack-tagline.jpg\" rel=\"prettyphoto[32332]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/jetpack-tagline.jpg?resize=792%2C418\" alt=\"jetpack-tagline\" class=\"aligncenter size-full wp-image-32707\" /></a></p>\n<p>The new tagline, <strong><em>&#8220;Your WordPress, Streamlined,&#8221;</em></strong> seems to reflect an interesting language change within WordPress.com that identifies <em>sites</em> as simply <em>WordPress</em>.</p>\n<p>As of today, the Jetpack team has not yet officially announced the release on their blog, but the 3.2 update is available to users within the WordPress admin.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Oct 2014 18:10:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Matt: Tim Cook Comes Out\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44334\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://ma.tt/2014/10/tim-cook-comes-out/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:591:\"<blockquote><p>&#8220;I will personally continue to advocate for equality for all people until my toes point up.&#8221;<br />\n&#8212; Tim Cook</p></blockquote>\n<p><a href=\"http://www.businessweek.com/articles/2014-10-30/tim-cook-im-proud-to-be-gay\">That&#8217;s from Tim Cook&#8217;s &#8220;I&#8217;m Proud to be Gay&#8221; essay in BusinessWeek today</a>. It&#8217;s beautiful, brave, and amazing, and I love that idea of fighting for something until your last breath, it&#8217;s a very Southern expression. Here&#8217;s to Tim&#8217;s toes not pointing up for many, many years to come.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Oct 2014 16:26:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WordPress.tv Blog: WordCamp San Francisco 2014:  State of the Word Keynote\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.wordpress.tv/?p=406\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://blog.wordpress.tv/2014/10/29/wordcamp-san-francisco-2014-state-of-the-word-keynote/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2024:\"<p>The first WordCamp ever was held in San Francisco nine years ago (2006) as a way for WordPress users and developers to meet, share knowledge, and learn from one another.  Since that time these informal community-run events have grown and spread across the globe, but to this day WordCamp San Francisco is considered the event of the year for WordPress lovers everywhere.</p>\n<p>One of the highlights of WordCamp San Francisco is the &#8220;State of the Word&#8221; keynote speech delivered by Matt Mullenweg, co-founder of WordPress.  Presented in two videos, here is the keynote, and the following town hall Q&amp;A, from WordCamp San Francisco 2014.</p>\n<h2>Matt Mullenweg: The State of the Word 2014</h2>\n<div id=\"v-GmPDhkyi-1\" class=\"video-player\">\n</div>\n<p><a href=\"http://wordpress.tv/2014/10/26/matt-mullenweg…-the-word-2014/\">View on WordPress.tv</a></p>\n<h2>Matt Mullenweg: Town Hall at WordCamp San Francisco 2014</h2>\n<div id=\"v-WmCl2kwS-1\" class=\"video-player\">\n</div>\n<p><a href=\"http://wordpress.tv/2014/10/26/matt-mullenweg-town-hall-at-wordcamp-san-francisco-2014/\">View on WordPress.tv</a></p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptvblog.wordpress.com/406/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptvblog.wordpress.com/406/\" /></a> <img alt=\"\" border=\"0\" src=\"http://pixel.wp.com/b.gif?host=blog.wordpress.tv&blog=5310177&post=406&subd=wptvblog&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://blog.wordpress.tv/2014/10/29/wordcamp-san-francisco-2014-state-of-the-word-keynote/\"><img alt=\"Matt Mullenweg: The State of the Word 2014\" src=\"http://videos.videopress.com/GmPDhkyi/135_3_scruberthumbnail_1.jpg\" width=\"160\" height=\"120\" /></a></div><div><a href=\"http://blog.wordpress.tv/2014/10/29/wordcamp-san-francisco-2014-state-of-the-word-keynote/\"><img alt=\"Matt Mullenweg: Town Hall at WordCamp San Francisco 2014\" src=\"http://videos.videopress.com/WmCl2kwS/136_scruberthumbnail_1.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Oct 2014 18:32:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Jerry Bates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Matt: No More Platinum\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44296\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"http://ma.tt/2014/10/no-more-platinum/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:177:\"<p><a href=\"http://www.forbes.com/sites/hughmcintyre/2014/10/16/not-one-artists-album-has-gone-platinum-in-2014/\">Not One Artist&#8217;s Album Has Gone Platinum In 2014</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Oct 2014 01:50:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Matt: State of the Word 2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44325\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://ma.tt/2014/10/sotw-2014/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4248:\"<p>Yesterday I delivered the State of the Word address to the WordPress community, and the video is <a href=\"http://wordpress.tv/2014/10/26/matt-mullenweg-the-state-of-the-word-2014/\">already up on WordPress.tv</a>.</p>\n<div id=\"v-GmPDhkyi-1\" class=\"video-player\"></div>\n<p>Here are the slides if you&#8217;d like to view them on their own:</p>\n<p> \n<div> <strong> <a href=\"https://www.slideshare.net/photomatt/state-of-the-word-2014\" title=\"State of the Word 2014\" target=\"_blank\">State of the Word 2014</a> </strong> from <strong><a href=\"http://www.slideshare.net/photomatt\" target=\"_blank\">photomatt</a></strong> </div>\n<p>If you just want the bullet points, here are the big things I discussed and announced:</p>\n<ul>\n<li>There will be 81 <a href=\"http://wordcamp.org/\">WordCamps</a> in 2014.</li>\n<li>This was the <a href=\"http://2014.sf.wordcamp.org/\">9th and final WordCamp San Francisco</a> in its current form. We&#8217;ve maxed out the venue for years, so next year we&#8217;ll do a WordCamp US at a location and date to be determined.</li>\n<li>Milestone: 2014 was the first year non-English downloads surpassed English downloads of WordPress.</li>\n<li>33k took our survey: 7,539 (25%) of survey participants make their living from WordPress. Over 90% of people build more than one site, and spend less than 200 hours building one.</li>\n<li>We&#8217;ve done five major and seven minor releases since the last WCSF, and have had 785 contributors across them.</li>\n<li><a href=\"http://w3techs.com/technologies/history_overview/content_management/all/y\">WordPress market share</a> has risen from 19% in 2013 to 23% now.</li>\n<li>We now have 34k plugins and 2.7k themes, and have enjoyed record activity on both &#8212; including plugins passing 1,000,000 commits.</li>\n<li><a href=\"https://apps.wordpress.org/\">16 releases of our mobile apps</a>, Android and iOS.</li>\n<li><a href=\"https://developer.wordpress.org/reference/\">Code Reference launched</a>.</li>\n<li><a href=\"http://wordpress.meetup.com/\">105 active meetup groups in 21 countries</a>, with over 100 meetup and WordCamp organizers present at the event.</li>\n<li>Internationalization will be a big focus of the coming year, including fully-localized plugin and theme directories on language sites and embedded on dashboard in version 4.1, which is coming out December 10th.</li>\n<li>Better stats coming for plugin and theme authors.</li>\n<li>Version fragmentation is a big challenge for WordPress, only a quarter of users are currently on the latest release.</li>\n<li> This is also a problem for PHP &#8212; we&#8217;ll be working with hosts to help with version fragmentation, as well as to get as many WordPress sites as possible running PHP 5.5 or better.</li>\n<li>Showed off 2015 theme.</li>\n<li>We will be testing a workflow for accepting pull requests on <a href=\"https://github.com/WordPress/WordPress\">our official WordPress Github repository</a> before the end of the year.</li>\n<li>For the first time in 11 years we&#8217;re switching away from IRC as our primary communication method. We&#8217;ll be moving to <a href=\"https://slack.com/\">Slack</a>, which has helped us set up so that every member of WordPress.org can use it. (During the keynote address the number of people on Slack surpassed our IRC channels, and is currently over 800 people.) <a href=\"http://chat.wordpress.org/\">Sign up at chat.wordpress.org</a>.</li>\n<li><a href=\"http://ma.tt/2014/09/five-for-the-future/\">Five for the Future</a>, with Gravity Forms and WPMU Dev committing to donate, and Automattic now at 14 full-time contributors to core and community.</li>\n<li>We need to work hard to harmonize the <a href=\"http://wp-api.org/\">REST API plugin</a> and the <a href=\"http://developer.wordpress.com/docs/api/\">WordPress.com REST API</a>.</li>\n<li><strong>The mission of WordPress is to democratize publishing</strong>, which means access for everyone regardless of language, geography, gender, wealth, ability, religion, creed, or anything else people might be born with. To do that we need our community to be inclusive and welcoming. There is a sublime beauty in our differences, and they&#8217;re as important as the principles that bring us together, like the GPL.</li>\n</ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 Oct 2014 01:28:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:128:\"WPTavern: Matt Mullenweg’s State of the Word Highlights Internationalization, Mobile, and New Tools for WordPress Contributors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32611\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:133:\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9105:\"<p>Today Matt Mullenweg delivered his annual State of the Word address at <a href=\"http://2014.sf.wordcamp.org/\" target=\"_blank\">WordCamp San Francisco</a>, with roughly 1,000 WordPress enthusiasts and contributors in attendance and hundreds more watching via livestream.</p>\n<p>Before jumping into the results of the survey, Mullenweg announced that this would be the last event held at Mission Bay conference center.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>Touch the walls as you walk out, as this is the last time we\'ll have <a href=\"https://twitter.com/hashtag/WordCampSF?src=hash\">#WordCampSF</a> here! ~ <a href=\"https://twitter.com/photomatt\">@photomatt</a> <a href=\"https://twitter.com/hashtag/wcsf14?src=hash\">#wcsf14</a> <a href=\"https://twitter.com/hashtag/endofanera?src=hash\">#endofanera</a></p>\n<p>&mdash; WordCamp SF (@WordCampSF) <a href=\"https://twitter.com/WordCampSF/status/526454529584549889\">October 26, 2014</a></p></blockquote>\n<p></p>\n<h3>WordCamp USA</h3>\n<p>WordCamp San Francisco will become WordCamp USA next year. The name of the conference, location, date, and details are yet to be determined. The event has outgrown the Mission Bay venue and the organization team wants to be make room for more people and presentations.</p>\n<p>With the undeniable success of <a href=\"http://wptavern.com/wordpress-beyond-boundaries-a-recap-of-wordcamp-europe-2014\" target=\"_blank\">WordCamp Europe</a> two years in a row, pan-continental WordCamps may become more common in connecting people in various regions of the world. In fact, Mullenweg envisions that a number of &#8220;anchor WordCamps&#8221; will surface in the near future.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>“There could be WordCamp Asia and WordCamp Africa, with their own set of contributors and developers.”  <a href=\"https://twitter.com/photomatt\">@photomatt</a> <a href=\"https://twitter.com/hashtag/wcsf?src=hash\">#wcsf</a> <a href=\"https://twitter.com/hashtag/wcsf14?src=hash\">#wcsf14</a></p>\n<p>&mdash; David Bisset (@dimensionmedia) <a href=\"https://twitter.com/dimensionmedia/status/526438861530873856\">October 26, 2014</a></p></blockquote>\n<p></p>\n<h3>Internationalization Improvements to Connect the Global WordPress Community</h3>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/internationalization.jpg\" rel=\"prettyphoto[32611]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/internationalization.jpg?resize=1025%2C476\" alt=\"internationalization\" class=\"aligncenter size-full wp-image-32625\" /></a></p>\n<p>This year 33,000 people responded to the <a href=\"http://wptavern.com/take-the-2014-wordpress-user-and-developer-survey\" target=\"_blank\">WordPress user and developer survey</a>. Mullenweg stated that 2014 is likely to be remembered as a turning point for the project, noting that this was the first year that non-English downloads surpassed English downloads.</p>\n<p>Mullenweg encouraged attendees to see locale as a wider concept that includes language, timezone, and date formats. WordPress may soon be able to provide per-user internationalization features. For example, if someone leaves a comment in Japanese, an English-speaking post author would receive the notification in English.</p>\n<p>Language packs are coming to more plugins and themes by early 2015. Mullenweg announced that fully localized plugin and theme directories will be available in the dashboard starting with WordPress 4.1. He believes that internationalization improvements will be one of the most impactful things for WordPress&#8217; growth over the next decade.</p>\n<p><strong>&#8220;If WordPress is going to be truly global, truly inclusive, it has to be fully available for other languages,&#8221;</strong> he said. The upcoming improvements give WordPress the potential to be a truly global experience.</p>\n<h3>The Importance of Responsive Mobile</h3>\n<p>As he has in many recent interviews, Mullenweg highlighted the continuing importance of responsive mobile. &#8220;There are now more phones on the planet than human beings. We need to cater to them or they&#8217;re just going to replace us,&#8221; he joked.</p>\n<p>The future of the platform depends on having a strong mobile presence, but Mullenweg has a larger vision for how WordPress can lead the way for the next generation of the mobile web.</p>\n<p><strong>&#8220;Online communication is one of the great equalizers of our time,&#8221;</strong> he said. This goes hand-in-hand with the WordPress mission to democratize publishing. As mobile devices now have the capacity to do more things, Mullenweg is inspired by the idea that people can always be connected. He believes that WordPress as an application platform is poised to the lead the way.</p>\n<p>The 2014 survey results revealed that WordPress usage as a blog and as a CMS is declining every year. However, its usage as an app framework is steadily growing.</p>\n<p>Mullenweg highlighted the <a href=\"http://wp-api.org/\" target=\"_blank\">WP REST API</a> as critical to WordPress&#8217; ability to rapidly iterate in the future. The new API will pave the way for &#8220;completely bespoke posting interfaces,&#8221; he said. WordPress developers have often asked him when the platform will allow for theming the admin. Mullenweg hopes that the new API will make it possible for &#8220;1,000 different WordPress admins to bloom.&#8221;</p>\n<h3>Exciting New Tools for WordPress Contributors: GitHub and Slack</h3>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/contributors.jpg\" rel=\"prettyphoto[32611]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/contributors.jpg?resize=1025%2C495\" alt=\"contributors\" class=\"aligncenter size-full wp-image-32645\" /></a></p>\n<p>WordPress runs on contributions and communication. There were 785 people who contributed on five major releases since the last WordCamp San Francisco. The software recently crossed the one million commits mark. During the State of the Word, Mullenweg highlighted recent release leads and new committers, making a point to personally thank those who create the software that now runs 23% of the web.</p>\n<h4>GitHub</h4>\n<p>He also delivered several announcements to the delight of contributors in attendance. After asking the audience who has used Git and GitHub, he exclaimed, &#8220;Whoah, that&#8217;s all the hands!&#8221; He followed that up with the announcement that core contributors will soon be able to submit pull requests on GitHub.</p>\n<h4>Slack</h4>\n<p>For the first time in 11 years, the project will experiment with not using IRC as its primary communication tool. Mullenweg announced that the community will be trying out Slack for real-time communication for contributor teams. The tool is mobile friendly and has a number of strong advantages over IRC for asynchronous communication. If a ticket is mentioned in Slack, it will be linked with trac. The #wordpress support IRC channel will still be used. Participation on Slack is now available to every single WordPress.org contributor, replacing IRC and ad hoc Skype chats. You can visit <a href=\"http://chat.wordpress.org\" target=\"_blank\">chat.wordpress.org</a> to initiate your invite.</p>\n<p>The #wordpress support IRC channel will continue on. Slack will be used for contributing to the WordPress project, be it code, design, documentation, etc.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>During State of the Word, already more people in <a href=\"https://twitter.com/SlackHQ\">@SlackHQ</a> then in WordPress Dev IRC. <a href=\"https://twitter.com/photomatt\">@photomatt</a> <a href=\"https://twitter.com/hashtag/wcsf?src=hash\">#wcsf</a> <a href=\"https://twitter.com/hashtag/wcsf14?src=hash\">#wcsf14</a></p>\n<p>&mdash; David Bisset (@dimensionmedia) <a href=\"https://twitter.com/dimensionmedia/status/526448569415262208\">October 26, 2014</a></p></blockquote>\n<p></p>\n<p>Results of the 2014 survey showed that a full quarter of those surveyed make their living using WordPress, representing more than a billion dollars of economic activity per year. Mullenweg referenced his <a href=\"http://ma.tt/2014/09/five-for-the-future/\" target=\"_blank\">Five for the Future</a> post encouraging companies to support the project with 5% of their time. Very few open source software projects thrive as long as the 11 years that WordPress already has, Mullenweg said. He featured three companies that have publicly committed 5% to WordPress, including Gravity Forms, WPMUDEV, and Automattic.</p>\n<p><strong>&#8220;This is what is going to take us from 23% to 30% or 40%,&#8221;</strong> he said. With hundreds and thousands of freelancers and companies all over the world giving back to WordPress, the project will have the momentum to continue its unprecedented growth. WordPress has now outgrown the venue of its flagship WordCamp. It has also outgrown its old communication tools. WordPress is about to explode on a global scale. Years from now we&#8217;ll look back on 2014 as a year where many key improvements positioned WordPress to further dominate the web.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 26 Oct 2014 23:41:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Post Status: Matt Mullenweg’s 2014 State of the Word\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://www.poststat.us/?p=7213\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://www.poststat.us/matt-mullenwegs-2014-state-word/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11832:\"<p><img class=\"aligncenter size-large wp-image-7215\" src=\"http://www.poststat.us/wp-content/uploads/2014/10/mullenweg-752x564.jpg\" alt=\"mullenweg\" width=\"627\" height=\"470\" /></p>\n<blockquote><p>&#8220;Oh, my name is Matt Mullenweg by the way. Nice to meet you.&#8221;</p></blockquote>\n<p>After the WordPress co-founder welcomed the largest WordCamp San Francisco audience ever, he introduced himself and began this year&#8217;s State of the Word &#8212; the annual talk where he provides insight of the last year of WordPress and inspiration for the future.</p>\n<p><em>edit</em>: The video is now available:</p>\n<div class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<a href=\"http://videos.videopress.com/GmPDhkyi/135_3_dvd.mp4\">http://videos.videopress.com/GmPDhkyi/135_3_dvd.mp4</a></div>\n<p><a href=\"http://wordpress.tv/2014/10/26/matt-mullenweg-the-state-of-the-word-2014/\">Or watch on WordPress.tv</a></p>\n<h3>The last WCSF as we know it</h3>\n<p>WordCamp San Francisco has been here in Mission Bay for 7 years, and it&#8217;s the last year here. Next year, things are going to change. There will be a WordCamp US (Matt notes it&#8217;s a working title) that will be modeled similarly to WordCamp Europe. The name, location and date are yet to be determined.</p>\n<h3>The annual WordPress survey</h3>\n<p>This year there were over 33,000 responses to the annual WordPress survey.</p>\n<p>Only 23% of the survey respondents were from the United States &#8212; a 6% increase of international respondents. And for the first time ever, non-English downloads surpassed English downloads. This change is much due to the new internationalization tools in WordPress core itself.</p>\n<p>A quarter of the respondents now make their living fully off of WordPress &#8212; 7,539 people from the survey pool. Matt estimates those people alone make up for more than a billion dollars of economic impact.</p>\n<p>Of those people surveyed, they have between half a million and a million currently active websites they own or have developed. And 91% of those sites took less than 200 hours to make.</p>\n<h3>5 releases since the last WCSF</h3>\n<p><img class=\"aligncenter size-large wp-image-7218\" src=\"http://www.poststat.us/wp-content/uploads/2014/10/contributors-752x560.jpg\" alt=\"contributors\" width=\"627\" height=\"466\" /></p>\n<p>Since last summer and the last WCSF, we&#8217;ve had five major releases of WordPress. Matt spent some time going over some of the features we&#8217;ve gained.</p>\n<p>From WordPress 3.6 to WordPress 4.0, WordPress has evolved an enormous amount in a short amount of time. It&#8217;s better on mobile; has a better user experience; is more performant; is easier to use for both developers and end users; and is the best publishing tool in the world.</p>\n<p>There have been seven release leads in that time:</p>\n<ul>\n<li>Jon Cave</li>\n<li>Andrew Nacin</li>\n<li>Helen Hou-Sandi</li>\n<li>Mark Jaquith</li>\n<li>Dion Hulse</li>\n<li>Mike Schroder</li>\n<li>Aaron Campbell</li>\n</ul>\n<p>Additionally, Matt highlighted another 8 significant contributors and five new committers to the WordPress project.</p>\n<p>In these five releases, there have been 785 contributors to the project. And Matt also highlights John Blackbourn &#8212; the WordPress 4.1 release lead, which will soon enter beta.</p>\n<h3>Two Drupal growth</h3>\n<p>Since last summer, WordPress has grown &#8220;two Drupal marketshares.&#8221;</p>\n<p>There have been 684 theme additions to the repository this year &#8212; a 36% increase year over year. There are now 2,781 themes in the repo.</p>\n<h3>iOS and Android</h3>\n<p>There have been two updates for Android, five for iOS, and we abandoned older platforms to focus on a better user experience. &#8220;Sorry, both of the Windows phone users,&#8221; he joked.</p>\n<p>Matt notes that there are now more mobile phones than humans on earth, and that this will continue to be a huge priority.</p>\n<h3>Developer.WordPress.org</h3>\n<p>Noted in the last WCSF State of the Word, <a href=\"http://developer.wordpress.org\">developer.wordpress.org</a> is now live. A little later that hoped, he noted, but it&#8217;s a huge achievement and improvement for WordPress documentation.</p>\n<h3>Community</h3>\n<p>There are over 100 meetup and WordCamp organizers here at WordCamp San Francisco. Matt asked them all to stand, with a personal thanks to their commitment to a difficult, but rewarding task.</p>\n<h3>Internationalization</h3>\n<p>We have a long way to go with Internationalization, but Matt highlights some of the progress and promise for the future, including the advancement of language packs that plugin and theme developers will be able to take advantage of.</p>\n<p>Soon &#8212; with the release of WordPress 4.1 &#8212; Matt announced that the WordPress plugin and theme directories will be fully localized, making it more accessible and fully translated for non-English speakers.</p>\n<p>&#8220;The discovery process [of themes and plugins] is prohibitive&#8221; unless we make it a priority to offer the same discovery features that are in English to other languages.</p>\n<blockquote><p>&#8220;We have the potential &#8212; thanks to the web &#8212; for WordPress to be a truly global experience.&#8221;</p></blockquote>\n<h3>Better WordPress.org stats</h3>\n<p>Matt is promising a better offering of statistics for WordPress theme and plugin providers &#8212; a task that&#8217;s being worked on right now by the .org team.</p>\n<p>These are numbers people have long wanted and are very difficult to get. This is a very welcome change.</p>\n<h3>Adoption of new releases</h3>\n<p>Matt says only 25% of users are on the latest install, WordPress 4.0. While he notes that it&#8217;s far better than it was in the past, we still have a lot of improvement we can make.</p>\n<p>And he goes into the importance of removing versions from the conversation in software. Users should not know or care the version of their software. They should only know that it works.</p>\n<p>&#8220;Our vision is that we&#8217;re like Chrome. &#8230; And the hosts have helped pioneer this.&#8221; But WordPress itself will eventually move to such a model; this is a thing that is controversial, but I believe it is an essential and inevitable evolution.</p>\n<p>Matt asked how many people had been hacked &#8212; and even in a room full of professionals &#8212; it was a lot of people. This is why updates are important, as updated WordPress installs are much safer.</p>\n<h3>Relationship with PHP</h3>\n<p>Matt spent some time talking about WordPress support for more modern versions of PHP.</p>\n<p>WordPress is notorious for being a poor supporter of modern PHP. But that&#8217;s ready to change.</p>\n<blockquote><p>&#8220;We&#8217;re going to start working with hosts to get everyone on PHP 5.5 or above.&#8221;</p></blockquote>\n<h3>The Twenty Fifteen theme</h3>\n<p>Matt is excited about Twenty Fifteen, this coming year&#8217;s default theme. He notes this is our fifth year with a new default theme, and it&#8217;s the same number of years that Kubrick was the only default theme. A massive success.</p>\n<h3>WordPress and Github</h3>\n<p>Matt Mullenweg says that starting this year, you can submit a pull request to WordPress on Github, &#8220;and that will not go into a black hole.&#8221;</p>\n<p>He asked how many people are using Github, and nearly everyone raised their hand. This removes a barrier to contributing to WordPress, and is a huge improvement.</p>\n<p>He also says that all development of the WordPress mobile apps is now on Github. It&#8217;s also worth noting that much of Automattic&#8217;s internal projects, like Jetpack, are run on Github.</p>\n<h3>Community communication with Slack</h3>\n<p>For the first time in 11 years, WordPress is leaving IRC for primary organization communication. We&#8217;re going to try a tool called <a href=\"http://slack.com\">Slack</a>, built by a company in San Francisco started by the former founder of Flickr. Slack has taken over communication in remote teams, from my experience, and will be excellent.</p>\n<p>Slack will also help us make use of integrations and notifications. Right after the talk, <a href=\"http://chat.wordpress.org\">chat.wordpress.org</a> will lead any WordPress.org user to a method for using Slack for communication.</p>\n<p>This is a huge partnership, and as someone that uses Slack daily, I&#8217;m incredibly excited. I&#8217;m sure there could be pushback for using a paid tool for this, but it&#8217;s certainly and interesting experiment and I&#8217;m excited to see what happens.</p>\n<p>It appears clear to me that contributing to WordPress will now be easier than ever.</p>\n<h3>Five for the future</h3>\n<p>Matt talked about his controversial blog post about the concept of <a href=\"http://ma.tt/2014/09/five-for-the-future/\">Five for the future</a>, something <a title=\"Contribution as culture\" href=\"http://www.poststat.us/contribution-culture/\">I also opined about</a>.</p>\n<p>Matt highlighted three companies: Gravity Forms, WPMUDev, and Automattic are all now contributing 5%. Of course he notes others are doing it as well, but wanted to highlight those that have committed to doing it publicly.</p>\n<p>Matt discussed a number of ways people can contribute, and that folks can attend sessions to learn how to contribute both here at WCSF and at most other WordCamp events.</p>\n<blockquote><p>&#8220;A contributor, by the way, is a title that no one can give you except yourself.&#8221;</p></blockquote>\n<p>He called it an altruistic mentality of contribution.</p>\n<h3>The JSON REST API</h3>\n<blockquote><p>&#8220;Who&#8217;s excited about the REST API?&#8221;</p></blockquote>\n<p>Nearly everyone responded with enthusiasm. Matt talks about how WordPress.com has had a similar API for years now, and what they&#8217;ve learned, and how much potential there will be for the core version, and the importance for marrying the .com API and the .org API as they each approach 2.0.</p>\n<p>Matt wants us to re-think &#8220;the WordPress engine&#8221; as a kernel that can a hub for building all sorts of things that are more capable to be fit into a proper architecture for the case at hand versus &#8220;shoehorning&#8221; existing WordPress features to areas that aren&#8217;t really meant for it.</p>\n<blockquote><p>&#8220;Maybe what we need isn&#8217;t a way for theming the WP admin; maybe what we need is a way for 1,000 WP admins to be built.&#8221;</p></blockquote>\n<p>And for those admins to be able to fork each other, learn from one another, and create better and catered publishing experiences catered to specific use cases.</p>\n<p>We can expect the core WordPress JSON API in 2015.</p>\n<h3>The continuing importance of WordPress and mobile.</h3>\n<p>Matt discussed how important mobile is to the future of the web, and therefore WordPress. &#8220;They are winning,&#8221; he says about the phones, and says how phones are more available and evolving every year. &#8220;They&#8217;re getting bigger and bigger,&#8221; and the interfaces and methods for interacting with our phones are evolving as well.</p>\n<p>Matt believes that WordPress can play a central role in the further evolution of mobile applications and the mobile web. As the power of mobile devices gets better, Matt believes that the web will become a bigger part of the mobile experience than it is now &#8212; when the conversation seems to be completely centered around apps.</p>\n<blockquote><p>&#8220;This is one of the ways that we can be truly global.&#8221;</p></blockquote>\n<h3>Wrapping up</h3>\n<p>To democratize publishing, is the mission of WordPress.</p>\n<p>WordPress is a community, Matt states, and accessibility from a language, device, and any other point of view is critical to the mission of WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 26 Oct 2014 18:49:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"Matt: Anti-spam and E2E crypto\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44305\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://ma.tt/2014/10/anti-spam-and-e2e-crypto/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:232:\"<p><a href=\"https://moderncrypto.org/mail-archive/messaging/2014/000780.html\">A brief history of spam and email crypto by someone who used to work on Gmail</a>. <cite>Hat tip: <a href=\"http://z9.io/\">Donncha O Caoimh</a>.</cite></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 25 Oct 2014 17:24:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"Matt: WordCamp SF Live Stream\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://ma.tt/2014/10/wordcamp-sf-live-stream/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:681:\"<p>WordCamp San Francisco, the original, starts tomorrow and the <a href=\"https://twitter.com/search?f=realtime&q=wcsf&src=typd\">tweets are already starting to stream in</a>. On Sunday at 11AM I will deliver my <a href=\"http://wordpress.tv/speakers/matt-mullenweg/?s=state\">State of the Word address</a>, our annual look at where we&#8217;ve been and the road ahead, and even if you can&#8217;t make it <a href=\"http://2014.sf.wordcamp.org/live-stream/\">you can livestream the SoTW and the entire weekend for just $10 from the comfort of your own home</a>. 16+ hours of WP entertainment for the price of one movie ticket! (Or might be a sleep aid, depends on your perspective.)</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Oct 2014 18:02:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"Alex King: No WordCamp SF 2014 For Me\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://alexking.org/?p=21026\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://alexking.org/blog/2014/10/24/no-wordcamp-2014-for-me\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:216:\"<p>Unfortunately I&#8217;m not going to be able to attend WordCamp SF 2014. My apologies to those who I was planning to meet up with. I&#8217;ll miss seeing you folks there &#8211; but have fun and do great work!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Oct 2014 16:21:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: MediaPress Now in Beta: A New Media Gallery Plugin for BuddyPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32554\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://wptavern.com/mediapress-now-in-beta-a-new-media-gallery-plugin-for-buddypress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6508:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/mediapress-feature.png\" rel=\"prettyphoto[32554]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/mediapress-feature.png?resize=991%2C494\" alt=\"mediapress-feature\" class=\"aligncenter size-full wp-image-32589\" /></a></p>\n<p>For a long time, BuddyPress has been sorely in need of better support for media, as images, video, and audio play a major part in connecting people on social networks. BuddyPress core has adopted the <a href=\"http://wptavern.com/buddypress-to-adopt-features-as-plugins-model-to-develop-new-media-component\" target=\"_blank\">features-as-plugin development</a> model to help facilitate the development of a new media component called BP Attachments. This new Attachments API, once finished, would allow BuddyPress to store media as attachments, offering developers a standard way of extending the plugin to build media-related functionality.</p>\n<p>With no way of knowing when or if BuddyPress will add a core media component, developers have struggled over the years to tackle media support with independent solutions. <a href=\"http://buddydev.com/\" target=\"_blank\">Brajesh Singh</a>, a prolific BuddyPress plugin developer, created the popular BP Gallery four years ago to address this need, but the plugin is now outdated.</p>\n<p>Last week Singh introduced <a href=\"http://buddydev.com/buddypress/presenting-mediapress-media-plugin-will-ever-need-buddypress/\" target=\"_blank\">MediaPress</a>, his latest attempt at creating gallery/album capabilities for BuddyPress. The plugin is now in beta and boasts an impressive list of features, including:</p>\n<ul>\n<li>User media/gallery/album support</li>\n<li>Group media/gallery/album support</li>\n<li>Built-in photo, audio, and video support</li>\n<li>Supports privacy</li>\n<li>Drag-and-drop uploader</li>\n<li>Upload from Activity</li>\n<li>Automatic wall galleries creation</li>\n<li>Wall gallery support for Groups/Users</li>\n<li>Grid layout for media</li>\n<li>Playlist view support for audio/Video Galleries</li>\n<li>Widgets and shortcodes to list galleries, media, playlist, audio, etc.</li>\n</ul>\n<p>MediaPress adds upload buttons for images, audio, and video to the activity update box. Users can also upload from the gallery menu item in their profiles.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/media-upload.png\" rel=\"prettyphoto[32554]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/media-upload.png?resize=1025%2C428\" alt=\"media-upload\" class=\"aligncenter size-full wp-image-32569\" /></a></p>\n<p>MediaPress&#8217; gallery support works very similar to Facebook. Images uploaded via the activity stream will be placed in a wall photo gallery where users can view, edit, or delete them.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/user-galleries.png\" rel=\"prettyphoto[32554]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/user-galleries.png?resize=700%2C527\" alt=\"user-galleries\" class=\"aligncenter size-full wp-image-32571\" /></a></p>\n<p>MediaPress comes with an extensive array of admin options for controlling its features. It&#8217;s also tightly integrated with WordPress and BuddyPress, which is why audio playlists in the activity stream look similar to audio uploaded to posts.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/audio-play-list-activity.png\" rel=\"prettyphoto[32554]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/audio-play-list-activity.png?resize=1025%2C318\" alt=\"audio-play-list-activity\" class=\"aligncenter size-full wp-image-32573\" /></a></p>\n<p>Singh built MediaPress to be easy to customize and easy for other components to extend. Here are a few examples of what developers can do with the plugin:</p>\n<ul>\n<li>Use a different storage manager (supports local uploads by default but you can write one for the cloud- check core/storage/storage-manager.php for details).</li>\n<li>Add support for a new Media Type. (Check core/common/api.php, core/common/init.php for details.)</li>\n<li>Write a custom media loop. (Check MPP_Media_Query in core/common/query-media.php.)</li>\n<li>Write your own custom Gallery loop/list. (Check MPP_Gallery_Query for details.)</li>\n</ul>\n<h3>The Future of MediaPress</h3>\n<p>MediaPress does not utilize the BP Attachments API. I spoke with Singh to see what his plans are, when/if BP core adds better media support. &#8220;Yes, I will continue developing it even if BP adds its own media component,&#8221; he said. &#8220;MediaPress has a more versatile API than what will come in any media component in the next 2-3 years at least.&#8221;</p>\n<p>Singh spent the last year and a half planning the plugin, but it was only within the last four months that he got serious about building it. &#8220;I spent most of the time planning the architecture and API. My basic goal was to make it easy for site admins as well as developers to use and extend the plugin,&#8221; he said.</p>\n<p>MediaPress is open source and will remain free to use, as Singh&#8217;s primary goal is better community adoption. After the first release, he is planning on putting the plugin on GitHub and will also submit it to WordPress.org. He hopes to build a community around it.</p>\n<p>Singh will be retiring BP Gallery in favor of MediaPress. &#8220;Things have changed in last 4 years &#8211; custom post types, taxonomy APIs made it into WordPress core, as well as multisite,&#8221; he said. &#8220;We needed a plugin to reflect these changes and work better with the current APIs. I did not feel updating BP Gallery will do it justice.&#8221;</p>\n<p>There are very few media plugins for BuddyPress at the moment, and Singh said that it seemed all of them were either bloated or very limited in options. MediaPress is currently the most advanced gallery/album solution for BuddyPress, even though it&#8217;s still in beta. I tested the plugin and found its UI to be fairly intuitive. It fits in like a natural part of BuddyPress. Check out the <a href=\"http://demos.buddydev.com/mediapress/activity/\" target=\"_blank\">live demo</a> to see it in action.</p>\n<p>In the future, Singh plans to add support for WordPress (non-BuddyPress) sites and bbPress. If you&#8217;d like to help test the MediaPress beta, you can download it from <a href=\"http://buddydev.com/buddypress/presenting-mediapress-media-plugin-will-ever-need-buddypress/\" target=\"_blank\">BuddyDev.com</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Oct 2014 05:13:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt: FB Rooms\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44309\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://ma.tt/2014/10/fb-rooms/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:397:\"<blockquote><p>We’re not trying to build the next Snapchat — we’re trying to build the next WordPress.<br />\n&#8212; Josh Miller from Facebook</p></blockquote>\n<p>Uh, okay! From the Verge&#8217;s article <a href=\"http://www.theverge.com/2014/10/23/7048495/facebook-rooms-brings-reddit-like-forums-to-your-iphone\">Facebook&#039;s new Rooms app brings bite-sized forums to your iPhone</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Oct 2014 20:15:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: JSTOR Launches Online Daily Magazine Using WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32503\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"http://wptavern.com/jstor-launches-online-daily-magazine-using-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3457:\"<p>In a strategic effort to make academic journals more relevant to your average reader, <a href=\"http://www.jstor.org/\" target=\"_blank\">JSTOR</a> has launched an online daily magazine. The digital academic library offers full-text searches of 2,000+ journals, e-books, and primary sources. <a href=\"http://daily.jstor.org/\" target=\"_blank\">JSTOR Daily</a> will serve to bring more context to current events by connecting readers to relevant scholarly publications found within the JSTOR library.</p>\n<p>The site&#8217;s authors tackle various complex issues, such as <a href=\"http://daily.jstor.org/stem-cells-offer-hope-for-treating-type-i-diabetes/\" target=\"_blank\">stem cell research</a>, <a href=\"http://daily.jstor.org/marijuana-and-public-health/\" target=\"_blank\">marijuana and public health</a>, <a href=\"http://daily.jstor.org/why-growing-more-food-wont-stop-hunger/\" target=\"_blank\">world hunger</a>, and more, by providing backstory using research from JSTOR&#8217;s wealth of scholarly publications.</p>\n<p><strong>&#8220;JSTOR is primarily a digital library, and we haven’t produced our own content before, so this is a real shift for the organization,”</strong> editor Catherine Halley told NiemanLab in a recent <a href=\"http://www.niemanlab.org/2014/10/opening-up-the-archives-jstor-wants-to-tie-a-library-to-the-news/\" target=\"_blank\">interview</a>. Publishers of the new daily magazine selected WordPress to power the site, which currently publishes two to three short posts per day, interspersed with longer feature stories twice per week.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/jstor-daily.jpg\" rel=\"prettyphoto[32503]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/jstor-daily.jpg?resize=345%2C500\" alt=\"jstor-daily\" class=\"alignright size-large wp-image-32540\" /></a>JSTOR Daily&#8217;s design uses a slightly modified version of <a href=\"http://themeforest.net/item/simplemag-magazine-theme-for-creative-stuff/4923427\" target=\"_blank\">SimpleMag</a>, a magazine theme sold on Themeforest. Based on a quick view of the source, you can see that the site also utilizes common plugins, such as <a href=\"http://jetpack.me/\" target=\"_blank\">Jetpack</a> to power subscriptions and stats, <a href=\"http://www.gravityforms.com/\" target=\"_blank\">Gravity Forms</a>, <a href=\"https://wordpress.org/plugins/add-to-any/\" target=\"_blank\">Add to Any</a>, <a href=\"https://github.com/deconf/google-analytics-dashboard-for-wp\" target=\"_blank\">Google Analytics Dashboard for WP</a>, and <a href=\"https://wordpress.org/plugins/w3-total-cache/\" target=\"_blank\">W3 Total Cache</a>.</p>\n<p>The site is currently still in beta, as JSTOR experiments with its content strategy. Ordinarily, JSTOR serves its library content via paid subscriptions, though access is licensed mainly to academic institutions and their students. However, content linked within JSTOR daily has to be freely available to readers, since the purpose of the publication is to maximize JSTOR&#8217;s academic archive. Therefore, the publishers opted to make any timely or otherwise compelling content available for free, when linked within one of the stories. If you&#8217;re interested in getting your news mixed with a healthy dose of in-depth academic research, subscribe to the <a href=\"http://daily.jstor.org/newsletter/\" target=\"_blank\">JSTOR Daily bi-weekly newsletter</a> or add the site to your favorite feed reader.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Oct 2014 18:40:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"WPTavern: Unsplash Plugin Brings One-Click Stock Photo Uploads to the WordPress Media Library\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32458\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://wptavern.com/unsplash-plugin-brings-one-click-stock-photo-uploads-to-the-wordpress-media-library\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4059:\"<p><a href=\"https://unsplash.com\" target=\"_blank\">Unsplash</a>, the free stock photo site, quickly became popular with designers, due to its tasteful curating of images. All of the high resolution images on the site are carefully selected, and you&#8217;d be hard-pressed to find a bad photo among them. Unsplash gradually grows its collection by adding 10 new photos every 10 days, all of which are available under the very permissive <a href=\"http://creativecommons.org/publicdomain/zero/1.0/\" target=\"_blank\">Creative Commons Zero</a> license.</p>\n<p><a href=\"https://wordpress.org/plugins/unsplash-stock-photo-library/\" target=\"_blank\">Unsplash WP</a> is the first plugin created to bring these images into WordPress. With one click you can upload stock photos directly into the media library without having to leave the admin. Since Unsplash photo licensing allows you the freedom to copy, modify, distribute and use the photos without permission, you can use the images in your commercial endeavors, designs, blog posts, or anywhere on your site.</p>\n<p>Once installed, you can add Unsplash photos from the plugin&#8217;s settings page or within the page/post editor. You have a few options for setting the upload image width and height, as well as the number of images per page. When editing content, you&#8217;ll find a new Unsplash Uploader button:</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/unsplash-button.png\" rel=\"prettyphoto[32458]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/unsplash-button.png?resize=1025%2C522\" alt=\"unsplash-button\" class=\"aligncenter size-full wp-image-32488\" /></a></p>\n<p>When you click on the uploader, the most recent Unsplash images will be displayed in lightbox. You can toggle between recent, oldest, and random to select images to upload.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/unsplash-media-library.png\" rel=\"prettyphoto[32458]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/unsplash-media-library.png?resize=1025%2C506\" alt=\"unsplash-media-library\" class=\"aligncenter size-full wp-image-32463\" /></a></p>\n<p>The images you select will then be added to your media library for use. You&#8217;ll have to switch back to the media upload button to insert them into your content. The plugin will need to be able to write temporary images into the wp-content/plugins/unsplash-stock-photo-library directory for image processing, prior to uploading them to the media library. If you see the little red warning on an image, it means that you will need to check your server permissions before it will work.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/check-permissions-yo.jpg\" rel=\"prettyphoto[32458]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/check-permissions-yo.jpg?resize=826%2C356\" alt=\"check-permissions-yo\" class=\"aligncenter size-full wp-image-32482\" /></a></p>\n<p>Unsplash WP was created by <a href=\"http://connekthq.com/\" target=\"_blank\">Darren Cooney</a>, author of the <a href=\"https://wordpress.org/plugins/ajax-load-more/\" target=\"_blank\">Ajax Load More</a> plugin. After testing it, I was impressed by how smoothly it performs as well as the convenience of not having to leave the admin.</p>\n<p>My only concern is that, with the growing popularity of Unsplash, some of the photos begin to look cliché and commonplace after you&#8217;ve seen them used on dozens of sites across the web. Ultimately, the best and most unique photographs are the ones you take, because they are tied to your own experience and perspective.</p>\n<p>However, if you simply need to quickly prototype a design and want to have a bunch of nice images at your fingertips, <a href=\"https://wordpress.org/plugins/unsplash-stock-photo-library/\" target=\"_blank\">Unsplash WP</a> is an excellent plugin that will save you quite a bit of time. <a href=\"https://wordpress.org/plugins/unsplash-stock-photo-library/\" target=\"_blank\">Download</a> it for free from WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Oct 2014 22:27:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: Tickets Still Available to Watch The WordCamp San Francisco Live Stream\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32471\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"http://wptavern.com/tickets-still-available-to-watch-the-wordcamp-san-francisco-live-stream\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1901:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/wcsf.jpeg\" rel=\"prettyphoto[32471]\"><img class=\"aligncenter size-full wp-image-24984\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/wcsf.jpeg?resize=810%2C300\" alt=\"wcsf\" /></a></p>\n<p>This weekend, the annual WordPress conference known as <a title=\"http://2014.sf.wordcamp.org/\" href=\"http://2014.sf.wordcamp.org/\">WordCamp San Francisco</a> will take place. It&#8217;s the only conference to feature &#8220;The State of the Word&#8221; presented by Matt Mullenweg. If you can&#8217;t make it to the event, there are still plenty of <a title=\"http://2014.sf.wordcamp.org/tickets/\" href=\"http://2014.sf.wordcamp.org/tickets/\">live stream tickets</a> available.</p>\n<p>Live stream tickets cost $10 and allow you to enjoy the conference from the comfort of your home. However, if you buy a Live Stream Plus T-Shirt ticket for $18, you&#8217;ll receive a T-Shirt immediately following the event. When purchasing tickets, make sure you log into your <a title=\"https://wordcamp.org/wp-login.php?redirect_to=http%3A%2F%2F2014.sf.wordcamp.org%2Ftickets%2F\" href=\"https://wordcamp.org/wp-login.php?redirect_to=http%3A%2F%2F2014.sf.wordcamp.org%2Ftickets%2F\">WordPress.org account</a>.</p>\n<p>An alternative to purchasing a live stream ticket is to check your local WordPress meetup as several of them are having live stream watch parties. If you&#8217;re a meetup organizer having a viewing party, please add the event in the comments. You can also follow the event by monitoring the <a title=\"https://twitter.com/hashtag/wcsf\" href=\"https://twitter.com/hashtag/wcsf\">#wcsf</a> and <a title=\"https://twitter.com/hashtag/wcsf14\" href=\"https://twitter.com/hashtag/wcsf14\">#wcsf14</a> hashtags on Twitter.</p>\n<p>Sarah Gooding and I will be in attendance during the weekend of festivities so if you see us, stop and say hi.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Oct 2014 21:22:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WPTavern: BuddyPress 2.2 Will Add Support for Composer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32397\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wptavern.com/buddypress-2-2-will-add-support-for-composer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3355:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/composer-support-buddypress.jpg\" rel=\"prettyphoto[32397]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/composer-support-buddypress.jpg?resize=961%2C440\" alt=\"composer-support-buddypress\" class=\"aligncenter size-full wp-image-32418\" /></a></p>\n<p>BuddyPress lead developer <a href=\"http://byotos.com/\" target=\"_blank\">Paul Gibbs</a> committed <a href=\"https://buddypress.trac.wordpress.org/changeset/9088\" target=\"_blank\">support for Composer</a> to BuddyPress core this week. Developers who want to check it out can find the json file at: <a href=\"https://buddypress.trac.wordpress.org/browser/trunk/src/composer.json?rev=9088\" target=\"_blank\">trunk/src/composer.json</a>.</p>\n<p>If you&#8217;re not yet familiar with <a href=\"https://getcomposer.org\" target=\"_blank\">Composer</a>, it&#8217;s essentially a tool for dependency management in PHP. It is designed to manage packages on a per-project basis by bringing in any dependent libraries that you declare in the <code>composer.json</code> file. The dependencies are then automatically installed in a <code>vendor</code> directory or other specified location inside your project.</p>\n<p>BuddyPress is not yet listed on <a href=\"https://packagist.org/\" target=\"_blank\">Packagist.org</a> but should be added soon. Once it&#8217;s listed there, it can easily be declared as a dependency after the next version (2.2) is released.</p>\n<pre class=\"brush: plain; title: ; notranslate\">{\n    \"require\": {\n        \"buddypress/buddypress\": \"~2.2\"\n    }\n}</pre>\n<p>BuddyPress 2.2 is expected in mid-January 2015, according to Gibbs&#8217; reply in the <a href=\"https://buddypress.trac.wordpress.org/timeline?from=2014-10-22T08%3A12%3A09Z&precision=second\" target=\"_blank\">ticket</a> to add Composer. He plans to configure Packagist to pull from <a href=\"http://plugins.svn.wordpress.org/buddypress/\" target=\"_blank\">http://plugins.svn.wordpress.org/buddypress/</a>.</p>\n<p>Because BuddyPress is identified as a WordPress plugin in its json file (&#8220;type&#8221;: &#8220;wordpress-plugin&#8221;), composer/installers will by default send it to the wp-content/plugins directory.</p>\n<p>If you can&#8217;t wait two months, and you&#8217;re dying to use BuddyPress with Composer right now, there&#8217;s an alternative method. I spoke with WordPress <a href=\"http://composer.rarst.net/\" target=\"_blank\">Composer evangelist</a> Andrey Savchenko (<a href=\"https://twitter.com/rarst\" target=\"_blank\">@rarst</a>) regarding the news. He suggests that in the meantime developers could use <a href=\"http://wpackagist.org/\" target=\"_blank\">wpackagist</a>, which provides a mirror of the WordPress plugin and theme directories as a Composer repository.</p>\n<pre class=\"brush: plain; title: ; notranslate\">{\n \"require\"     : {\n  \"wpackagist-plugin/buddypress\": \"~2.1\"\n },\n \"repositories\": [\n  {\n   \"type\": \"composer\",\n   \"url\" : \"http://wpackagist.org\"\n  }\n ]\n}</pre>\n<p>If you search for &#8220;WordPress&#8221; on Packagist, you&#8217;ll find many other projects, which can also be easily added into your next BuddyPress project. Composer support makes it easy to create a master <code>composer.json</code> file for your projects, that will save you time by allowing you to load all of your dependencies in a matter of seconds.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Oct 2014 10:32:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: How to Increase or Decrease The Font Size in The Visual Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32400\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://wptavern.com/how-to-increase-or-decrease-the-font-size-in-the-visual-editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3068:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/VisualEditorFontSizeFeaturedImage.png\" rel=\"prettyphoto[32400]\"><img class=\"size-full wp-image-32423\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/VisualEditorFontSizeFeaturedImage.png?resize=640%2C200\" alt=\"Visual Editor Font Size Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/ush/3741182620/\">Mr Ush</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>If you use the visual editor to write posts or pages, you&#8217;ll know that the font can sometimes be hard to read due to its size. Some themes use a tiny font in the visual editor and unless you know how to apply CSS changes, you&#8217;re stuck with it. Luckily, there&#8217;s a plugin available specifically for the purpose of adjusting the font size in the visual editor called <a title=\"https://wordpress.org/plugins/visual-editor-font-size/\" href=\"https://wordpress.org/plugins/visual-editor-font-size/\">Visual Editor Font Size</a>.</p>\n<p>Developed by <a title=\"http://extrapolate.me/\" href=\"http://extrapolate.me/\">Nikolay Bachiyski</a>, Visual Editor Font Size adds a meta box to the post editor. After installing and activating the plugin, check the screen options on the post editor and make sure the box next to Visual Editor Font Size is checked. The meta box has a plus and minus button to increase or decrease the font size. There&#8217;s also a sample of text to indicate how large or small the font is and the revert link resets the text to the default size.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/VisualEditorFontSizeMetaBox.png\" rel=\"prettyphoto[32400]\"><img class=\"size-full wp-image-32411\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/VisualEditorFontSizeMetaBox.png?resize=783%2C334\" alt=\"Visual Editor Font Size Meta Box\" /></a>Visual Editor Font Size Meta Box\n<p>Although it works fine in WordPress 4.0, I&#8217;d rather see the size adjusting buttons added to the TinyMCE editor. The editor is the first place I look to manipulate content in the visual editor and when I didn&#8217;t see any additional buttons, I thought the plugin was broken. This plugin is great if you don&#8217;t have the CSS knowledge or access to make the appropriate changes, but it&#8217;s not the best way to solve the problem.</p>\n<p>If the theme you&#8217;re using doesn&#8217;t have a visual editor style applied to it, contact the author and send them <a title=\"http://codex.wordpress.org/Editor_Style\" href=\"http://codex.wordpress.org/Editor_Style\">this link</a>. It&#8217;s a Codex article that explains how to add a style to a theme specifically for the visual editor. When executed well, the content in the editor will look identical to what visitors see. <a title=\"http://themehybrid.com/themes/stargazer\" href=\"http://themehybrid.com/themes/stargazer\">Stargazer,</a> by Justin Tadlock, is an excellent example of a theme where the content in the visual editor is the same style that&#8217;s seen by visitors.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Oct 2014 09:36:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"WPTavern: Comparing The Photo Publishing Experience of WordPress For iOS to Facebook and Twitter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32379\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"http://wptavern.com/comparing-the-photo-publishing-experience-of-wordpress-for-ios-to-facebook-and-twitter\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5318:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/WelcomeHomeFeaturedImage.png\" rel=\"prettyphoto[32379]\"><img class=\"size-full wp-image-32387\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/WelcomeHomeFeaturedImage.png?resize=639%2C200\" alt=\"Welcome Home Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/angusf/2165904810/\">angusf</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>In late September, WordPress.com <a title=\"http://wptavern.com/wordpress-com-publishes-first-ever-video-ad-entitled-welcome-home\" href=\"http://wptavern.com/wordpress-com-publishes-first-ever-video-ad-entitled-welcome-home\">published the first in a series of short videos</a> that shows how easy it is to publish content from a mobile device. In the 15 second video entitled &#8220;<a title=\"https://www.youtube.com/watch?v=MfW2UJMIQvQ&feature=youtu.be\" href=\"https://www.youtube.com/watch?v=MfW2UJMIQvQ&feature=youtu.be\">Welcome Home,</a>&#8221; a user is seen taking photos with an iPhone in various locations. Near the end of the video, the user taps the WordPress mobile app icon and sees a post with one of the images captured by the phone. What&#8217;s not shown is the process of publishing the photo.</p>\n<p><span class=\"embed-youtube\"></span></p>\n<p>The take away from the video is that it&#8217;s easy to publish photos to WordPress.com from a mobile device. With that in mind, I was curious what it&#8217;s like to perform the same task with other social networks on a mobile device. The following is my experience using <a title=\"https://apps.wordpress.org/\" href=\"https://apps.wordpress.org/\">WordPress For iOS</a> for this specific task and how it compares to using Facebook and Twitter.</p>\n<h2>The WordPress For iOS Process</h2>\n<p>The first thing I do is take a photo with my phone. Next, I load the WordPress For iOS app. I tap the Pencil icon in the lower right corner and make sure to select my WordPress.com account. I give the post a title which is normally related to the image, then write some content. Writing a lot of content on the iPhone is not an ideal experience so I usually keep it short.</p>\n<p>Next, I add an image to the post. Selecting a photo from the phone and uploading it to WordPress is an easy task. After the photo is inserted, I head into the Options area. From here, I assign a Category and relevant Tags. I preview the post and if I like what I see, I tap the Publish button.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/DogInChair.png\" rel=\"prettyphoto[32379]\"><img class=\"wp-image-32384 size-large\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/DogInChair.png?resize=281%2C500\" alt=\"WordPress For iOS Post Preview\" /></a>WordPress For iOS Post Preview\n<p>While I&#8217;m not forced to assign a Category or Tags to posts, it&#8217;s a good practice and one I&#8217;ve already established with the site.</p>\n<h2>The Facebook on iOS Process</h2>\n<p>I open the Facebook app and select Photo. I&#8217;m given the choice to either select a photo from the phone&#8217;s media library or to take a picture. The ability to use the camera to take a photo for a post is a distinct difference between the Facebook app and WordPress. I usually have an image ready to publish but when I don&#8217;t, taking a photo within the app is a nice convenience. After selecting a photo, it&#8217;s uploaded to Facebook where I then add context for the image.</p>\n<p>With the Facebook app, I can add other data to the post such as location, the people I was with or who are in the photo, and my mood. Most of the time, the additional information doesn&#8217;t apply to my photo. After adding some context, I tap the Post button. Boiled down to the simplest procedure, I can publish a photo post on Facebook in five steps.</p>\n<ol>\n<li>Open App</li>\n<li>Select Photo</li>\n<li>Choose or Take Photo</li>\n<li>Apply Context</li>\n<li>Post</li>\n</ol>\n<p>I don&#8217;t have to worry about assigning a category or tags to Facebook posts.</p>\n<h2>The Twitter on iOS Process</h2>\n<p>I open the Twitter app and tap the button to write a new Tweet. I tap the button to add media and similar to Facebook, I can either choose from the phone&#8217;s media library or take a photo. After selecting an image, I add context, then tap the send button. I don&#8217;t have to worry about tags or categories.</p>\n<h2>Not The Simplest, But The Most Future Proof</h2>\n<p>WordPress For iOS isn&#8217;t the simplest way to share photos with the world but it&#8217;s the most future proof. It may be more work, but an added benefit to using WordPress.com is its <a title=\"http://en.support.wordpress.com/publicize/\" href=\"http://en.support.wordpress.com/publicize/\">Publicize feature</a>. When a post is published, WordPress.com can send it to both Twitter and Facebook. This is an ideal way to share photos to the widest possible audience while maintaining full control of your content.</p>\n<p>Facebook and Twitter are islands where you have no control and the carpet can be pulled out from under you. But at WordPress.com, you have a place to call your own and if you desire, you can pack up your content and leave. This is what the message &#8220;Welcome Home&#8221; means to me. What does it mean to you?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Oct 2014 08:30:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: Initiatives Being Developed Alongside WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32296\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wptavern.com/initiatives-being-developed-alongside-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6434:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/OpportunityFeaturedImage.png\" rel=\"prettyphoto[32296]\"><img class=\"size-full wp-image-32335\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/OpportunityFeaturedImage.png?resize=639%2C287\" alt=\"Opportunity Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/streamishmc/2340150187/\">{Guerrilla Futures | Jason Tester}</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nd/2.0/\">cc</a>\n<p>While it&#8217;s easy to focus on WordPress core development, there are a handful of satellite projects to keep an eye on. There is so much happening around the WordPress project, it&#8217;s tough to keep up. This post highlights some of the satellite projects and initiatives that are being developed concurrently with WordPress.</p>\n<h2>Feature Plugin: Improve Image Editing</h2>\n<p>Led by Siobhan McKeown, the <a title=\"https://make.wordpress.org/ui/2014/07/07/feature-plugin-improving-image-editing/\" href=\"https://make.wordpress.org/ui/2014/07/07/feature-plugin-improving-image-editing/\">Image Flow project</a> is aimed at improving the image editing experience in WordPress. It&#8217;s a feature that will likely not be removed, so the team is doing what it can to improve it. In the most recent meeting, the group <a title=\"https://make.wordpress.org/ui/2014/10/21/image-flow-update-21st-october-wireframe-discussion/\" href=\"https://make.wordpress.org/ui/2014/10/21/image-flow-update-21st-october-wireframe-discussion/\">discussed various wireframes</a> and will be making changes based on community feedback. The group meets every Friday and uses Google Hangout to conduct meetings.</p>\n<h2>Scalable Dropdowns</h2>\n<p>Created by Helen Hou-Sandi, the scalable dropdowns project is focused on addressing some long-standing issues with dropdowns in WordPress, specifically for <a title=\"https://core.trac.wordpress.org/ticket/19867\" href=\"https://core.trac.wordpress.org/ticket/19867\">users</a> and <a title=\"https://core.trac.wordpress.org/ticket/9864\" href=\"https://core.trac.wordpress.org/ticket/9864\">pages</a>. An <a title=\"https://irclogs.wordpress.org/chanlog.php?channel=wordpress-dev&day=2014-10-08&sort=asc#m936665\" href=\"https://irclogs.wordpress.org/chanlog.php?channel=wordpress-dev&day=2014-10-08&sort=asc#m936665\">initial meeting</a> has taken place on IRC and as a result, several issues have been <a title=\"https://github.com/helenhousandi/wp-19867-9864/issues\" href=\"https://github.com/helenhousandi/wp-19867-9864/issues\">opened on Github</a> for work and discussion. If you&#8217;re interested, review the issues on Github and contribute where you&#8217;re able to. Questions related to the project can be <a title=\"https://make.wordpress.org/core/2014/10/10/scalable-dropdowns-update/\" href=\"https://make.wordpress.org/core/2014/10/10/scalable-dropdowns-update/\">asked here</a>.</p>\n<h2>Meta, Date, and Taxonomy Query Improvements</h2>\n<p>Boone Gorges is <a title=\"https://make.wordpress.org/core/2014/10/02/meta-date-and-tax-query-improvements-in-wp-4-1/\" href=\"https://make.wordpress.org/core/2014/10/02/meta-date-and-tax-query-improvements-in-wp-4-1/\">leading the way</a> towards improving <code>WP_Meta_Query</code>, <code>WP_Tax_Query</code>, and <code>WP_Date_Query</code>. The improvements are slated for WordPress 4.1. According to a recent <a title=\"https://make.wordpress.org/core/2014/10/20/update-on-query-improvements-in-4-1/\" href=\"https://make.wordpress.org/core/2014/10/20/update-on-query-improvements-in-4-1/\">project update</a>, most of the proposed changes Gorges listed in the initial post have been made.</p>\n<h2>Inline Documentation</h2>\n<p>Shortly after WordCamp San Francisco 2013, the <a title=\"https://make.wordpress.org/core/tag/inline-docs/\" href=\"https://make.wordpress.org/core/tag/inline-docs/\">inline docs team</a> began working on providing inline documentation to every hook in WordPress. The team successfully completed documented every action and filter hook as part of the release of WordPress 3.9. In a <a title=\"https://make.wordpress.org/core/2014/09/29/were-discussing-js-docs-at-this-weeks-inline-docs-chat/\" href=\"https://make.wordpress.org/core/2014/09/29/were-discussing-js-docs-at-this-weeks-inline-docs-chat/\">recent meeting</a>, the group discussed options for adopting a documentation standard for core JavaScript.</p>\n<h2>WordPress Training</h2>\n<p>The <a title=\"https://make.wordpress.org/training/\" href=\"https://make.wordpress.org/training/\">training initiative</a> is a proposed <a title=\"http://make.wordpress.org/training/theme-curriculum/\" href=\"http://make.wordpress.org/training/theme-curriculum/\">curriculum</a> that covers everything from explaining what a theme is, to creating and altering child themes. The group is working on various training modules that make up each class. In their <a title=\"https://irclogs.wordpress.org/chanlog.php?channel=wordpress-getinvolved&day=2014-10-14&sort=asc\" href=\"https://irclogs.wordpress.org/chanlog.php?channel=wordpress-getinvolved&day=2014-10-14&sort=asc\">most recent meeting</a>, the group discussed the status of modules in progress, infrastructure for testing modules, and a team training sign up form. If you&#8217;re interested in contributing to this project, the team has meetings every <strong>Tuesday 18:00 UTC</strong> in the<strong> #wordpress-getinvolved</strong> IRC channel.</p>\n<h2>Opportunities to Contribute</h2>\n<p>I&#8217;ve only scratched the surface with the number of initiatives available to contribute to. Whether you have a special interest in <a title=\"http://make.wordpress.org/accessibility/\" href=\"http://make.wordpress.org/accessibility/\">accessibility</a>, <a title=\"http://make.wordpress.org/ui/\" href=\"http://make.wordpress.org/ui/\">UI</a>, <a title=\"http://make.wordpress.org/mobile/\" href=\"http://make.wordpress.org/mobile/\">mobile</a>, <a title=\"http://make.wordpress.org/support/\" href=\"http://make.wordpress.org/support/\">support</a>, <a title=\"http://make.wordpress.org/themes/\" href=\"http://make.wordpress.org/themes/\">themes</a>, or <a title=\"http://make.wordpress.org/polyglots/\" href=\"http://make.wordpress.org/polyglots/\">translations</a>, there&#8217;s a project that could use your help. The best way to stay informed of new and existing initiatives is visit <a title=\"https://make.wordpress.org/\" href=\"https://make.wordpress.org/\">Make.WordPress.org</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Oct 2014 04:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Matt: Retina 5k Mac\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44298\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://ma.tt/2014/10/retina-5k-mac/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2380:\"<p><img class=\"alignright  wp-image-44300\" src=\"http://i1.wp.com/ma.tt/files/2014/10/imac-retina-step1-hero-2014.jpeg?resize=354%2C213\" alt=\"imac-retina-step1-hero-2014\" /> To me one of the most meaningful shifts in computing the past few years has been how the resolution of displays is getting higher and higher, and interfaces are starting to become resolution independent. I feel like when pixels disappear there&#8217;s less of a wall between people and the technology, it starts to blend and meld a bit more. It&#8217;s something I&#8217;ve been personally passionate about since the first retina iPhone, tirelessly beating the drum at <a href=\"http://automattic.com/\">Automattic</a> to make everything we do shine on hi-DPI screens, or leading the <a href=\"https://wordpress.org/news/2013/12/parker/\">WordPress 3.8 release</a> that brought in MP6 project to make WordPress&#8217; aesthetics cleaner and vector-based.</p>\n<p>I&#8217;m sitting in front of a <a href=\"http://www.apple.com/imac-with-retina/\">Retina 5k iMac</a> right now typing this to you. (It was supposed to arrive on Friday but came a few days early.)</p>\n<p>It&#8217;s the most gorgeous desktop display I&#8217;ve ever seen, breathtaking at first and then like all great work becomes invisible and you forget that there was ever a time when displays weren&#8217;t this beautiful. (Until you look at some lesser monitor again.)</p>\n<p>I&#8217;ve been using 4k displays, <a href=\"http://smile.amazon.com/dp/B00LFNDLVG/\">the Sharp</a> and <a href=\"http://smile.amazon.com/dp/B00DJ4BIKA/\">the ASUS</a>, with Mac Pros for a few months now, and to be honest they come close, but this takes the cake in every possible way, including the design and aesthetics of the computer/display itself which is laptop-thin at the edges. If you&#8217;ve been on the fence, and you&#8217;re okay with the <a href=\"http://techcrunch.com/2014/10/20/retina-imac-review/\">tradeoffs an iMac has in general</a>, get one. I can&#8217;t wait for them to do a 5k Thunderbolt display (but it sounds like it <a href=\"http://www.slashgear.com/an-apple-thunderbolt-5k-display-dont-hold-your-breath-17351284/\">might be at least a year away</a>).</p>\n<p>P. S. If you&#8217;re looking for a gift for the iMac that has everything, <a href=\"http://www.hardgraft.com/collections/extras-1/imac\">consider a slipper to keep its feet warm</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Oct 2014 00:42:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WPTavern: Monster Widgets for bbPress and BuddyPress Make It Easy to Test Core Widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32267\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://wptavern.com/monster-widgets-for-bbpress-and-buddypress-make-it-easy-to-test-core-widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3265:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/monster.jpg\" rel=\"prettyphoto[32267]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/monster.jpg?resize=700%2C348\" alt=\"photo credit: massdistraction - cc\" class=\"size-full wp-image-32363\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/sharynmorrow/3019436/\">massdistraction</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a>\n<p>The original <a href=\"http://wptavern.com/monster-widget-a-useful-wordpress-theme-testing-tool\" target=\"_blank\">Monster Widget</a> plugin is a handy tool created by Automattic to assist theme developers with testing. Essentially, it allows you to quickly drop all core widgets into your sidebar at once, saving you the trouble of having to add them individually.</p>\n<p>Now you can get the same for bbPress and BuddyPress, thanks to a two new plugins from <a href=\"https://profiles.wordpress.org/mercime/\" target=\"_blank\">@mercime</a>, a contributor on both WordPress sister projects.</p>\n<p>The <a href=\"https://wordpress.org/plugins/buddypress-monster-widget/\" target=\"_blank\">BuddyPress Monster Widget</a> makes it easy to populate your sidebar with all of the BP core widgets, including the following:</p>\n<ul>\n<li>Log In</li>\n<li>Members</li>\n<li>Who&#8217;s Online</li>\n<li>Recently Active Members</li>\n<li>Friends</li>\n<li>Groups</li>\n<li>Sitewide Messages</li>\n<li>Recent Networkwide Posts</li>\n</ul>\n<p>The widgets are pre-configured to show a set number of blog posts, members, friends, etc. The list of widgets displayed can be altered by using the &#8216;buddypress-monster-widget-config&#8217; filter included in the plugin.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/buddypress-monster-widget.jpg\" rel=\"prettyphoto[32267]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/buddypress-monster-widget.jpg?resize=501%2C299\" alt=\"buddypress-monster-widget\" class=\"aligncenter size-full wp-image-32353\" /></a></p>\n<p>The <a href=\"https://wordpress.org/plugins/bbpress-monster-widget/\" target=\"_blank\">bbPress Monster Widget</a> plugin allows you to add all of the bbPress core widgets to your sidebar in one instance, including:</p>\n<ul>\n<li>Log In</li>\n<li>Forum Views</li>\n<li>Forum Search Form</li>\n<li>Forums</li>\n<li>Forum Topics</li>\n<li>Forum Statistics</li>\n<li>Forum Replies</li>\n</ul>\n<p>The bbPress Monster Widget also comes pre-configured with a set number of topics and replies displayed. The default list of widgets can be altered by using the &#8216;bbpress-monster-widget-config&#8217; filter.</p>\n<p>When creating a theme for public distribution, it&#8217;s important to make sure you know how the core widgets are going to look with your theme applied. This is especially true for community-oriented sites that utilize bbPress and BuddyPress, because the widgets often play a big part in connecting members to recent activity on the site. Download the <a href=\"https://wordpress.org/plugins/bbpress-monster-widget/\" target=\"_blank\">bbPress</a> and <a href=\"https://wordpress.org/plugins/buddypress-monster-widget/\" target=\"_blank\">BuddyPress</a> monster widgets from WordPress.org to make it quick and easy to test the core widgets.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Oct 2014 00:00:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"WPTavern: Compass: A Free Starter Theme for WordPress Built with Hybrid Core, Bourbon, and Neat\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32153\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"http://wptavern.com/free-compass-starter-theme-for-wordpress-built-with-hybrid-core-bourbon-and-neat\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6576:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/compass.jpg\" rel=\"prettyphoto[32153]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/compass.jpg?resize=1023%2C487\" alt=\"photo credit: Theresa Thompson - cc\" class=\"size-full wp-image-32316\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/theresasthompson/7163227255/\">Theresa Thompson</a> &#8211; <a href=\"http://creativecommons.org/licenses/by/2.0/\">cc</a>\n<p>The life of a frontend developer has changed a great deal over the past few years, with the introduction of new technologies for authoring CSS and automating tasks. We&#8217;re starting to see that trickle down into every new WordPress starter theme.</p>\n<p>These days you&#8217;ve got to <code>npm install allthiscrazystuff</code> just to get started on a project. Once you&#8217;ve gone through the setup, you&#8217;re ready to work more efficiently with many of the more boring tasks automated for you.</p>\n<p><a href=\"https://github.com/FlagshipWP/Compass\" target=\"_blank\">Compass</a> is a new WordPress starter theme that incorporates a host of modern web development technologies to help you create themes faster while staying in line with WordPress coding standards. The folks at <a href=\"http://flagshipwp.com/\" target=\"_blank\">Flagship</a>, a soon-to-launch theme shop, released Compass for free earlier this month, claiming that it is <strong>&#8220;the most advanced WordPress starter theme in existence.&#8221;</strong></p>\n<p><em>Note: The Compass theme name keeps with the company&#8217;s nautical vibe, but it&#8217;s not to be confused with the open source <a href=\"http://compass-style.org/\" target=\"_blank\">Compass</a> CSS framework built with Sass.</em></p>\n<p>Out of the box, the theme is fairly plain but, thankfully, not hideous. Obviously, it&#8217;s a starter theme, so the point is to provide the basics for getting started on your own beautiful creation.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/compass-starter-theme.jpg\" rel=\"prettyphoto[32153]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/compass-starter-theme.jpg?resize=690%2C375\" alt=\"compass-starter-theme\" class=\"aligncenter size-full wp-image-32319\" /></a></p>\n<h4>Sass, Bourbon, and Neat with Composer Support</h4>\n<p>Similar to the <a href=\"http://wptavern.com/some-like-it-neat-a-free-wordpress-starter-theme-built-with-underscores-bourbon-and-neat\" target=\"_blank\">Some Like It Neat</a> starter theme, Compass features support for <a href=\"http://sass-lang.com/\" target=\"_blank\">Sass</a>, <a href=\"http://bourbon.io/\" target=\"_blank\">Bourbon</a>, and <a href=\"http://neat.bourbon.io/\" target=\"_blank\">Neat</a>. The theme uses <a href=\"https://getcomposer.org/\" target=\"_blank\">Composer</a> to manage dependencies for PHP, allowing you to declare the dependent libraries for your specific project to have them installed for you.</p>\n<h4>Grunt</h4>\n<p>The Flagship team has worked hard to create what they believe to be the most advanced and robust <a href=\"http://gruntjs.com/\" target=\"_blank\">Grunt</a> workflow available for WordPress theme development. You&#8217;ll need to install <a href=\"http://nodejs.org/\" target=\"_blank\">Node.js</a> to run the Grunt task runner with the Compass theme, although many theme developers will likely already have it installed. Some of the tasks will also require external command-line applications, which you&#8217;ll need to install as global Node.js packages.</p>\n<p>Once you&#8217;re ready to roll, you&#8217;ll be able to automate an amazing number of tasks associated with theme development, including things like auto-prefixing CSS properties, tidying up style.css to match the WordPress Coding Standards, generating the RTL style sheet, optimizing images, and much more. Here&#8217;s a short sampling:</p>\n<ul>\n<li><code>grunt build:dependencies</code></li>\n<li><code>grunt build:css</code></li>\n<li><code>grunt build:font</code></li>\n<li><code>grunt build:images</code></li>\n<li><code>grunt build:js</code></li>\n<li><code>grunt build:i18n</code></li>\n<li><code>grunt check</code></li>\n<li><code>grunt package</code></li>\n</ul>\n<p>Check out the documentation on GitHub for the comprehensive <a href=\"https://github.com/FlagshipWP/Compass#tasks\" target=\"_blank\">list of available tasks</a> included in the Compass theme.</p>\n<h5>Hybrid Core</h5>\n<p>Compass is built on top of Justin Tadlock&#8217;s <a href=\"http://themehybrid.com/hybrid-core\" target=\"_blank\">Hybrid Core</a>, one of the oldest and most developer-friendly frameworks for building WordPress themes. The Compass release post explains why Flagship went with Hybrid Core:</p>\n<blockquote><p>There are so many things that are going to be necessary on nearly every project, and they’re regularly done poorly in many of the themes that we’ve used and tested. Justin has done an amazing job of doing things “the WordPress way” and has been building and iterating Hybrid Core for many years.</p></blockquote>\n<p>The framework handles functionality that most themes commonly require, such breadcrumbs, grabbing media, integrating microdata like schema.org, pagination, theme layouts, and translation.</p>\n<p>Like many other new starter themes, Compass also offers support for the <a href=\"https://github.com/zamoose/themehookalliance\" target=\"_blank\">Theme Hook Alliance</a> project in an effort to provide a common set of entry points for plugin and theme developers looking to extend the theme.</p>\n<p>Although Flagship hasn&#8217;t yet officially launched, the site shows a preview of a few planned themes that were built using Compass as a starter theme.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/flagship-themes.jpg\" rel=\"prettyphoto[32153]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/flagship-themes.jpg?resize=962%2C418\" alt=\"flagship-themes\" class=\"aligncenter size-full wp-image-32305\" /></a></p>\n<p>The theme shop will soon launch with a unique pricing model that doesn&#8217;t involve bundle or theme club pricing. Each theme is priced at $199, with a $99 annual fee for support. The Compass starter theme that they use to build all of their products is open source and available to developers for free on <a href=\"https://github.com/FlagshipWP/Compass\" target=\"_blank\">GitHub</a>. Check out the <a href=\"http://community.flagshipwp.com/t/getting-started/37\" target=\"_blank\">Getting Started</a> guide for documentation, including video tutorials on installing the tools and working with Compass.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Oct 2014 19:40:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: Easily Edit a Post or Page Using The Slash Edit Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32149\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://wptavern.com/easily-edit-a-post-or-page-using-the-slash-edit-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2060:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/SlashEditFeaturedImage.png\" rel=\"prettyphoto[32149]\"><img class=\"aligncenter size-full wp-image-32264\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/SlashEditFeaturedImage.png?resize=650%2C200\" alt=\"Slash Edit Featured Image\" /></a></p>\n<p>If you&#8217;re not a fan of the admin bar or it&#8217;s disabled and you want a shortcut to edit posts in WordPress, you might be interested in a new plugin called <a title=\"https://wordpress.org/plugins/slash-edit/\" href=\"https://wordpress.org/plugins/slash-edit/\">Slash Edit</a>. Developed by <a title=\"http://www.ronalfy.com/\" href=\"http://www.ronalfy.com/\">Ronald Huereca</a>, Slash Edit adds the ability to edit the following items by adding <strong>/edit</strong> to the end of a url.</p>\n<ul>\n<li>Posts</li>\n<li>Pages</li>\n<li>Custom Post Types</li>\n<li>Author and Taxonomy Archives</li>\n</ul>\n<p>To load the appropriate editing interface, visit a post or page while logged into WordPress and add <strong>/edit</strong> to the end of the url. It can also be used as a shortcut to login to the backend of WordPress.</p>\n<p>Huereca works in an environment where the admin bar is consistently disabled. He created the plugin to provide a convenient way to edit pages or posts without having to search for them in the backend. &#8220;I thought, wouldn&#8217;t it be cool to just add &#8220;/edit&#8221; to the end of a post or page and be redirected to the right place in the admin panel?&#8221;</p>\n<p>Huereca doesn&#8217;t know what else could be added to the plugin to fulfill its basic purpose. &#8220;I&#8217;m not sure how much farther this plugin can go, but the WordPress community is ingenious as far as feature requests, so I&#8217;m eager to get feedback on the base feature set.&#8221; I tested the plugin on WordPress 4.0 and it works as advertised. To keep tabs on development, you can <a title=\"https://github.com/ronalfy/slash-edit\" href=\"https://github.com/ronalfy/slash-edit\">follow the project</a> on Github.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Oct 2014 03:06:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Jason Schuller to Re-Enter WordPress Theme Market with Niche Admin Designs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32202\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://wptavern.com/jason-schuller-to-re-enter-wordpress-theme-market-with-niche-admin-designs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7575:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/pickle-preview.jpg\" rel=\"prettyphoto[32202]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/pickle-preview.jpg?resize=972%2C462\" alt=\"pickle-preview\" class=\"aligncenter size-full wp-image-32216\" /></a></p>\n<p><a href=\"http://jason.sc/\" target=\"_blank\">Jason Schuller</a>, the original founder of the <a href=\"http://press75.com/\" target=\"_blank\">Press75</a> theme company, has been off the radar for a few years as he pursued experiments with alternative publishing platforms. He officially exited the commercial WordPress theme business earlier this year when <a href=\"http://wptavern.com/press75-acquired-by-westwerk-for-undisclosed-amount\" target=\"_blank\">Press75 was acquired by Westwerk</a>, following a sharp decline in the shop&#8217;s monthly revenue.</p>\n<p>Prior to selling his company, Schuller had begun to focus more on his experimental projects, <a href=\"http://dropplets.com/\" target=\"_blank\">Dropplets</a>, <a href=\"https://leeflets.com/\" target=\"_blank\">Leeflets</a>, and <a href=\"https://cinemati.co/\" target=\"_blank\">Cinematico</a>. Over the years, he had become disillusioned with the software, as he watched WordPress become increasingly more complex. This frustration, coupled with the weight of complex frameworks that started devouring the WordPress theme market, essentially vaporized his passion for the software and pushed him out to make something new.</p>\n<p>Earlier this year, in an <a href=\"http://wptavern.com/interview-with-jason-schuller-founder-of-press75-com\" target=\"_blank\">interview</a> with Jeff Chandler, Schuller expressed his dissatisfaction with trying to make WordPress do what he wanted and said that he wouldn&#8217;t be concentrating his efforts on WordPress in the immediate future.</p>\n<h3>Video Preview of Custom WordPress Admin for the &#8220;Pickle&#8221; Project</h3>\n<p>In his never-ending quest to simplify publishing online, Schuller has once again picked up WordPress to experiment with creating a radically simplified admin design for <a href=\"https://leeflets.com/templates?template=pickle\" target=\"_blank\">Pickle</a>, his restaurant-themed HTML template.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>A short video preview of my <a href=\"https://twitter.com/hashtag/WordPress?src=hash\">#WordPress</a> admin redesign for “Pickle”: <a href=\"http://t.co/lvQtgIaAWP\">http://t.co/lvQtgIaAWP</a> <a href=\"https://twitter.com/hashtag/design?src=hash\">#design</a></p>\n<p>&mdash; Jason Schuller (@jschuller) <a href=\"https://twitter.com/jschuller/status/524235736166330368\">October 20, 2014</a></p></blockquote>\n<p></p>\n<p>Traditionally, making a template like that editable in WordPress ends up being a complex thing for your average user to navigate in the admin. The <a href=\"http://jason.sc/pickle-preview\" target=\"_blank\">preview video</a> shows how Schuller has re-imagined the admin for his niche one page template.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/pickle-admin.jpg\" rel=\"prettyphoto[32202]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/pickle-admin.jpg?resize=964%2C520\" alt=\"pickle-admin\" class=\"aligncenter size-full wp-image-32235\" /></a></p>\n<p>He has essentially removed the admin, de-registered all the styles and many of the components, in an effort to create a custom CMS for this particular template. The result is a better correlation between the content editing experience and the actual website, with simplified action buttons.</p>\n<p>If you watch the preview, you&#8217;ll hear Schuller summarize why he created the simplified admin:</p>\n<blockquote><p>This is my biggest issue with WordPress right now. It doesn&#8217;t scale backward for minimalist websites like this. The CMS should reflect, in my opinion, what you&#8217;re trying to accomplish with your website, and all of these unnecessary components of WordPress just really don&#8217;t need to be here unless you need them for what you&#8217;re trying to accomplish.</p></blockquote>\n<p>Schuller said that it took him approximately two days to customize the WordPress admin to suit his template. <strong>&#8220;I&#8217;m nearly finished with it. It’s going to launch as a downloadable theme first and then I’ll be launching a hosted version as well,&#8221;</strong> he said.</p>\n<p>The theme will not be launching on Leeflets but rather on a new domain, yet to be determined, bringing Schuller back into the WordPress theme market. Why is he returning?</p>\n<p>&#8220;With this particular project, I really just wanted to get my vision out of my head as quick as possible,&#8221; he said. &#8220;With that in mind, I couldn&#8217;t see creating a custom CMS just for Pickle, so I figured WordPress would be the best way to do that quickly. Plus, you still can’t ignore WordPress’s reach.&#8221;</p>\n<p>I asked Schuller if the Pickle admin theme is a one time project or if he plans to create more niche admin themes to accompany his designs. &#8220;If Pickle goes well, I have a few other niche admins in mind for specific templates,&#8221; he replied.</p>\n<p><strong>&#8220;My goal is really simple &#8211; to help my customers/users create and manage websites. If WordPress helps me do that in an efficient way, I’m all for it. But I’ll be doing it my way this time around,&#8221;</strong> he emphasized.</p>\n<p>Schuller&#8217;s minimalist approach to the WordPress admin is something that he hopes will be easier for his target market to wrap their brains around. The popularity of the Pickle template is what spurred him on to create an editable version using WordPress. &#8220;I wasn’t expecting much when I released the Pickle HTML template,&#8221; he said. &#8220;But it was an instant hit. There are quite a few people helping restaurants create websites with it. That’s what triggered the idea to make a WordPress version.&#8221;</p>\n<p>At the moment Schuller is in touch with his market on a very small scale, but he hopes that it will expand with a successful launch of the Pickle theme. &#8220;My hope is that the WordPress version makes it even more enticing for businesses looking for a minimalist website/solution.&#8221;</p>\n<p>Schuller has identified a problem that many developers are hoping to solve. WordPress core is moving towards bridging the separation between the editing experience and the display of the content, with improvements to the customizer and experimental projects like the frontend editor. Others hope that the new JSON REST API will make it easier for developers to create custom admins.</p>\n<p>These changes cannot come soon enough, but will they be fully able to provide a more natural editing experience for users? Those, like Schuller, who have wrestled with dissatisfaction, have a decent shot at creating a revolutionary editing experience for the 10 year old platform. His inspiring work on the Pickle admin breaks WordPress out of the box and forces developers to look at the content editing experience in a new way.</p>\n<p>A more modular admin that can easily be scaled back for minimalist websites is something that would allow developers to truly customize the CMS for any niche template or project. The WordPress admin then becomes a chameleon of sorts, able to disappear into its surroundings with the content in focus. Schuller&#8217;s <a href=\"http://jason.sc/pickle-preview\" target=\"_blank\">Pickle experiment</a> is a good example of this, and likely part of a trend that we&#8217;ll see more in the future.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 20 Oct 2014 22:14:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: The First “Rate and Review a Plugin Day” is a Success\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32151\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wptavern.com/the-first-rate-and-review-a-plugin-day-is-a-success\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7981:\"<p>Thanks to everyone who participated in the first &#8220;<a title=\"http://wptavern.com/rate-and-review-a-wordpress-plugin-day-set-for-october-17th\" href=\"http://wptavern.com/rate-and-review-a-wordpress-plugin-day-set-for-october-17th\">Rate and Review a plugin day&#8221;</a>. After reviewing the #<a title=\"https://twitter.com/hashtag/wppluginreviewday?src=hash\" href=\"https://twitter.com/hashtag/wppluginreviewday?src=hash\">wppluginreviewday</a> hashtag on Twitter, it&#8217;s clear that a lot of people submitted reviews to their favorite plugins. Based on an <a title=\"https://twitter.com/richardtape/status/523331218973405184\" href=\"https://twitter.com/richardtape/status/523331218973405184\">estimate by Richard Tape</a>, 455 reviews were published on October 17th. When compared to 254 reviews on October 16th, that&#8217;s an increase of 180%. Here are a few noteworthy mentions of the hashtag in action.</p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>Wrote a review for <a href=\"https://twitter.com/eddwp\">@eddwp</a> here <a href=\"https://t.co/zvwWNJaGtu\">https://t.co/zvwWNJaGtu</a> Awesome feeling! <a href=\"https://twitter.com/hashtag/wppluginreviewday?src=hash\">#wppluginreviewday</a></p>\n<p>&mdash; Bharath Mandava  (@_mandava) <a href=\"https://twitter.com/_mandava/status/523321112222900225\">October 18, 2014</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>So I delivered a plugin review on .org today. <a href=\"http://t.co/4ua0iG0XjQ\">http://t.co/4ua0iG0XjQ</a> <a href=\"https://twitter.com/hashtag/wppluginreviewday?src=hash\">#wppluginreviewday</a> /cc: <a href=\"https://twitter.com/stevengliebe\">@stevengliebe</a> :)</p>\n<p>&mdash; David Decker (@deckerweb) <a href=\"https://twitter.com/deckerweb/status/523217428311191552\">October 17, 2014</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\" width=\"550\"><p>For Rate &amp; Review a <a href=\"https://twitter.com/hashtag/WordPress?src=hash\">#WordPress</a> Plugin Day I gave kudos to <a href=\"https://twitter.com/iThemesSecurity\">@iThemesSecurity</a> <a href=\"https://twitter.com/hashtag/wppluginreviewday?src=hash\">#wppluginreviewday</a></p>\n<p>&mdash; BobWP (@bobWP) <a href=\"https://twitter.com/bobWP/status/523121578268041216\">October 17, 2014</a></p></blockquote>\n<p></p>\n<h2>Observations I Made While Submitting Reviews</h2>\n<p>It took 90 minutes to rate and review the plugins I&#8217;ve depended on for years. I noticed some of the plugins haven&#8217;t been updated since 2010. In some cases, the last review a plugin received was from 2012 or earlier.</p>\n<p>When I announced the holiday, I asked users to browse to the bottom of the plugin’s description page and click on the <em>broken</em> or <em>works</em> box. As I submitted my reviews, I forgot about the compatibility box. When submitting a review, there is a drop down menu to select which version of WordPress I&#8217;m using. I used this in combination with my review to tell people if the plugin works or not.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/WPPluginReviewSubmissionForm.png\" rel=\"prettyphoto[32151]\"><img class=\"size-full wp-image-32152\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/WPPluginReviewSubmissionForm.png?resize=752%2C502\" alt=\"WordPress Plugin Review Submission Form\" /></a>WordPress Plugin Review Submission Form\n<p>Clicking the works or doesn&#8217;t work button is an easy task but it&#8217;s a <strong>separate action</strong> from submitting a review. It&#8217;s also the last widget on the description page and depending on the length of the description, may be hidden from view. I suggest merging the compatibility box into the process of submitting a review so it&#8217;s one action. Even though submitting compatibility information can be as simple as pressing a mouse button, not many do it.</p>\n<h2>The Disconnect Between WordPress.org and The Backend of WordPress</h2>\n<p>Your ratings, reviews, and compatibility checks are contributions to WordPress. It’s actionable data that millions of people use to determine whether or not to use a plugin. The backend of WordPress is an area millions of users interact with yet, the option to rate and review plugins as well as submit compatibility information doesn&#8217;t exist. The plugin details modal doesn&#8217;t show the compatibility box on the plugin&#8217;s description page and although you can read reviews, you can&#8217;t rate or review plugins.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/PluginDetailsModal.png\" rel=\"prettyphoto[32151]\"><img class=\"size-full wp-image-32173\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/PluginDetailsModal.png?resize=684%2C723\" alt=\"Current Plugin Details Modal\" /></a>Plugin Details Modal\n<p>The plugin management page in WordPress hasn&#8217;t seen a visual upgrade in a long time. Here&#8217;s what it looks like in WordPress 4.0.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/PluginManagementPage.png\" rel=\"prettyphoto[32151]\"><img class=\"size-full wp-image-32176\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/PluginManagementPage.png?resize=1025%2C530\" alt=\"WordPress 4.0 Plugin Management Page\" /></a>WordPress 4.0 Plugin Management Page\n<p>WordPress 3.9 <a title=\"http://wptavern.com/wordpress-4-0-benny-now-available-for-download\" href=\"http://wptavern.com/wordpress-4-0-benny-now-available-for-download\">revamped the theme browsing experience</a> while 4.0 introduced a refreshed <a title=\"http://wptavern.com/wordpress-4-0-benny-now-available-for-download\" href=\"http://wptavern.com/wordpress-4-0-benny-now-available-for-download\">plugin install and search experience</a>. Perhaps it&#8217;s time to refresh the plugin management page. One suggestion is to create two different list views. The management page in 4.0 could be the slim, detailed view. The enhanced view could use the card concept as seen on the Add Plugins page. Instead of displaying the crowd sourced information, you&#8217;d be able to rate and review the plugin and submit compatibility info from within the card.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/WordPressAddNewPluginCards.png\" rel=\"prettyphoto[32151]\"><img class=\"size-full wp-image-32179\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/WordPressAddNewPluginCards.png?resize=1025%2C485\" alt=\"WordPress 4.0 Plugin Cards\" /></a>WordPress 4.0 Plugin Cards\n<p>The problem with two different views is that a sub-set of users wouldn&#8217;t see the card view and stick with the default. In order to maximize the potential of obtaining crowd sourced data, the submission points have to be accessible by as many people as possible.</p>\n<h2>Tighter Integration Between The Backend and WordPress.org</h2>\n<p>In order to submit ratings and reviews, you need to be logged into a WordPress.org user account. I&#8217;m unsure on how to properly address this issue. One idea is for WordPress to provide a connection similar to Jetpack where I connect a WordPress powered site to my WordPress.org account. This could also act as an opt-in mechanism. Ultimately, I&#8217;d like to see better integration between the WordPress backend and the WordPress.org website.</p>\n<p>I&#8217;m not advocating that I be able to browse the WordPress.org website from the backend of WordPress, that&#8217;s what browsers are for. I see plenty of opportunities to connect certain actions on WordPress.org to the backend of WordPress, such as the ability to create a forum post to receive support.</p>\n<h2>A New Annual Tradition</h2>\n<p>While you don&#8217;t need a special day to review plugins, it&#8217;s a unique feeling to do something so many others across the world are doing at the same time. I&#8217;m encouraged to see so many people who have rated and reviewed their favorite plugins. Based on the feedback we&#8217;ve received, this will likely become an annual tradition.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 20 Oct 2014 18:54:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"WPTavern: Some Like It Neat: A Free WordPress Starter Theme Built with Underscores, Bourbon, and Neat\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32135\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:108:\"http://wptavern.com/some-like-it-neat-a-free-wordpress-starter-theme-built-with-underscores-bourbon-and-neat\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6075:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/bourbon-neat.jpg\" rel=\"prettyphoto[32135]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/bourbon-neat.jpg?resize=1024%2C488\" alt=\"photo credit: j03 - cc\" class=\"size-full wp-image-32137\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/j03/2035547120/\">j03</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc/2.0/\">cc</a>\n<p><a href=\"https://wordpress.org/themes/some-like-it-neat\" target=\"_blank\">Some Like it Neat</a> is a new starter theme for WordPress, based on the popular ultra-minimal <a href=\"http://underscores.me\" target=\"_blank\">Underscores</a> theme. It also incorporates <a href=\"http://bourbon.io\" target=\"_blank\">Bourbon</a>, a lightweight mixin library for <a href=\"http://sass-lang.com/\" target=\"_blank\">Sass</a>. On top of that it adds <a href=\"http://neat.bourbon.io\" target=\"_blank\">Neat</a>, which applies a semantic grid framework for Sass and Bourbon, enabling you to build any responsive layout that you can dream up.</p>\n<p>Since Some Like It Neat is a simple starter theme, there&#8217;s not much to see in the screenshot, apart from a relatively blank canvas, waiting to be shaped and styled.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/some-like-it-neat.png\" rel=\"prettyphoto[32135]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/some-like-it-neat.png?resize=880%2C660\" alt=\"some-like-it-neat\" class=\"aligncenter size-full wp-image-32140\" /></a></p>\n<p>The power of this theme lies in the tools that it incorporates. Some Like It Neat expedites the creation of a modern frontend development workflow for WordPress theming with responsive grids and a few prepackaged styles. The theme offers support for the following tools:</p>\n<ul>\n<li><a href=\"http://bourbon.io/\" target=\"_blank\">Bourbon</a>: A simple and lightweight mixin library for Sass</li>\n<li><a href=\"http://neat.bourbon.io\" target=\"_blank\">Neat</a>: A lightweight semantic grid framework for Sass and Bourbon</li>\n<li><a href=\"http://bitters.bourbon.io/\" target=\"_blank\">Bitters</a>: Scaffold styles, variables and structure for Bourbon projects</li>\n<li><a href=\"http://refills.bourbon.io/\" target=\"_blank\">Refills</a>: Prepackaged patterns and components, built on top of Bourbon, Bitters, and Neat</li>\n<li><a href=\"http://bower.io/\" target=\"_blank\">Bower</a>: A frontend package manager</li>\n</ul>\n<p>This is essentially everything you need for a Bourbon-soaked development workflow. Developers starting with this theme should already be familiar with Sass, since it&#8217;s the foundation for using Bourbon and Neat. If you need a Sass primer, Sitepoint has a great <a href=\"http://www.sitepoint.com/sass-for-wordpress-developers/\" target=\"_blank\">tutorial</a> on the basics. WP Beginner also has a <a href=\"http://www.wpbeginner.com/wp-tutorials/introduction-to-sass-for-new-wordpress-theme-designers/\" target=\"_blank\">quick introduction</a> to help WordPress theme designers get started with Sass.</p>\n<p>Some Like It Neat also allows for <a href=\"http://gulpjs.com/\" target=\"_blank\">Gulp.js</a> task automation. <a href=\"http://alexhasnicehair.com/\" target=\"_blank\">Alex Vasquez</a>, the theme&#8217;s creator, says that this feature still has room for improvement. The theme currently includes support for the following tasks:</p>\n<ul>\n<li><code>gulp watch</code> &#8211; Starts up Gulp and watches your scss, js and php folder for changes, writes them out and refreshes the browser for you</li>\n<li><code>gulp build</code> &#8211; Removes unnecessary files and packs up the required files into a nice and neat, installable, zip package</li>\n</ul>\n<p>Additionally, Some Like It Neat adds support for the <a href=\"https://github.com/zamoose/themehookalliance\" target=\"_blank\">Theme Hook Alliance</a> (THA), a community-driven project that offers a standardized set of third-party action hooks to theme developers to implement for more flexibility. THA has a growing list of <a href=\"https://github.com/zamoose/themehookalliance#tha-compatible-themes\" target=\"_blank\">compatible themes</a>. Vasquez opted for adding it to help keep things within the theme cleaner and easier to maintain.</p>\n<h3>Why Use Bourbon and Neat?</h3>\n<p>Incorporating Bourbon and its parallel projects into your WordPress theme is a matter of personal preference. In the past, Vasquez had used frontend frameworks such as Bootstrap and Foundation, but after discovering Bourbon+Neat, he found that it gave him a more efficient approach to theme creation:</p>\n<blockquote><p>To achieve the responsiveness required of various projects, I would have to tear up my HTML, input my own selector classes and what have you, in addition to changing my CSS. I didn&#8217;t like it. I heard about <a href=\"http://neat.bourbon.io\" target=\"_blank\">Neat</a> and really liked its approach to a grid framework. You keep your HTML structure the way you like and all of the styling in your Sass files.</p></blockquote>\n<p>If that sounds like a better workflow for you, then you may want to set aside some time to give this starter theme a try. It can be used  as a parent theme from which you create a highly customized child theme. Vasquez has outlined how to <a href=\"https://github.com/digisavvy/some-like-it-neat#getting-started\" target=\"_blank\">get started</a> in the documentation, which will walk you through installing Node, Sass, Gulp.js, etc. He also posted a handy <a href=\"https://github.com/digisavvy/some-like-it-neat#folder-structure\" target=\"_blank\">folder structure</a> as an example for how projects are structured with the starter theme.</p>\n<p><a href=\"https://wordpress.org/themes/some-like-it-neat\" target=\"_blank\">Some Like It Neat</a> is <a href=\"http://alexhasnicehair.com/\" target=\"_blank\">Alex Vasquez</a>&#8216;s first submission to the official WordPress Themes Directory. You can download it via your admin theme browser or from its <a href=\"https://github.com/digisavvy/some-like-it-neat\" target=\"_blank\">GitHub</a> repository.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 20 Oct 2014 18:04:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"Matt: Life and Work at the Distributed Wonderland\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44293\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"http://ma.tt/2014/10/life-and-work-at-the-distributed-wonderland/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:229:\"<p>Luca Sartoni writes <a href=\"http://lucasartoni.com/2014/10/14/how-i-fell-into-the-rabbit-hole-life-and-work-at-the-distributed-wonderland/\">How I fell into the rabbit hole: life and work at the distributed wonderland</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 20 Oct 2014 16:26:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Matt: Run Better\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44263\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://ma.tt/2014/10/run-better/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:544:\"<p>Joe Boydston, the self-described &#8220;crazy running guy&#8221; who runs as far as 90+ miles from the airport to WordCamps or meetups when he lands, has <a href=\"http://crazyrunningguy.wordpress.com/2014/10/06/run-better/\">written a bit about how to run better</a>. At our <a href=\"http://ma.tt/2014/09/automattic-grand-meetup-2014/\">company meetup</a> he ran running workshops and coached a lot of people including myself, and applying his suggestions <a href=\"http://ma.tt/2014/10/streak/\">I&#8217;ve been able to do a lot better</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 19 Oct 2014 23:51:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Matt: Pink Drill Bits\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44261\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"http://ma.tt/2014/10/pink-drill-bits/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:335:\"<p><a href=\"http://www.salon.com/2014/10/08/susan_g_komen_teams_up_with_fracking_company_introduces_pink_drill_bits_for_the_cure/\">Fracking company teams up with Susan G. Komen, introduces pink drill bits for the cure</a>, presented without comment. <cite>Hat tip: <a href=\"http://spitfirestrategies.com/\">Kristin Grimm</a>.</cite></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 18 Oct 2014 23:27:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Themosis Object-Oriented Development Framework for WordPress Now Available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://wptavern.com/themosis-object-oriented-development-framework-for-wordpress-now-available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4107:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/07/routes.png\" rel=\"prettyphoto[32082]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/07/routes.png?resize=1025%2C598\" alt=\"routes\" class=\"aligncenter size-full wp-image-26649\" /></a></p>\n<p>Version 1.0 of the <a href=\"http://wptavern.com/themosis-object-oriented-development-framework-for-wordpress-now-in-beta\" target=\"_blank\">Themosis development framework</a> is now available. Belgium-based application developer <a href=\"http://jlambe.be/\" target=\"_blank\">Julien Lambé</a> created Themosis in order to accelerate object-oriented development with WordPress. It offers a routing system for managing WordPress behavior on an application level and also includes a Laravel-esque templating engine for view files. Last week Lambé announced that the framework is now out of beta and ready for public use.</p>\n<p><a href=\"http://framework.themosis.com/\" target=\"_blank\">Themosis</a>, which Lambé describes as <strong>“a mix between WordPress best practices and a typical MVC framework,”</strong> has evolved considerably since its beta period. Version 1.0 includes dozens of improvements based on developer feedback.</p>\n<p>The website has been updated to provide complete <a href=\"http://framework.themosis.com/docs/\" target=\"_blank\">documentation</a> and code examples to help developers get started. <a href=\"http://framework.themosis.com/docs/installation/\" target=\"_blank\">Installation</a> is quick and easy, as Themosis uses <a href=\"https://getcomposer.org/\" target=\"_blank\">Composer</a> for dependency package management, so you can install and update everything needed in a matter of seconds. The framework is designed with respect to WordPress best practices and should work seamlessly with its APIs and plugins.</p>\n<p>Themosis comes with local and production environments pre-configured in order to facilitate collaboration. Once you register your database credentials and application URLS, you&#8217;ll be able to define the different environment configurations, making it easy to move between development and production.</p>\n<p>The <a href=\"http://framework.themosis.com/docs/framework/\" target=\"_blank\">framework guide</a> contains everything you need to know to get started structuring and building your application. The <a href=\"http://framework.themosis.com/docs/routing/\" target=\"_blank\">route API</a> docs cover all the conditional tags available with code samples for basic routing methods. Lambé describes the route system as &#8220;an enhanced &#8216;if&#8217; statement,&#8221; which is essentially based on WordPress conditional template tags and a closure callback.</p>\n<p>The framework includes classes for handling AJAX requests, custom post types, metaboxes, custom fields, taxonomies, options, validation, and more. It also adds a unique set of <a href=\"http://framework.themosis.com/docs/helpers/\" target=\"_blank\">Helpers</a> which act as framework utility functions that run on the global scope.</p>\n<p>Lambé has now separated the <a href=\"http://www.themosis.com/\" target=\"_blank\">Themosis studio</a> from the framework, which can be found at <a href=\"http://framework.themosis.com\" target=\"_blank\">framework.themosis.com</a>. He is launching a Themosis web agency, specializing in WordPress design and development, in order to fund future development of the framework to ensure its future.</p>\n<p>The Themosis framework is an interesting option that could be very helpful for new WordPress developers, especially those who are used to using Laravel or those who simply want to structure and organize their code like a typical MVC framework. It provides another avenue for getting started using a structure that may be more approachable for PHP developers who are new to working with WordPress.</p>\n<p>Themosis is an open source tool that Lambé decided to share with the community, and it will remain free to use. If you want to contribute to the project or report any issues, the framework can also be found on <a href=\"https://github.com/themosis/\" target=\"_blank\">GitHub</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Oct 2014 22:27:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WPTavern: Watch The Q&amp;A Session Between Matt Mullenweg and Om Malik From WordCamp Europe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32059\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"http://wptavern.com/watch-the-qa-session-between-matt-mullenweg-and-om-malik-from-wordcamp-europe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1950:\"<p>Some of the sessions recorded at <a title=\"http://wordpress.tv/event/wordcamp-europe-2014/\" href=\"http://wordpress.tv/event/wordcamp-europe-2014/\">WordCamp Europe</a> are now available to watch on <a title=\"http://wordpress.tv\" href=\"http://wordpress.tv\">WordPress.TV</a>. The rest of the sessions will be added in the coming weeks. Included in the first batch of videos is the <a title=\"http://wordpress.tv/2014/10/03/matt-mullenweg-om-malik-qa/\" href=\"http://wordpress.tv/2014/10/03/matt-mullenweg-om-malik-qa/\">question and answer session</a> between Matt Mullenweg and Om Malik.</p>\n<p>The session is an hour long and includes Mullenweg&#8217;s thoughts on the current status of WordPress, the media library, and what the platform may evolve into. One of the questions asked during the session is the role of women in the WordPress ecosystem.</p>\n<p>At the 47 minute mark, you can hear the infamous &#8220;we love women&#8221; comment from a member of the audience. Mullenweg responds with &#8220;come onnnnn&#8221; with applause from the audience. Helen Hou-Sandí, who lead the release of WordPress 4.0, explains why saying &#8220;we love women&#8221; can cause <a title=\"http://helenhousandi.com/2014/09/unintentional-destruction/\" href=\"http://helenhousandi.com/2014/09/unintentional-destruction/\">unintentional destruction</a>.</p>\n<p>Near the 53:40 minute mark, Mullenweg is asked, &#8220;How much should WordPress businesses be contributing to WordPress and involved with the project?&#8221; This is the question that prompted the 5% figure and his post, <a title=\"http://ma.tt/2014/09/five-for-the-future/\" href=\"http://ma.tt/2014/09/five-for-the-future/\">Five for the Future</a>.</p>\n<p></p>\n<p>This is a great session filled with information related to WordPress, Automattic, open source in general, and the future of the platform. If you attended the session live or watched the video, let us know your thoughts in the comments.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Oct 2014 18:36:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Matt: Moving into Management\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44170\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://ma.tt/2014/10/moving-into-management/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:384:\"<p>&#8220;The biggest misconception engineers have when thinking about moving into management is they think it&#8217;s a promotion.&#8221; &#8212; Lindsay Holmwood writes <a href=\"http://fractio.nl/2014/09/19/not-a-promotion-a-career-change/\">It&#8217;s not a promotion &#8211; it&#8217;s a career change</a>. <cite>Hat tip: <a href=\"http://pento.net/\">Gary Pendergast</a>.</cite></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Oct 2014 18:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: New Plugin Adds Open Source Emoji One Support to WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=31456\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://wptavern.com/new-plugin-adds-open-source-emoji-one-support-to-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4669:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/09/emoji-one.jpg\" rel=\"prettyphoto[31456]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/09/emoji-one.jpg?resize=831%2C376\" alt=\"emoji-one\" class=\"aligncenter size-full wp-image-31461\" /></a></p>\n<p><a href=\"http://emojione.com/\" target=\"_blank\">Emoji One</a> is a new open source emoji set that is the first of its kind, designed specifically for the web. The set boasts more than 840 emoji. It was created to solve the perennial problem of translating emoji code from mobile devices while legally displaying the corresponding emoji icon on the web. The idea is to avoid displaying those ugly blank squares that you see so often, as illustrated on the Emoji One website:</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/emoji-one-problem-1.jpg\" rel=\"prettyphoto[31456]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/emoji-one-problem-1.jpg?resize=795%2C392\" alt=\"emoji-one-problem-1\" class=\"aligncenter size-full wp-image-32029\" /></a></p>\n<p>Emoji One was also created to provide consistency across various mobile and web platforms. As things currently stand, you tend to get a slight variation in display depending on the mobile platform used to input the emoji.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/emoji-one-problem-2.jpg\" rel=\"prettyphoto[31456]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/emoji-one-problem-2.jpg?resize=824%2C464\" alt=\"emoji-one-problem-2\" class=\"aligncenter size-full wp-image-32033\" /></a></p>\n<p>Emoji One is tackling both of these problems head on with its new open source emoji set. It&#8217;s released under the MIT license, which is GPL-compatible. Check out a <a href=\"http://emojione.com/demo\" target=\"_blank\">live demo</a> of Emoji One to see the set in action.</p>\n<h3>WP Emoji One</h3>\n<p><a href=\"https://wordpress.org/plugins/wp-emoji-one/\" target=\"_blank\">WP Emoji One</a> is the first plugin to bring Emoji One support to WordPress posts and pages. It is based on work from the <a href=\"https://wordpress.org/plugins/typepad-emoji-for-tinymce/\" target=\"_blank\">TypePad Emoji For TinyMCE</a> plugin. The emoji chooser can be launched via a button added to the visual editor.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/visual-editor-emoji-one.jpg\" rel=\"prettyphoto[31456]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/visual-editor-emoji-one.jpg?resize=822%2C264\" alt=\"visual-editor-emoji-one\" class=\"aligncenter size-full wp-image-32047\" /></a></p>\n<p>Clicking on the button opens a modal window with the Emoji One library, along with the option to choose the pixel size of the emoji inserted into the content.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/emoji-one-modal.jpg\" rel=\"prettyphoto[31456]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/emoji-one-modal.jpg?resize=818%2C598\" alt=\"emoji-one-modal\" class=\"aligncenter size-full wp-image-32049\" /></a></p>\n<p>You don&#8217;t have to install anything on your mobile device to use Emoji One; just continue to use emoji as you have been. The WordPress plugin simply provides a more consistent experience for displaying emoji on the web.</p>\n<p>I checked with the WP Emoji One plugin author to inquire about using the emoji in comments. He plans to add them to comments in the next release. BuddyPress and bbPress integration would also be very handy, as social sites are likely to derive greater benefits from offering emoji support.</p>\n<p>Emoji One only recently launched on September 11, 2014. The team is currently working on creating the 250 new emojis that <a href=\"http://www.unicode.org/\" target=\"_blank\">Unicode</a> approved in June 2014, and will make those available soon.</p>\n<p>You may have already seen Emjoi One icons in the wild here and there. The WordPress-powered Emoji One blog recently highlighted <a href=\"http://www.emojione.com/blog/slack-adds-emoji-one-gets-more-awesome/\" target=\"_blank\">Slack&#8217;s integration of Emoji One</a> as one of its default emoji options. As more companies and services begin to recognize the need for a universal emoji set, you can expect to see Emoji One popping up around the web in more places.</p>\n<p>Better emoji support may someday find its way into WordPress core with enough popular support. In the meantime, you can use <a href=\"https://wordpress.org/plugins/wp-emoji-one/\" target=\"_blank\">WP Emoji One</a> to extend WordPress&#8217; capabilities to provide a more consistent and colorful emoji display on your site.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Oct 2014 17:06:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Matt: Dave Winer’s 20th\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44291\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"http://ma.tt/2014/10/dave-winers-20th/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:352:\"<p>The Observer writes <a href=\"http://www.theguardian.com/technology/2014/oct/12/happy-20th-anniversary-dave-winer-inventor-of-the-blog\">Happy 20th anniversary to Dave Winer – inventor of the blog</a>. I&#8217;ve gotten a huge amount of inspiration, help, and feedback from Dave over the years, and I&#8217;m really happy he&#8217;s still at it.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Oct 2014 22:37:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"Post Status: Postmatic wants to revitalize your WordPress email, starting with comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://www.poststat.us/?p=7197\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://www.poststat.us/postmatic-wordpress-email/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4912:\"<p><img class=\"aligncenter size-large wp-image-7200\" src=\"http://www.poststat.us/wp-content/uploads/2014/10/postmatic-752x307.gif\" alt=\"postmatic\" width=\"627\" height=\"255\" /></p>\n<p><a href=\"http://gopostmatic.com/\">Postmatic</a> is a new WordPress plugin that I think is quite promising. It&#8217;s aim is to eventually change the way you utilize WordPress email in many ways, but its comment functionality is what intrigued me immediately.</p>\n<p>Postmatic currently allows users to subscribe to comments and posts by email; but what sets it apart is that it enables <em>reply by email</em> functionality as well. That&#8217;s something that has been high on my list of wants for a WordPress plugin for a long time, and I wanted it without switching to a third party system like Disqus.</p>\n<p>All in all &#8212; aside from enabling replies by email &#8212; the current feature set is quite similar to Jetpack&#8217;s Subscriptions module. Postmatic has widgets for post subscriptions and will send subscribers new posts and allow them to get emailed comment notifications as well.</p>\n<p></p>\n<p>I asked Jason Lemieux, a co-founder of Postmatic, if they were considering a way to import from Jetpack or otherwise integrate with it, and they are. They&#8217;re working now to make it so that your old posts using Jetpack&#8217;s subscription module for comment notifications will still work, and your new posts will use Postmatic.</p>\n<p>I had a pretty thorough conversation with Jason and got to see Postmatic in action. For a free plugin especially, the functionality is quite impressive. I tested subscribing to comments, replying by email, and opting into subscriptions, and it is all very smooth. Here&#8217;s a sample reply notification to my email.<span id=\"more-7197\"></span></p>\n<div id=\"attachment_7201\" class=\"wp-caption aligncenter\"><img class=\"wp-image-7201 size-large\" src=\"http://www.poststat.us/wp-content/uploads/2014/10/postmatic-email-752x816.gif\" alt=\"postmatic-email\" width=\"627\" height=\"680\" /><p class=\"wp-caption-text\">Sample Postmatic notification email</p></div>\n<p>Postmatic is already in beta with their API as well. With a little legwork, you can utilize Postmatic for a variety of custom use cases. I know I&#8217;d love to play with it to see if I could create email campaigns for custom post types or multiple lists. They also intend to monetize the plugin via a few avenues &#8212; including ensuring mail delivery and functionality add-ons.</p>\n<p>Postmatic &#8212; available for <a href=\"https://wordpress.org/plugins/postmatic/\">download on WordPress.org</a> &#8212; is and will remain completely free. At some point they&#8217;ll exit beta and they will offer paid delivery of outgoing mail for larger sites. They understand the limitations of sending email through your own server and are using Mailgun to ensure delivery. They also have an extensive &#8212; and for now private &#8212; list of features they aim to introduce to Postmatic.</p>\n<p>The product is definitely version 1.0. Advanced list management, and more advanced campaign delivery is still not ready. But I was impressed by how good of a 1.0 Postmatic is, and how much effort Jason and his business parter, Dylan Kuhn, have clearly invested heavily into the product. For instance, subscriber importing is already possible, so you could move to Postmatic for post delivery right away. They <a href=\"http://gopostmatic.com/setup/\">have videos show how to do that and more</a> already available.</p>\n<p>They tell me as well that Postmatic is in very early stages. Right now they are working on more advanced template building and other features to help tame your WordPress emails. I think they definitely have other services like <a href=\"http://jetpack.me\">Jetpack&#8217;s</a> Subscriptions and <a title=\"WYSIJA is now MailPoet\" href=\"http://www.poststat.us/wysija-now-mailpoet/\">MailPoet</a> in their sights.</p>\n<p>I think WordPress email is ripe for disruption. Imagine, currently, all the ways users can get emails from a website, with little continuity: WordPress itself, Mailchimp or other newsletter provider, Jetpack / WordPress.com, eCommerce solutions, form solutions. Each of these sends email and each has their own quirks, look and feel, and otherwise.</p>\n<p>I&#8217;d love to see a service like <a href=\"http://gopostmatic.com/\">Postmatic</a> help tame WordPress email as a whole, and offer a more seamless experience for my website visitors that receive email from me.</p>\n<p>In the short term, I doubt any service will be able to do this perfectly. But I think as WordPress sites send more and more mail, continuity in this arena will be very important. I know, for me, as I prepare to enable <a title=\"The future of Post Status\" href=\"http://www.poststat.us/radical/\">club memberships on Post Status</a>, it&#8217;s top of my mind to provide a quality email experience to my members.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Oct 2014 21:51:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"WPTavern: WPWeekly Episode 166 – Interview With The Project Lead For XWP, Frankie Jarrett\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=32015&preview_id=32015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://wptavern.com/wpweekly-episode-166-interview-with-the-project-lead-for-xwp-frankie-jarrett\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4393:\"<p>Back in September, <a title=\"http://wptavern.com/stream-morphs-from-a-plugin-into-a-service\" href=\"http://wptavern.com/stream-morphs-from-a-plugin-into-a-service\">Stream 2.0 was released</a> with some significant changes. The most notable change is the transition from a plugin into a service.</p>\n<p>In this episode of WordPress Weekly, <a title=\"http://marcuscouch.com/\" href=\"http://marcuscouch.com/\">Marcus Couch</a> and I are joined by the project lead For <a title=\"https://xwp.co/\" href=\"https://xwp.co/\">XWP</a>, <a title=\"http://frankiejarrett.com/\" href=\"http://frankiejarrett.com/\">Frankie Jarrett</a>. Jarrett goes in-depth on the decision to turn Stream into a service. He also explains why it needs to be connected to a WordPress.com ID, what the team is doing regarding the enterprise, and why record data is stored in the cloud. Near the end of the interview, we discuss the lessons learned from how the plugin was shipped and communicated to customers.</p>\n<h2>Stories Discussed:</h2>\n<p><a title=\"http://wptavern.com/webdesign-com-is-now-ithemes-training\" href=\"http://wptavern.com/webdesign-com-is-now-ithemes-training\">WebDesign.com Is Now iThemes Training</a><br />\n<a title=\"http://wptavern.com/troubleshooting-handbook-for-new-wordpress-support-forum-volunteers-is-live\" href=\"http://wptavern.com/troubleshooting-handbook-for-new-wordpress-support-forum-volunteers-is-live\">Troubleshooting Handbook For New WordPress Support Forum Volunteers Is Live</a><br />\n<a title=\"http://wptavern.com/how-to-obtain-the-total-download-count-for-plugins-attached-to-a-wordpress-org-username\" href=\"http://wptavern.com/how-to-obtain-the-total-download-count-for-plugins-attached-to-a-wordpress-org-username\">How to Obtain The Total Download Count For Plugins Attached to a WordPress.org Username</a><br />\n<a title=\"http://wptavern.com/rate-and-review-a-wordpress-plugin-day-set-for-october-17th\" href=\"http://wptavern.com/rate-and-review-a-wordpress-plugin-day-set-for-october-17th\">Rate and Review a WordPress Plugin Day Set For October 17th</a><br />\n<a title=\"http://wptavern.com/twenty-fifteen-officially-added-to-the-development-version-of-wordpress\" href=\"http://wptavern.com/twenty-fifteen-officially-added-to-the-development-version-of-wordpress\">Twenty Fifteen Officially Added to The Development Version of WordPress </a><br />\n<a title=\"http://wptavern.com/loopconf-a-conference-catered-to-wordpress-developers\" href=\"http://wptavern.com/loopconf-a-conference-catered-to-wordpress-developers\">LoopConf: A Conference Catered to WordPress Developers </a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a title=\"https://wordpress.org/plugins/wc-vendors/\" href=\"https://wordpress.org/plugins/wc-vendors/\">WC Vendors</a> is a WooCommerce extension that lets you create your own Etsy or Amazon style marketplace, allowing multiple vendors to sell their goods. This allows other users to sell tangible products, virtual products or downloads on your site. Vendors receive the commissions you set on products they sell from your store.</p>\n<p><a title=\"https://wordpress.org/plugins/wp-comment-fields/\" href=\"https://wordpress.org/plugins/wp-comment-fields/\">WordPress Comments Fields</a> is a plugin that allows admins to add custom fields to the comment area. These fields are saved as comment meta and are displayed under the comment. The plugin support four different field types: Drag and drop, text, radio, radio and select inputs.</p>\n<p><a title=\"https://wordpress.org/plugins/comic-sans-roulette/\" href=\"https://wordpress.org/plugins/comic-sans-roulette/\">Comic Sans Roulette</a> randomly changes all fonts on your site to Comic Sans. You have a 10% chance that all of the fonts will be Comic Sans!</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, October 22nd 9:30 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #166:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Oct 2014 17:41:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: LoopConf: A Conference Catered to WordPress Developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32006\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wptavern.com/loopconf-a-conference-catered-to-wordpress-developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2653:\"<p>&nbsp;</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/LoopConfFeaturedImage.png\" rel=\"prettyphoto[32006]\"><img class=\"aligncenter size-full wp-image-32007\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/LoopConfFeaturedImage.png?resize=650%2C200\" alt=\"LoopConf Featured Image\" /></a>Scheduled to take place <strong>May 7-8th, 2015</strong> at Westin Lake in Las Vegas, NV, <a title=\"http://loopconf.io/\" href=\"http://loopconf.io/\">LoopConf</a> is a conference dedicated to WordPress developers. The two-day event has six speakers confirmed with more on the way. They include:</p>\n<ul>\n<li>Joost de Valk</li>\n<li>Jenn Schiffer</li>\n<li>John O&#8217; Nolan</li>\n<li>Helen Hou-Sandí</li>\n<li>Andrew Nacin</li>\n<li>Syed Balkhi</li>\n</ul>\n<p>LoopConf is a single track conference where a bulk of the content will consist of 30 minute sessions and 60 minute developer work shops. It gives developers an opportunity to dive deep into advanced engineering and development topics in a relaxed atmosphere surrounded by like-minded individuals.</p>\n<p>If you&#8217;re interested in speaking at the event, LoopConf is <a title=\"http://loopconf.io/apply/\" href=\"http://loopconf.io/apply/\">calling for speakers</a>. The deadline to submit a speaker application is November 4th, 2014. If you&#8217;re interested in financially supporting the event, there&#8217;s a <a title=\"http://loopconf.io/sponsor/\" href=\"http://loopconf.io/sponsor/\">sponsor application available</a>.</p>\n<p>Like <a title=\"http://prestigeconf.com/\" href=\"http://prestigeconf.com/\">PrestigeConf</a>, LoopConf is not a WordCamp or associated with the WordPress foundation. Even though it&#8217;s an independent event, there is at least one trait similar to WordCamps. One of the rules to be a speaker is to embrace the open source spirit.</p>\n<blockquote><p>We want all of our speakers to show up with an attitude to give freely. This isn’t an opportunity to pitch your company, it’s the chance to share knowledge that you’ve picked up as you’ve perfected your craft.</p></blockquote>\n<p>Event organizer, Ryan Sullivan, says the plan is to &#8220;sell 600-700 tickets in two rounds&#8221;. He also told the Tavern, &#8220;we&#8217;ll have an exclusive deal with the hotel for attendees to take advantage of. For those who can&#8217;t make it or would like to attend virtually, the event will be <strong>streamed live for free</strong>.&#8221;</p>\n<p>Tickets have yet to go on sale as the organizing team works to complete the details. However, those who sign up to the LoopConf email list will be the first to know when tickets go on sale.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Oct 2014 21:58:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: Twenty Fifteen Officially Added to The Development Version of WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=31991\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"http://wptavern.com/twenty-fifteen-officially-added-to-the-development-version-of-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5572:\"<p>The default theme slated to ship with WordPress 4.1 dubbed &#8220;<a title=\"http://wptavern.com/first-look-at-designs-for-the-twenty-fifteen-default-wordpress-theme\" href=\"http://wptavern.com/first-look-at-designs-for-the-twenty-fifteen-default-wordpress-theme\">Twenty Fifteen</a>&#8221; has <a title=\"https://make.wordpress.org/core/2014/10/14/twenty-fifteen-is-here/\" href=\"https://make.wordpress.org/core/2014/10/14/twenty-fifteen-is-here/\">officially been added</a> to the development version of WordPress. In sharp contrast to <a title=\"https://wordpress.org/themes/twentyfourteen\" href=\"https://wordpress.org/themes/twentyfourteen\">Twenty Fourteen</a>, Twenty Fifteen is a simple, two column, blog focused theme. The typography features Google’s Noto Serif and Sans, a font family designed to be visually harmonious across many of the worlds languages.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/09/twenty-fifteen.png\" rel=\"prettyphoto[31991]\"><img class=\"aligncenter size-full wp-image-30226\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/09/twenty-fifteen.png?resize=1024%2C825\" alt=\"twenty-fifteen\" /></a></p>\n<p>Here&#8217;s what the Tavern looks like with Twenty Fifteen activated. In the screenshot, you&#8217;ll notice a scrollbar between the sidebar and content. Being able to scroll the sidebar separate from the content reminds me of the Visual Editor in WordPress 3.9. I&#8217;d like to see both columns be a cohesive unit for a better experience and to eliminate the <strong>ugly</strong> scrollbar. <em>This issue has already been <a title=\"https://core.trac.wordpress.org/ticket/29979\" href=\"https://core.trac.wordpress.org/ticket/29979\">reported</a>.</em></p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/TwentyFifteenTavernHomepage.png\" rel=\"prettyphoto[31991]\"><img class=\"size-full wp-image-31993\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/TwentyFifteenTavernHomepage.png?resize=1025%2C718\" alt=\"Twenty Fifteen Tavern Home Page\" /></a>Twenty Fifteen Tavern Home Page\n<p>In Twenty Fifteen, the comment reply link is aligned to the left. While not a deal breaker, I prefer the comment link to be aligned to the right.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/TwentyFifteenCommentReplyLink.png\" rel=\"prettyphoto[31991]\"><img class=\"size-full wp-image-31994\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/TwentyFifteenCommentReplyLink.png?resize=660%2C258\" alt=\"Comment Reply Link on The Left\" /></a>Comment Reply Link on The Left\n<p>On the Tavern, we routinely use the featured image as the first image in a post. This works well since the Tavern theme is configured to show only the excerpts and featured image on the homepage. The Twenty Fifteen homepage displays full posts which shows the same image twice, creating a <em>post title sandwich</em>. Keep this in mind if you use featured images and are thinking of switching to Twenty Fifteen in the future.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/TwentyFifteenSandwhich.png\" rel=\"prettyphoto[31991]\"><img class=\"size-full wp-image-31995\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/TwentyFifteenSandwhich.png?resize=750%2C887\" alt=\"A Featured Image Sandwich\" /></a>A Post Title Sandwich\n<p>&nbsp;</p>\n<p>Each post on the homepage is separated by blank space. Featured images that are not at least 826 pixels wide are padded by an equal amount of blank space on each side. Similar to Twenty Fourteen, images that span the entire width change the visual look and feel of the theme. Posts on the homepage look great when the image is more than 826 pixels wide, while smaller images don&#8217;t have the same visual pop.</p>\n<p>Since featured images touch the top of the content box, smaller images give me the impression that something is broken. For example, maybe there&#8217;s an alignment issue where the top of the image is being cut off. It&#8217;s not, but that&#8217;s what I&#8217;m thinking when I see it. This is all a moot point though if you use a full width featured image.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/TooSmallOfaFeaturedImage.png\" rel=\"prettyphoto[31991]\"><img class=\"size-full wp-image-31997\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/TooSmallOfaFeaturedImage.png?resize=789%2C905\" alt=\"Featured Image is Too Small\" /></a>Featured Image is Too Small\n<h2>It&#8217;s Still Early</h2>\n<p>There is a long way to go before Twenty Fifteen is ready for prime time. Initial feedback I&#8217;ve seen so far labels Twenty Fifteen as a breath of fresh air. Twenty Fifteen goes back to the blogging roots of WordPress, but it does so in a modern, elegant way. Once the bugs have been squashed and the theme polished, I think a lot of people will either switch to or use Twenty Fifteen when WordPress 4.1 is released. If you&#8217;d like to see Twenty Fifteen in the wild, check out <a title=\"http://www.brandonkraft.com/\" href=\"http://www.brandonkraft.com/\">Brandon Kraft&#8217;s personal site</a>.</p>\n<h2>How You Can Help Improve Twenty Fifteen</h2>\n<p>The Twenty Fifteen development team is holding meetings on IRC, every Tuesday at 15:30 UTC, in the #wordpress-dev channel. The meetings are opportunities to discuss all things Twenty Fifteen and to <a title=\"https://core.trac.wordpress.org/query?status=!closed&component=Bundled+Theme\" href=\"https://core.trac.wordpress.org/query?status=!closed&component=Bundled+Theme\">collaborate on tickets</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Oct 2014 20:49:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"WordPress.tv Blog: The Future of WordPress: Great videos from Matt Mullenweg and Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.wordpress.tv/?p=400\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"http://blog.wordpress.tv/2014/10/15/the-future-of-wordpress-great-videos-from-matt-mullenweg-and-andrew-nacin/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1936:\"<p>Here are some recent videos from <a href=\"http://wordpress.tv/event/wordcamp-europe-2014/\" target=\"_blank\">WordCamp Europe 2014</a> covering the past, present, and future of WordPress development.</p>\n<h2>Matt Mullenweg: Q&amp;A with Om Malik</h2>\n<div id=\"v-xBhclaAc-1\" class=\"video-player\">\n</div>\n<p>Matt Mullenweg, the founder of WordPress, in conversation with tech writer Om Malik on the WordPress past and present, as well as where we are going for the future.  </p>\n<p><a href=\"http://wordpress.tv/2014/10/03/matt-mullenweg-om-malik-qa/\" target=\"_blank\">View on WordPress.tv</a></p>\n<h2>Andrew Nacin: Post-Modern WordPress</h2>\n<div id=\"v-4Lx4dIRH-1\" class=\"video-player\">\n</div>\n<p>Andrew Nacin, lead developer for the WordPress open source project, discusses the philosophy of WordPress development, and the course it should and will take to keep growing.</p>\n<p><a href=\"http://wordpress.tv/2014/10/13/andrew-nacin-post-modern-wordpress/\" target=\"_blank\">View on WordPress.tv</a></p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptvblog.wordpress.com/400/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptvblog.wordpress.com/400/\" /></a> <img alt=\"\" border=\"0\" src=\"http://pixel.wp.com/b.gif?host=blog.wordpress.tv&blog=5310177&post=400&subd=wptvblog&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://blog.wordpress.tv/2014/10/15/the-future-of-wordpress-great-videos-from-matt-mullenweg-and-andrew-nacin/\"><img alt=\"Matt Mullenweg & Om Malik: Q&A\" src=\"http://videos.videopress.com/xBhclaAc/video-b445f277f2_scruberthumbnail_1.jpg\" width=\"160\" height=\"120\" /></a></div><div><a href=\"http://blog.wordpress.tv/2014/10/15/the-future-of-wordpress-great-videos-from-matt-mullenweg-and-andrew-nacin/\"><img alt=\"Andrew Nacin: Post-Modern WordPress\" src=\"http://videos.videopress.com/4Lx4dIRH/video-ed23aaca26_scruberthumbnail_3.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Oct 2014 19:29:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Jerry Bates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Matt: Listen Completely\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44245\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"http://ma.tt/2014/10/listen-completely/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:441:\"<blockquote><p>Listen now . When people talk listen completely. Don’t be thinking what you’re going to say. Most people never listen. Nor do they observe. You should be able to go into a room and when you come out know everything that you saw there and not only that. If that room gave you any feeling you should know exactly what it was that gave you that feeling. Try that for practice.</p></blockquote>\n<p>&#8212; Ernest Hemingway</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Oct 2014 15:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Matt: Among the Marchers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44254\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://ma.tt/2014/10/among-the-marchers/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:231:\"<p>Bill McKibben writes from <a href=\"http://www.newyorker.com/news/news-desk/among-marchers\">Among the Marchers of the climate change march</a> the other week. <cite>Hat tip: <a href=\"http://grist.org/\">Chip Giller</a>.</cite></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Oct 2014 22:46:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"Post Status: LoopConf: A new WordPress conference that’s only for developers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://www.poststat.us/?p=7188\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://www.poststat.us/loopconf-new-wordpress-conference-thats-developers/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3300:\"<p>&nbsp;</p>\n<p><img class=\"aligncenter size-large wp-image-7191\" src=\"http://www.poststat.us/wp-content/uploads/2014/10/loopconf1-752x295.png\" alt=\"loopconf\" width=\"627\" height=\"245\" /></p>\n<p>Early May 2015 will be the first ever <a href=\"http://loopconf.io/\">LoopConf</a>, a WordPress conference that&#8217;s geared solely toward developers. Ryan Sullivan, the owner of <a href=\"http://wpsitecare.com\">WP Site Care</a>, is hosting the conference that is to be held in Las Vegas.</p>\n<p>LoopConf describes itself like this:</p>\n<blockquote><p>LoopConf is the greatest conference ever created for WordPress developers. LoopConf came about as we heard technically-minded folks talk about wanting to get together and dive deep into advanced engineering and development topics. We&#8217;ve assembled an amazing group of speakers to get this inaugural event started off on the right foot, and we&#8217;re excited to share our excitement and passion for WordPress with all of you in an exciting two-day event. We hope that you join us to celebrate the software we love, enjoy each other&#8217;s company, and learn from one another.</p></blockquote>\n<p>There are already six speakers confirmed:</p>\n<ul>\n<li><a href=\"http://nacin.com\">Andrew Nacin</a>: WordPress lead developer, works at Audrey Capital</li>\n<li><a href=\"http://helenhousandi.com/\">Helen Hou-Sandí</a>: Lead developer of WordPress 4.0, works at 10up</li>\n<li><a href=\"http://ghost.org\">John O&#8217;Nolan</a>: Founder of Ghost and former WordPress contributor</li>\n<li><a href=\"http://www.balkhis.com/about/\">Syed Balkhi</a>: Owner of Awesome Motive, the parent company for WP Beginner, List 25, OptinMonster, and others</li>\n<li><a href=\"http://jennmoney.biz/\">Jenn Schiffer</a>: Open web engineer at Bocoup</li>\n<li><a href=\"http://yoast.com\">Joost de Valk</a>: owner of Yoast and maker of the WordPress SEO plugin, amongst others</li>\n</ul>\n<p>The initial speaker line-up is pretty fantastic. I&#8217;d love to learn more from each one of them.</p>\n<p>LoopConf is not a WordCamp or associated with the WordPress foundation. It&#8217;s an independent WordPress conference, and Ryan says it&#8217;s the first in-person developer only WordPress conference he knows of. Most WordCamps are very catered to a diverse audience.</p>\n<p>This could be a good way for people to have more developer centric conversations. I&#8217;m certainly interested to see how it goes, and would like to make it myself. They are seeking sponsors and speaker submissions now. I don&#8217;t know how much the tickets will be exactly, but Ryan tells me he hopes for LoopConf to have a prestige and quality similar to An Event Apart events, but for WordPress &#8212; so I imagine the tickets won&#8217;t be cheap.</p>\n<p>As the WordPress conference ecosystem continues to blossom, I&#8217;m sure this isn&#8217;t the only one we&#8217;ll see like this. Non-WordCamp, niche events like <a href=\"http://pressnomics.com\">PressNomics</a> helped lead the way for those that are happening now, and I think generally it&#8217;s been good to have a diverse array of options for people to attend and learn from one another.</p>\n<p>You can keep up with <a href=\"http://twitter.com/loopconf\">@LoopConf</a> on Twitter or <a href=\"http://loopconf.io\">via the website</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Oct 2014 18:22:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: Rate and Review a WordPress Plugin Day Set For October 17th\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=31977\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wptavern.com/rate-and-review-a-wordpress-plugin-day-set-for-october-17th\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3065:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/RateReviewPluginDayFeaturedImage.png\" rel=\"prettyphoto[31977]\"><img class=\"aligncenter size-full wp-image-31979\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/RateReviewPluginDayFeaturedImage.png?resize=666%2C211\" alt=\"Rate Review Plugin Day Featured Image\" /></a></p>\n<p>Mark your calendars and schedule some free time on <strong>Friday, October 17th</strong> for the first &#8220;<strong>Rate and Review a WordPress Plugin Day</strong>&#8220;. On October 17th, visit the page of your favorite plugin in the <a title=\"https://wordpress.org/plugins/\" href=\"https://wordpress.org/plugins/\">WordPress.org plugin directory</a>, give it a star rating, and write a review.</p>\n<h2>Why The Special Day?</h2>\n<p>If you&#8217;re anything like me, you get caught up in the day-to-day activities without getting around to rating and reviewing the plugins you depend on. Some of the plugins I rely on have served me well for years, but I&#8217;ve yet to rate or review them. The only time I stop by a plugin&#8217;s page after installing it is to visit the support forum. Since disgruntled users are more vocal than those with positive experiences, this day is an excuse to share those positive experiences with the community and the plugin author.</p>\n<h2>Quick Tip</h2>\n<p>Since you can&#8217;t rate and review plugins from the backend of WordPress, here is a quick tip. Login to your WordPress.org account and navigate to the installed plugins page in the backend of WordPress. Each plugin should have a view details link that will load the plugin details modal. On the details screen, open the link to the WordPress.org Plugin Page in a new browser tab. These steps save you the trouble of manually browsing to each plugin&#8217;s page on WordPress.org.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/WPPluginPageNewTab.png\" rel=\"prettyphoto[31977]\"><img class=\"size-full wp-image-31978\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/10/WPPluginPageNewTab.png?resize=761%2C576\" alt=\"Open The WordPress.org Plugin Page In A New Browser Tab\" /></a>Open The WordPress.org Plugin Page In A New Browser Tab\n<h2>An Easy Way to Contribute Back to WordPress</h2>\n<p>Start with your favorite plugin. Review it based on your experience and try to write more than one-five words. As an additional courtesy, browse to the bottom of the plugin&#8217;s description page and click on the <em>broken</em> or <em>works</em> box. This helps determine which versions of the plugin are compatible with WordPress. Your ratings, reviews, and compatibility checks are indirect contributions to WordPress. It&#8217;s actionable data that millions of people will use to determine whether or not to use a plugin.</p>\n<p>One thing to keep in mind is that ratings and reviews are not set in stone. If you&#8217;d like to change the content or star ratings, find your review and scroll to the bottom of the page. From there, you&#8217;ll be able to change the text and rating.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Oct 2014 16:39:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"Alex King: WordPress vs. a Roll-Your-Own Blog Engine\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://pinboard-9c824ddfe7946cbde24dbe9eb552eb42\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"http://alexking.org/blog/2014/10/14/do-you-need-a-new-blog-engine\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6167:\"<p>Inspired by Brent&#8217;s <a href=\"http://inessential.com/2014/10/02/need_new_blog_engine\">consideration of an off-the-shelf blog engine</a>, Santiago Valdarrama has written a post outlining <a href=\"https://blog.svpino.com/2014/10/03/do-you-need-a-new-blog-engine\">the problems he has with off-the-shelf blog engines</a>. What was so interesting to me about this was that a self-hosted WordPress site addresses nearly every one of his concerns.</p>\n<blockquote><p>\n  1) You don&#8217;t have to deal with updates to the platform. Updates and new features are nice, unless they break all the custom code you&#8217;ve developed over time.\n</p></blockquote>\n<p>WordPress has well abstracted APIs that make it easy for your custom code to live alongside the WP core code. I can&#8217;t remember the last time I needed to make a change to code I&#8217;d written for this site because of a WP core update.</p>\n<blockquote><p>\n  2) You can&#8217;t control when bugs are fixed or new features released. If there&#8217;s something missing, the only thing you can do is file a request and wait.\n</p></blockquote>\n<p>Fiddlesticks. You can <a href=\"https://make.wordpress.org/core/handbook/\">submit a patch</a>, you can hack your local copy, and you can write plugins to add any features you feel are missing.</p>\n<blockquote><p>\n  3) There&#8217;s always a learning curve. Every platform is different, specially when you want to fine tune your layout and deviate from the provided templates.\n</p></blockquote>\n<p>This one strikes me as a bit silly. There is a learning curve when building your own system too &#8211; especially if you haven&#8217;t written your layout/templating system yet.</p>\n<blockquote><p>\n  4) Sometimes there&#8217;re things you can&#8217;t do. Period. (I wanted to use a specific format to display the date of my posts but Blogger doesn&#8217;t support it. I had to settle with something else.)\n</p></blockquote>\n<p>Using a hosted service and using an off-the-shelf blog engine are <em>not</em> the same thing. Self-hosting WordPress removes all of the hosted service restrictions.</p>\n<blockquote><p>\n  5) You have to deal with features you don&#8217;t need. Comments? Related posts? Search? Templating engine? Image carousel? I don&#8217;t need these, but I&#8217;d have to pay the price anyway.\n</p></blockquote>\n<p>Just as you can customize WordPress to add features, you can also customize it to hide features. Don&#8217;t use comments? An included setting and couple of lines of CSS will make it so you never know they were there. And WordPress doesn&#8217;t include bloated features out of the box; it wisely leaves that to plugins so that you add what you want instead of removing things you don&#8217;t.</p>\n<blockquote><p>\n  6) You can always export your content (sometimes you can&#8217;t), but even when the option is right there, the exported format is so messed up that you can&#8217;t use it again without a huge clean up. (One time I got my posts exported in a text file with no formatting.)\n</p></blockquote>\n<p>Again &#8211; this is only a problem with hosted solutions. With a self-hosted WordPress site you have full access to your MySQL database, as well as the built-in export features of WordPress.</p>\n<blockquote><p>\n  7) What&#8217;s true today might change tomorrow. What you like about the platform might go away some day. They won&#8217;t ask for your opinion.\n</p></blockquote>\n<p>WordPress is Open Source. Anyone can create a fork based on their own needs and preferences.</p>\n<blockquote><p>\n  8) It will never be as fast as you want it to be. If it&#8217;s hosted, your traffic will be shared. If you host it yourself, you might never be able to fine tune it to perfection.\n</p></blockquote>\n<p>WordPress powers around 20% of the internet &#8211; you don&#8217;t grow that big if you can&#8217;t handle scale. Dedicated WordPress hosts will solve these problems for you, and installing a few simple plugins (caching, CSS and JS concatenation and optimization, etc.) will do a ton to optimize a site on an server that isn&#8217;t tuned for WordPress.</p>\n<blockquote><p>\n  9) I will never be sure what my content is being used for. I know it&#8217;s public anyway, but it&#8217;s also in somebody else&#8217;s database I don&#8217;t control.\n</p></blockquote>\n<p>Another assumption of a hosted platform. NA for a self-hosted WordPress site.</p>\n<blockquote><p>\n  10) You&#8217;ll never get to experience the satisfaction of engaging in a conversation about how you developed your own platform from scratch.\n</p></blockquote>\n<p>As someone who has hacked on WordPress and related code for the last 12 years, I find this statement absurd. There are plenty of &#8220;from scratch&#8221; opportunities within the WordPress community, even now. And if what you want is engagement then joining a bountiful and vibrant community of developers is a much bigger opportunity than the potential for a conversation with another NIH hacker.</p>\n<p>I&#8217;m not saying that there is anything wrong with building your own X. Every time you do that it&#8217;s a great learning experience. I&#8217;m saying I don&#8217;t think it is necessary to get pride of ownership.</p>\n<blockquote><p>\n  There might be something out there that offsets all my concerns, I&#8217;m not sure (but I don&#8217;t believe so.) My blog is my hobby, and I think I&#8217;d never give control again. Every single bit you see here was a labor of love, and I&#8217;m not ready to stop thinking about it that way.\n</p></blockquote>\n<p>I think a self-hosted WordPress site is really close. And I feel exactly the same about my site &#8211; it&#8217;s mine and I am in control of it. Even though I&#8217;ve released much of the code for this site as Open Source, no one else has a site that&#8217;s exactly like mine. I&#8217;ve made the decisions about how to present my content, how to distribute it to Twitter and Facebook, how to integrate with the responses on those platforms, and how I represent myself online. And I do so while building on a robust base platform that allows me to concentrate on building just the features that are unique to my site.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Oct 2014 15:10:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WPTavern: How to Obtain The Total Download Count For Plugins Attached to a WordPress.org Username\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=31955\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"http://wptavern.com/how-to-obtain-the-total-download-count-for-plugins-attached-to-a-wordpress-org-username\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3818:\"<p>Over the weekend, the <a title=\"https://easydigitaldownloads.com/\" href=\"https://easydigitaldownloads.com/\">Easy Digital Downloads</a> team launched a new side project called <a title=\"http://wptally.com/\" href=\"http://wptally.com/\">WP Tally</a>. WP Tally is a tool that displays the total download count for plugins attached to a WordPress.org username. The project is the result of a conversation about the lack of an easy way to determine the total amount of plugin downloads a WordPress.org user has.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/WPTallyHomePage.png\" rel=\"prettyphoto[31955]\"><img class=\"size-full wp-image-31956\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/10/WPTallyHomePage.png?resize=736%2C568\" alt=\"WP Tally Home Page\" /></a>WP Tally Home Page\n<p><a title=\"http://ghost1227.com/\" href=\"http://ghost1227.com/\">Daniel Griffiths</a>, who worked on the backend of the project, tells the Tavern, &#8220;it only took 10 minutes to come up with a name.&#8221; <a title=\"http://seandavis.co/\" href=\"http://seandavis.co/\">Sean Davis</a>, a full-time support manager and theme developer for EDD, is credited with the name. The founder of Easy Digital Downloads, <a title=\"https://pippinsplugins.com/\" href=\"https://pippinsplugins.com/\">Pippin Williamson</a>, asked Griffiths if he was interested in creating a new plugin, &#8220;I&#8217;m always looking for a new pet project, so I happily agreed.&#8221; The first version of WP Tally took about an hour and a half of development time. Due to other things going on throughout the day, the estimated time to complete the project is half a day.</p>\n<h2>The WP Tally API</h2>\n<p>While the site didn&#8217;t have an <a title=\"http://wptally.com/api-docs/\" href=\"http://wptally.com/api-docs/\">API initially</a>, one was added after being suggested by Williamson. Griffiths says the API is public and passes the same data that is displayed on WP Tally. While the extent of what the API can do is small, the team is open to suggestions. &#8220;We&#8217;ve already had someone express interest in writing a widget to allow users to display their personal data on their own website.&#8221;</p>\n<h2>WP Tally in Action</h2>\n<p>Since Scott Reilly known as <a title=\"https://profiles.wordpress.org/coffee2code/\" href=\"https://profiles.wordpress.org/coffee2code/\">Coffee2Code</a> on WordPress.org, has 70 plugins attached to his account, I used his name as an example. According to WP Tally, he has <a title=\"http://wptally.com/?wpusername=Coffee2Code\" href=\"http://wptally.com/?wpusername=Coffee2Code\">911, 256 total downloads</a>. Meanwhile, <a title=\"https://profiles.wordpress.org/joostdevalk/\" href=\"https://profiles.wordpress.org/joostdevalk/\">Joost de Valk</a> has a total of <a title=\"http://wptally.com/?wpusername=joostdevalk\" href=\"http://wptally.com/?wpusername=joostdevalk\">22.3 million downloads</a> from 29 different plugins. Results are displayed in a vertical list without a way to sort them.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/Coffer2CodeTotalPluginDownloads.png\" rel=\"prettyphoto[31955]\"><img class=\"size-full wp-image-31958\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/10/Coffer2CodeTotalPluginDownloads.png?resize=723%2C405\" alt=\"Coffee2Code Total Download Count\" /></a>Coffee2Code Total Download Count\n<p>It would be nice to be able to sort through the list by the most downloads, most popular based on ratings, and alphabetical order. I&#8217;d also like to see the total number of plugins displayed in the same area as the total download count. As an added bonus, it would be neat if the information could be embedded into a text widget as a badge.</p>\n<p>What do you think of the site and is there anything else you&#8217;d like to see it tally?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Oct 2014 01:21:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 31 Oct 2014 20:53:32 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"213903\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Fri, 31 Oct 2014 20:30:13 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20141017221016\";}", "no");
INSERT INTO `wp_options` VALUES("319", "_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1414832012", "no");
INSERT INTO `wp_options` VALUES("320", "_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1414788812", "no");
INSERT INTO `wp_options` VALUES("321", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1414832012", "no");
INSERT INTO `wp_options` VALUES("322", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 Oct 2014 20:52:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using Yoast&#039;s WordPress SEO plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Your WordPress, Streamlined.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet Web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"Wordfence Security is a free enterprise class security and performance plugin that makes your site up to 50 times faster and more secure.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"iThemes Security (formerly Better WP Security)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"The easiest, most effective way to secure WordPress in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Chris Wiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Google Analytics by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wordpress.org/plugins/google-analytics-for-wordpress/#post-2316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 14 Sep 2007 12:15:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2316@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"Track your WordPress site easily with the latest tracking codes and lots added data for search result pages and error pages.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"MailPoet Newsletters\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/wysija-newsletters/#post-32629\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 02 Dec 2011 17:09:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"32629@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"Send newsletters, post notifications or autoresponders from WordPress easily, and beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"MailPoet Staff\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your WordPress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Meta Slider\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/ml-slider/#post-49521\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 14 Feb 2013 16:56:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"49521@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:145:\"Easy to use WordPress slider plugin. Create SEO optimised responsive slideshows with Nivo Slider, Flex Slider, Coin Slider and Responsive Slides.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Matcha Labs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Black Studio TinyMCE Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/plugins/black-studio-tinymce-widget/#post-31973\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 10 Nov 2011 15:06:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"31973@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"The visual editor widget for Wordpress.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Marco Chiesi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Disqus Comment System\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://wordpress.org/plugins/disqus-comment-system/#post-6808\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 28 Aug 2008 01:22:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"6808@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"The Disqus comment system replaces your WordPress comment system with your comments hosted and powered by Disqus.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Disqus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:46:\"https://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 31 Oct 2014 20:53:32 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Thu, 02 Aug 2007 12:45:03 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20141017221016\";}", "no");
INSERT INTO `wp_options` VALUES("323", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1414832012", "no");
INSERT INTO `wp_options` VALUES("324", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1414788812", "no");
INSERT INTO `wp_options` VALUES("325", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1414832012", "no");
INSERT INTO `wp_options` VALUES("326", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2014/10/wcsf-livestream/\'>Watch WordCamp San Francisco Livestream</a> <span class=\"rss-date\">October 24, 2014</span><div class=\"rssSummary\">WordCamp San Francisco is the official annual WordPress conference, gathering the community every year since 2006. This is the time when Matt Mullenweg addresses the community in his annual State of the Word presentation – a recap of  the year in WordPress and giving us a glimpse into its future. This year the speaker lineup is stellar. There will be talks by [&hellip;]</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wptavern.com/security-vulnerability-discovered-and-patched-in-wp-ecommerce\'>WPTavern: Security Vulnerability Discovered and Patched in WP eCommerce</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/wpweekly-episode-168-recap-of-wordcamp-san-francisco-2014\'>WPTavern: WPWeekly Episode 168 – Recap of WordCamp San Francisco 2014</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/apppresser-debuts-reactor-a-wordpress-powered-mobile-app-creator-built-with-the-wp-json-rest-api\'>WPTavern: AppPresser Debuts Reactor: A WordPress-Powered Mobile App Creator Built with the WP JSON REST API</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\'dashboard-news-plugin\'><span>Popular Plugin:</span> <a href=\'https://wordpress.org/plugins/wysija-newsletters/\' class=\'dashboard-news-plugin-link\'>MailPoet Newsletters</a>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=wysija-newsletters&amp;_wpnonce=e2e943dd4d&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'MailPoet Newsletters\'>Install</a>)</span></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("333", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1414802701", "yes");
INSERT INTO `wp_options` VALUES("334", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"4690\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"2907\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"2823\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"2344\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"2238\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"1804\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1619\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1591\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1569\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1533\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1496\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:4:\"1485\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1403\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:4:\"1236\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:4:\"1183\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:4:\"1133\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:4:\"1081\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:4:\"1027\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:4:\"1018\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"849\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:3:\"844\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"838\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"806\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"798\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"747\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"710\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"709\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"673\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"663\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"631\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"626\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"623\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"619\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"613\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"600\";}s:11:\"woocommerce\";a:3:{s:4:\"name\";s:11:\"woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:5:\"count\";s:3:\"572\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"564\";}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";s:3:\"561\";}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";s:3:\"554\";}s:5:\"share\";a:3:{s:4:\"name\";s:5:\"Share\";s:4:\"slug\";s:5:\"share\";s:5:\"count\";s:3:\"553\";}}", "yes");
INSERT INTO `wp_options` VALUES("335", "_site_transient_timeout_theme_roots", "1414793724", "yes");
INSERT INTO `wp_options` VALUES("336", "_site_transient_theme_roots", "a:4:{s:9:\"Newspaper\";s:7:\"/themes\";s:14:\"twentyfourteen\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("337", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1414791929;s:7:\"checked\";a:12:{s:19:\"akismet/akismet.php\";s:5:\"3.0.2\";s:43:\"animated-gif-resize/animated-gif-resize.php\";s:3:\"1.0\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:5:\"4.0.1\";s:25:\"duplicator/duplicator.php\";s:5:\"0.5.8\";s:9:\"hello.php\";s:3:\"1.6\";s:19:\"jetpack/jetpack.php\";s:5:\"3.1.1\";s:40:\"mojo-marketplace-hg/mojo-marketplace.php\";s:5:\"0.5.9\";s:33:\"privacy-policy/privacy-policy.php\";s:3:\"1.1\";s:23:\"revslider/revslider.php\";s:5:\"4.3.8\";s:39:\"td-social-counter/td-social-counter.php\";s:3:\"2.0\";s:27:\"js_composer/js_composer.php\";s:5:\"4.2.2\";s:27:\"wp-super-cache/wp-cache.php\";s:5:\"1.4.2\";}s:8:\"response\";a:2:{s:19:\"jetpack/jetpack.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"20101\";s:4:\"slug\";s:7:\"jetpack\";s:6:\"plugin\";s:19:\"jetpack/jetpack.php\";s:11:\"new_version\";s:3:\"3.2\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/jetpack/\";s:7:\"package\";s:54:\"https://downloads.wordpress.org/plugin/jetpack.3.2.zip\";}s:27:\"js_composer/js_composer.php\";O:8:\"stdClass\":5:{s:4:\"slug\";s:11:\"js_composer\";s:11:\"new_version\";s:5:\"4.3.4\";s:3:\"url\";s:0:\"\";s:7:\"package\";s:0:\"\";s:4:\"name\";s:24:\"WPBakery Visual Composer\";}}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:6:{s:19:\"akismet/akismet.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:2:\"15\";s:4:\"slug\";s:7:\"akismet\";s:6:\"plugin\";s:19:\"akismet/akismet.php\";s:11:\"new_version\";s:5:\"3.0.2\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/akismet.3.0.2.zip\";}s:43:\"animated-gif-resize/animated-gif-resize.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"41980\";s:4:\"slug\";s:19:\"animated-gif-resize\";s:6:\"plugin\";s:43:\"animated-gif-resize/animated-gif-resize.php\";s:11:\"new_version\";s:3:\"1.0\";s:3:\"url\";s:50:\"https://wordpress.org/plugins/animated-gif-resize/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/animated-gif-resize.zip\";}s:36:\"contact-form-7/wp-contact-form-7.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:3:\"790\";s:4:\"slug\";s:14:\"contact-form-7\";s:6:\"plugin\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:11:\"new_version\";s:5:\"4.0.1\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/contact-form-7/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/contact-form-7.4.0.1.zip\";}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"22600\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:5:\"0.5.8\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/duplicator.0.5.8.zip\";}s:9:\"hello.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:4:\"3564\";s:4:\"slug\";s:11:\"hello-dolly\";s:6:\"plugin\";s:9:\"hello.php\";s:11:\"new_version\";s:3:\"1.6\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/hello-dolly/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/hello-dolly.1.6.zip\";}s:27:\"wp-super-cache/wp-cache.php\";O:8:\"stdClass\":7:{s:2:\"id\";s:4:\"1221\";s:4:\"slug\";s:14:\"wp-super-cache\";s:6:\"plugin\";s:27:\"wp-super-cache/wp-cache.php\";s:11:\"new_version\";s:5:\"1.4.2\";s:14:\"upgrade_notice\";s:91:\"Fixed &quot;acceptable file list&quot; and no caching for GET queries bugs in last release.\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/wp-super-cache/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/wp-super-cache.1.4.2.zip\";}}}", "yes");
INSERT INTO `wp_options` VALUES("338", "duplicator_settings", "a:9:{s:7:\"version\";s:5:\"0.5.8\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:0;s:22:\"package_mysqldump_path\";s:0:\"\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("339", "duplicator_version_plugin", "0.5.8", "yes");
INSERT INTO `wp_options` VALUES("340", "duplicator_ui_view_state", "a:1:{s:14:\"dup-wpnotice01\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("341", "duplicator_package_active", "O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:22:\"20141031_parentingblog\";s:4:\"Hash\";s:29:\"5454030407a9e1502141031214540\";s:8:\"NameHash\";s:52:\"20141031_parentingblog_5454030407a9e1502141031214540\";s:7:\"Version\";s:5:\"0.5.8\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:72:\"/home1/anton241/public_html/blogsforsales.com/parenting/wp-snapshots/tmp\";s:8:\"StoreURL\";s:48:\"http://blogsforsales.com/parenting/wp-snapshots/\";s:8:\"ScanFile\";s:62:\"20141031_parentingblog_5454030407a9e1502141031214540_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":17:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:55:\"/home1/anton241/public_html/blogsforsales.com/parenting\";s:4:\"Size\";i:0;s:12:\"WarnFileSize\";a:0:{}s:12:\"WarnFileName\";a:0:{}s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:5:\"Links\";a:0:{}s:8:\"OmitDirs\";a:0:{}s:9:\"OmitFiles\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:22:\"20141031_parentingblog\";s:4:\"Hash\";s:29:\"5454030407a9e1502141031214540\";s:8:\"NameHash\";s:52:\"20141031_parentingblog_5454030407a9e1502141031214540\";s:7:\"Version\";s:5:\"0.5.8\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:72:\"/home1/anton241/public_html/blogsforsales.com/parenting/wp-snapshots/tmp\";s:8:\"StoreURL\";s:48:\"http://blogsforsales.com/parenting/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";r:15;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:30;}s:8:\"Database\";O:12:\"DUP_Database\":9:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:30;s:25:\"\0DUP_Database\0dbStorePath\";N;}}s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";r:45;s:8:\"Database\";r:57;}", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("2", "1", "_edit_lock", "1414576628:1");
INSERT INTO `wp_postmeta` VALUES("3", "1", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("9", "8", "_form", "<p>Your Name (required)<br />\n    [text* your-name] </p>\n\n<p>Your Email (required)<br />\n    [email* your-email] </p>\n\n<p>Subject<br />\n    [text your-subject] </p>\n\n<p>Your Message<br />\n    [textarea your-message] </p>\n\n<p>[submit \"Send\"]</p>");
INSERT INTO `wp_postmeta` VALUES("10", "8", "_mail", "a:8:{s:7:\"subject\";s:14:\"[your-subject]\";s:6:\"sender\";s:41:\"[your-name] <wordpress@blogsforsales.com>\";s:4:\"body\";s:186:\"From: [your-name] <[your-email]>\nSubject: [your-subject]\n\nMessage Body:\n[your-message]\n\n--\nThis e-mail was sent from a contact form on Parenting Blog (http://blogsforsales.com/parenting)\";s:9:\"recipient\";s:17:\"mail@yourmail.com\";s:18:\"additional_headers\";s:22:\"Reply-To: [your-email]\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";i:0;s:13:\"exclude_blank\";i:0;}");
INSERT INTO `wp_postmeta` VALUES("11", "8", "_mail_2", "a:9:{s:6:\"active\";b:0;s:7:\"subject\";s:14:\"[your-subject]\";s:6:\"sender\";s:44:\"Parenting Blog <wordpress@blogsforsales.com>\";s:4:\"body\";s:128:\"Message Body:\n[your-message]\n\n--\nThis e-mail was sent from a contact form on Parenting Blog (http://blogsforsales.com/parenting)\";s:9:\"recipient\";s:12:\"[your-email]\";s:18:\"additional_headers\";s:27:\"Reply-To: mail@yourmail.com\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";i:0;s:13:\"exclude_blank\";i:0;}");
INSERT INTO `wp_postmeta` VALUES("12", "8", "_messages", "a:6:{s:12:\"mail_sent_ok\";s:43:\"Your message was sent successfully. Thanks.\";s:12:\"mail_sent_ng\";s:93:\"Failed to send your message. Please try later or contact the administrator by another method.\";s:16:\"validation_error\";s:74:\"Validation errors occurred. Please confirm the fields and submit it again.\";s:4:\"spam\";s:93:\"Failed to send your message. Please try later or contact the administrator by another method.\";s:12:\"accept_terms\";s:35:\"Please accept the terms to proceed.\";s:16:\"invalid_required\";s:31:\"Please fill the required field.\";}");
INSERT INTO `wp_postmeta` VALUES("13", "8", "_additional_settings", "");
INSERT INTO `wp_postmeta` VALUES("14", "8", "_locale", "en_US");
INSERT INTO `wp_postmeta` VALUES("15", "10", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("16", "10", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("17", "10", "_menu_item_object_id", "10");
INSERT INTO `wp_postmeta` VALUES("18", "10", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("19", "10", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("20", "10", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("21", "10", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("22", "10", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("23", "11", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("24", "11", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("25", "11", "_menu_item_object_id", "11");
INSERT INTO `wp_postmeta` VALUES("26", "11", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("27", "11", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("28", "11", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("29", "11", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("30", "11", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("31", "12", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("32", "12", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("33", "12", "_menu_item_object_id", "12");
INSERT INTO `wp_postmeta` VALUES("34", "12", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("35", "12", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("36", "12", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("37", "12", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("38", "12", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("39", "13", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("40", "13", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("41", "13", "_menu_item_object_id", "13");
INSERT INTO `wp_postmeta` VALUES("42", "13", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("43", "13", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("44", "13", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("45", "13", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("46", "13", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("47", "14", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("48", "14", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("49", "14", "_menu_item_object_id", "14");
INSERT INTO `wp_postmeta` VALUES("50", "14", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("51", "14", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("52", "14", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("53", "14", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("54", "14", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("55", "15", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("56", "15", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("57", "15", "_menu_item_object_id", "15");
INSERT INTO `wp_postmeta` VALUES("58", "15", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("59", "15", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("60", "15", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("61", "15", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("62", "15", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("63", "16", "_wp_page_template", "page-homepage-loop.php");
INSERT INTO `wp_postmeta` VALUES("64", "17", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("65", "17", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("66", "17", "_menu_item_object_id", "16");
INSERT INTO `wp_postmeta` VALUES("67", "17", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("68", "17", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("69", "17", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("70", "17", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("71", "17", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("72", "16", "td_homepage_loop", "a:1:{s:9:\"td_layout\";s:1:\"6\";}");
INSERT INTO `wp_postmeta` VALUES("73", "18", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("74", "18", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("75", "18", "_menu_item_object_id", "18");
INSERT INTO `wp_postmeta` VALUES("76", "18", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("77", "18", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("78", "18", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("79", "18", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("80", "18", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("81", "19", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("82", "19", "_menu_item_menu_item_parent", "18");
INSERT INTO `wp_postmeta` VALUES("83", "19", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("84", "19", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("85", "19", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("86", "19", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("87", "19", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("88", "19", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("89", "20", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("90", "20", "_menu_item_menu_item_parent", "18");
INSERT INTO `wp_postmeta` VALUES("91", "20", "_menu_item_object_id", "6");
INSERT INTO `wp_postmeta` VALUES("92", "20", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("93", "20", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("94", "20", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("95", "20", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("96", "20", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("97", "21", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("98", "21", "_menu_item_menu_item_parent", "18");
INSERT INTO `wp_postmeta` VALUES("99", "21", "_menu_item_object_id", "7");
INSERT INTO `wp_postmeta` VALUES("100", "21", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("101", "21", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("102", "21", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("103", "21", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("104", "21", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("105", "22", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("106", "22", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("107", "22", "_menu_item_object_id", "22");
INSERT INTO `wp_postmeta` VALUES("108", "22", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("109", "22", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("110", "22", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("111", "22", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("112", "22", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("113", "23", "_wp_page_template", "page-homepage-loop.php");
INSERT INTO `wp_postmeta` VALUES("114", "24", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("115", "24", "_menu_item_menu_item_parent", "22");
INSERT INTO `wp_postmeta` VALUES("116", "24", "_menu_item_object_id", "23");
INSERT INTO `wp_postmeta` VALUES("117", "24", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("118", "24", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("119", "24", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("120", "24", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("121", "24", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("122", "25", "_wp_page_template", "page-homepage-blank.php");
INSERT INTO `wp_postmeta` VALUES("123", "26", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("124", "26", "_menu_item_menu_item_parent", "22");
INSERT INTO `wp_postmeta` VALUES("125", "26", "_menu_item_object_id", "25");
INSERT INTO `wp_postmeta` VALUES("126", "26", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("127", "26", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("128", "26", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("129", "26", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("130", "26", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("131", "27", "_wp_page_template", "page-homepage-bg-loop.php");
INSERT INTO `wp_postmeta` VALUES("132", "27", "td_homepage_loop_slide", "a:1:{s:19:\"td_slide_background\";s:69:\"http://demo.tagdiv.com/newspaper/wp-content/uploads/2013/09/bg001.jpg\";}");
INSERT INTO `wp_postmeta` VALUES("133", "28", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("134", "28", "_menu_item_menu_item_parent", "22");
INSERT INTO `wp_postmeta` VALUES("135", "28", "_menu_item_object_id", "27");
INSERT INTO `wp_postmeta` VALUES("136", "28", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("137", "28", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("138", "28", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("139", "28", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("140", "28", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("141", "29", "_wp_page_template", "page-homepage-blank.php");
INSERT INTO `wp_postmeta` VALUES("142", "30", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("143", "30", "_menu_item_menu_item_parent", "22");
INSERT INTO `wp_postmeta` VALUES("144", "30", "_menu_item_object_id", "29");
INSERT INTO `wp_postmeta` VALUES("145", "30", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("146", "30", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("147", "30", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("148", "30", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("149", "30", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("150", "31", "_wp_page_template", "page-homepage-blank.php");
INSERT INTO `wp_postmeta` VALUES("151", "32", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("152", "32", "_menu_item_menu_item_parent", "22");
INSERT INTO `wp_postmeta` VALUES("153", "32", "_menu_item_object_id", "31");
INSERT INTO `wp_postmeta` VALUES("154", "32", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("155", "32", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("156", "32", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("157", "32", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("158", "32", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("159", "33", "_wp_page_template", "page-homepage-loop.php");
INSERT INTO `wp_postmeta` VALUES("160", "33", "td_homepage_loop", "a:2:{s:9:\"td_layout\";i:6;s:19:\"td_sidebar_position\";s:10:\"no_sidebar\";}");
INSERT INTO `wp_postmeta` VALUES("161", "33", "td_homepage_loop_filter", "a:1:{s:5:\"limit\";i:12;}");
INSERT INTO `wp_postmeta` VALUES("162", "34", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("163", "34", "_menu_item_menu_item_parent", "22");
INSERT INTO `wp_postmeta` VALUES("164", "34", "_menu_item_object_id", "33");
INSERT INTO `wp_postmeta` VALUES("165", "34", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("166", "34", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("167", "34", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("168", "34", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("169", "34", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("170", "35", "_wp_page_template", "page-pagebuilder-title.php");
INSERT INTO `wp_postmeta` VALUES("171", "36", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("172", "36", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("173", "36", "_menu_item_object_id", "35");
INSERT INTO `wp_postmeta` VALUES("174", "36", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("175", "36", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("176", "36", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("177", "36", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("178", "36", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("180", "38", "_wp_attached_file", "2014/10/1.jpg");
INSERT INTO `wp_postmeta` VALUES("182", "38", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1074;s:6:\"height\";i:483;s:4:\"file\";s:13:\"2014/10/1.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:13:\"1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:13:\"1-300x134.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:134;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:14:\"1-1024x460.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:460;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:13:\"1-700x314.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:314;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:12:\"1-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:12:\"1-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:13:\"1-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:13:\"1-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:13:\"1-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:13:\"1-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:14:\"1-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:13:\"1-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:13:\"1-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:1;}}");
INSERT INTO `wp_postmeta` VALUES("184", "40", "_wp_attached_file", "2014/10/2.jpg");
INSERT INTO `wp_postmeta` VALUES("186", "40", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1074;s:6:\"height\";i:483;s:4:\"file\";s:13:\"2014/10/2.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:13:\"2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:13:\"2-300x134.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:134;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:14:\"2-1024x460.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:460;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:13:\"2-700x314.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:314;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:12:\"2-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:12:\"2-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:13:\"2-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:13:\"2-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:13:\"2-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:13:\"2-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:14:\"2-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:13:\"2-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:13:\"2-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:1;}}");
INSERT INTO `wp_postmeta` VALUES("188", "42", "_wp_attached_file", "2014/10/3.jpg");
INSERT INTO `wp_postmeta` VALUES("190", "42", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1074;s:6:\"height\";i:483;s:4:\"file\";s:13:\"2014/10/3.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:13:\"3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:13:\"3-300x134.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:134;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:14:\"3-1024x460.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:460;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:13:\"3-700x314.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:314;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:12:\"3-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:12:\"3-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:13:\"3-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:13:\"3-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:13:\"3-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:13:\"3-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:14:\"3-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:13:\"3-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:13:\"3-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:1;}}");
INSERT INTO `wp_postmeta` VALUES("192", "43", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("193", "41", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("194", "39", "post_views_count", "2");
INSERT INTO `wp_postmeta` VALUES("195", "37", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("196", "1", "post_views_count", "1");
INSERT INTO `wp_postmeta` VALUES("198", "45", "_wp_attached_file", "2014/10/5.jpg");
INSERT INTO `wp_postmeta` VALUES("200", "45", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1074;s:6:\"height\";i:483;s:4:\"file\";s:13:\"2014/10/5.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:13:\"5-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:13:\"5-300x134.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:134;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:14:\"5-1024x460.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:460;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:13:\"5-700x314.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:314;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:12:\"5-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:12:\"5-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:13:\"5-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:13:\"5-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:13:\"5-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:13:\"5-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:14:\"5-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:13:\"5-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:13:\"5-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:1;}}");
INSERT INTO `wp_postmeta` VALUES("208", "49", "post_views_count", "1");
INSERT INTO `wp_postmeta` VALUES("209", "48", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("210", "47", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("211", "46", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("212", "44", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("277", "73", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("278", "72", "post_views_count", "0");
INSERT INTO `wp_postmeta` VALUES("281", "73", "_edit_lock", "1414576161:1");
INSERT INTO `wp_postmeta` VALUES("282", "74", "_wp_attached_file", "2014/10/baby-20339_1280.jpg");
INSERT INTO `wp_postmeta` VALUES("283", "74", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:27:\"2014/10/baby-20339_1280.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:28:\"baby-20339_1280-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-700x466.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:466;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:26:\"baby-20339_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:26:\"baby-20339_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:28:\"baby-20339_1280-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:27:\"baby-20339_1280-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("284", "73", "_thumbnail_id", "74");
INSERT INTO `wp_postmeta` VALUES("285", "73", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("287", "73", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("289", "76", "_wp_attached_file", "2014/09/babyfm.jpg");
INSERT INTO `wp_postmeta` VALUES("290", "76", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:18:\"2014/09/babyfm.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"babyfm-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"babyfm-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"babyfm-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:18:\"babyfm-700x466.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:466;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:17:\"babyfm-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:17:\"babyfm-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:18:\"babyfm-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:18:\"babyfm-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:18:\"babyfm-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:18:\"babyfm-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:19:\"babyfm-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:18:\"babyfm-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:18:\"babyfm-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("291", "1", "_thumbnail_id", "76");
INSERT INTO `wp_postmeta` VALUES("293", "1", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("294", "72", "_edit_lock", "1414577998:1");
INSERT INTO `wp_postmeta` VALUES("295", "72", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("297", "72", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("298", "72", "td_post_video", "a:2:{s:8:\"td_video\";s:43:\"https://www.youtube.com/watch?v=G4AYcJ0fzJc\";s:13:\"td_last_video\";s:43:\"https://www.youtube.com/watch?v=G4AYcJ0fzJc\";}");
INSERT INTO `wp_postmeta` VALUES("299", "79", "_wp_attached_file", "2014/10/hqdefault.jpg");
INSERT INTO `wp_postmeta` VALUES("300", "72", "_thumbnail_id", "79");
INSERT INTO `wp_postmeta` VALUES("301", "79", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:480;s:6:\"height\";i:360;s:4:\"file\";s:21:\"2014/10/hqdefault.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"hqdefault-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"hqdefault-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:20:\"hqdefault-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:20:\"hqdefault-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:21:\"hqdefault-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:21:\"hqdefault-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:21:\"hqdefault-326x360.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:21:\"hqdefault-480x357.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:21:\"hqdefault-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("313", "82", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("314", "82", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("315", "82", "_menu_item_object_id", "2");
INSERT INTO `wp_postmeta` VALUES("316", "82", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("317", "82", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("318", "82", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("319", "82", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("320", "82", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("322", "83", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("323", "83", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("324", "83", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("325", "83", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("326", "83", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("327", "83", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("328", "83", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("329", "83", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("332", "82", "td_mega_menu_cat", "");
INSERT INTO `wp_postmeta` VALUES("333", "83", "td_mega_menu_cat", "");
INSERT INTO `wp_postmeta` VALUES("334", "84", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("335", "84", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("336", "84", "_menu_item_object_id", "1");
INSERT INTO `wp_postmeta` VALUES("337", "84", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("338", "84", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("339", "84", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("340", "84", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("341", "84", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("343", "84", "td_mega_menu_cat", "");
INSERT INTO `wp_postmeta` VALUES("344", "16", "_edit_lock", "1414706565:1");
INSERT INTO `wp_postmeta` VALUES("345", "16", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("346", "16", "_wpb_vc_js_status", "false");
INSERT INTO `wp_postmeta` VALUES("347", "16", "_wpb_vc_js_interface_version", "0");
INSERT INTO `wp_postmeta` VALUES("348", "16", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("349", "16", "vc_teaser", "a:2:{s:4:\"data\";s:115:\"[{\"name\":\"title\",\"link\":\"post\"},{\"name\":\"image\",\"image\":\"featured\",\"link\":\"none\"},{\"name\":\"text\",\"mode\":\"excerpt\"}]\";s:7:\"bgcolor\";s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("350", "16", "td_homepage_loop_filter", "a:1:{s:4:\"sort\";s:12:\"random_posts\";}");
INSERT INTO `wp_postmeta` VALUES("395", "109", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("396", "109", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("397", "109", "_menu_item_object_id", "108");
INSERT INTO `wp_postmeta` VALUES("398", "109", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("399", "109", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("400", "109", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("401", "109", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("402", "109", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("404", "109", "td_mega_menu_cat", "");
INSERT INTO `wp_postmeta` VALUES("405", "111", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("406", "111", "_edit_lock", "1414615874:1");
INSERT INTO `wp_postmeta` VALUES("407", "111", "_wp_page_template", "page-homepage-blank.php");
INSERT INTO `wp_postmeta` VALUES("408", "111", "_wpb_vc_js_status", "false");
INSERT INTO `wp_postmeta` VALUES("409", "111", "_wpb_vc_js_interface_version", "2");
INSERT INTO `wp_postmeta` VALUES("410", "111", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("411", "111", "vc_teaser", "a:2:{s:4:\"data\";s:115:\"[{\"name\":\"title\",\"link\":\"post\"},{\"name\":\"image\",\"image\":\"featured\",\"link\":\"none\"},{\"name\":\"text\",\"mode\":\"excerpt\"}]\";s:7:\"bgcolor\";s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("412", "113", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("413", "113", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("414", "113", "_menu_item_object_id", "111");
INSERT INTO `wp_postmeta` VALUES("415", "113", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("416", "113", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("417", "113", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("418", "113", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("419", "113", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("421", "113", "td_mega_menu_cat", "");
INSERT INTO `wp_postmeta` VALUES("422", "49", "_edit_lock", "1414615578:1");
INSERT INTO `wp_postmeta` VALUES("423", "114", "_wp_attached_file", "2014/10/baby-443388_1280.jpg");
INSERT INTO `wp_postmeta` VALUES("424", "114", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:28:\"2014/10/baby-443388_1280.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:29:\"baby-443388_1280-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-700x466.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:466;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:27:\"baby-443388_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:27:\"baby-443388_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:29:\"baby-443388_1280-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:28:\"baby-443388_1280-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("425", "49", "_thumbnail_id", "114");
INSERT INTO `wp_postmeta` VALUES("426", "49", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("428", "49", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("439", "27", "_edit_lock", "1414617764:1");
INSERT INTO `wp_postmeta` VALUES("440", "35", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("441", "35", "_wp_trash_meta_time", "1414617954");
INSERT INTO `wp_postmeta` VALUES("442", "23", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("443", "23", "_wp_trash_meta_time", "1414617954");
INSERT INTO `wp_postmeta` VALUES("444", "25", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("445", "25", "_wp_trash_meta_time", "1414617954");
INSERT INTO `wp_postmeta` VALUES("446", "33", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("447", "33", "_wp_trash_meta_time", "1414617954");
INSERT INTO `wp_postmeta` VALUES("448", "31", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("449", "31", "_wp_trash_meta_time", "1414617954");
INSERT INTO `wp_postmeta` VALUES("450", "29", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("451", "29", "_wp_trash_meta_time", "1414617954");
INSERT INTO `wp_postmeta` VALUES("452", "27", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("453", "27", "_wp_trash_meta_time", "1414617954");
INSERT INTO `wp_postmeta` VALUES("454", "125", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("455", "125", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("456", "125", "_menu_item_object_id", "16");
INSERT INTO `wp_postmeta` VALUES("457", "125", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("458", "125", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("459", "125", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("460", "125", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("461", "125", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("463", "125", "td_mega_menu_cat", "");
INSERT INTO `wp_postmeta` VALUES("464", "126", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("465", "126", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("466", "126", "_menu_item_object_id", "6");
INSERT INTO `wp_postmeta` VALUES("467", "126", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("468", "126", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("469", "126", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("470", "126", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("471", "126", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("473", "126", "td_mega_menu_cat", "");
INSERT INTO `wp_postmeta` VALUES("474", "48", "_edit_lock", "1414618416:1");
INSERT INTO `wp_postmeta` VALUES("475", "127", "_wp_attached_file", "2014/10/baby-17342_1280.jpg");
INSERT INTO `wp_postmeta` VALUES("476", "127", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:27:\"2014/10/baby-17342_1280.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:28:\"baby-17342_1280-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-700x466.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:466;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:26:\"baby-17342_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:26:\"baby-17342_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:28:\"baby-17342_1280-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:27:\"baby-17342_1280-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("478", "48", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("480", "48", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("481", "129", "_wp_attached_file", "2014/10/girl-344327_1280.jpg");
INSERT INTO `wp_postmeta` VALUES("482", "129", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:28:\"2014/10/girl-344327_1280.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:29:\"girl-344327_1280-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-700x466.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:466;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:27:\"girl-344327_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:27:\"girl-344327_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:29:\"girl-344327_1280-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:28:\"girl-344327_1280-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("483", "48", "_thumbnail_id", "129");
INSERT INTO `wp_postmeta` VALUES("485", "44", "_edit_lock", "1414704128:1");
INSERT INTO `wp_postmeta` VALUES("486", "44", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("488", "44", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("489", "44", "td_post_video", "a:2:{s:8:\"td_video\";s:43:\"https://www.youtube.com/watch?v=B0QnGpEnzQA\";s:13:\"td_last_video\";s:43:\"https://www.youtube.com/watch?v=B0QnGpEnzQA\";}");
INSERT INTO `wp_postmeta` VALUES("490", "132", "_wp_attached_file", "2014/10/hqdefault1.jpg");
INSERT INTO `wp_postmeta` VALUES("491", "44", "_thumbnail_id", "132");
INSERT INTO `wp_postmeta` VALUES("492", "132", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:480;s:6:\"height\";i:360;s:4:\"file\";s:22:\"2014/10/hqdefault1.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:22:\"hqdefault1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"hqdefault1-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:21:\"hqdefault1-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:21:\"hqdefault1-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:22:\"hqdefault1-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:22:\"hqdefault1-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:22:\"hqdefault1-326x360.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:22:\"hqdefault1-480x357.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:22:\"hqdefault1-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("493", "46", "_edit_lock", "1414703420:1");
INSERT INTO `wp_postmeta` VALUES("494", "46", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("496", "46", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("497", "46", "td_post_video", "a:1:{s:8:\"td_video\";s:43:\"https://www.youtube.com/watch?v=zxAK8TbLwxg\";}");
INSERT INTO `wp_postmeta` VALUES("498", "136", "_wp_attached_file", "2014/10/hqdefault2.jpg");
INSERT INTO `wp_postmeta` VALUES("499", "46", "_thumbnail_id", "136");
INSERT INTO `wp_postmeta` VALUES("500", "136", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:480;s:6:\"height\";i:360;s:4:\"file\";s:22:\"2014/10/hqdefault2.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:22:\"hqdefault2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"hqdefault2-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:21:\"hqdefault2-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:21:\"hqdefault2-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:22:\"hqdefault2-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:22:\"hqdefault2-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:22:\"hqdefault2-326x360.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:22:\"hqdefault2-480x357.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:22:\"hqdefault2-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("504", "47", "_edit_lock", "1414706719:1");
INSERT INTO `wp_postmeta` VALUES("505", "47", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("507", "47", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("508", "47", "td_post_video", "a:2:{s:8:\"td_video\";s:43:\"https://www.youtube.com/watch?v=ki9z-QH6EQw\";s:13:\"td_last_video\";s:43:\"https://www.youtube.com/watch?v=ki9z-QH6EQw\";}");
INSERT INTO `wp_postmeta` VALUES("509", "139", "_wp_attached_file", "2014/10/maxresdefault.jpg");
INSERT INTO `wp_postmeta` VALUES("510", "47", "_thumbnail_id", "139");
INSERT INTO `wp_postmeta` VALUES("511", "139", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:720;s:4:\"file\";s:25:\"2014/10/maxresdefault.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"maxresdefault-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"maxresdefault-300x168.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"maxresdefault-1024x576.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:25:\"maxresdefault-700x393.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:393;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:24:\"maxresdefault-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:24:\"maxresdefault-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:25:\"maxresdefault-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:25:\"maxresdefault-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:25:\"maxresdefault-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:25:\"maxresdefault-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:26:\"maxresdefault-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:25:\"maxresdefault-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:25:\"maxresdefault-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("513", "41", "_edit_lock", "1414790733:1");
INSERT INTO `wp_postmeta` VALUES("514", "41", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("516", "41", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("517", "41", "td_post_video", "a:2:{s:8:\"td_video\";s:43:\"https://www.youtube.com/watch?v=oGuifXktr-0\";s:13:\"td_last_video\";s:43:\"https://www.youtube.com/watch?v=oGuifXktr-0\";}");
INSERT INTO `wp_postmeta` VALUES("518", "141", "_wp_attached_file", "2014/10/hqdefault3.jpg");
INSERT INTO `wp_postmeta` VALUES("519", "41", "_thumbnail_id", "141");
INSERT INTO `wp_postmeta` VALUES("520", "141", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:480;s:6:\"height\";i:360;s:4:\"file\";s:22:\"2014/10/hqdefault3.jpg\";s:5:\"sizes\";a:9:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:22:\"hqdefault3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"hqdefault3-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:21:\"hqdefault3-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:21:\"hqdefault3-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:22:\"hqdefault3-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:22:\"hqdefault3-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:22:\"hqdefault3-326x360.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:360;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:22:\"hqdefault3-480x357.jpg\";s:5:\"width\";i:480;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:22:\"hqdefault3-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("522", "37", "_edit_lock", "1414790944:1");
INSERT INTO `wp_postmeta` VALUES("523", "142", "_wp_attached_file", "2014/10/baby-21167_1280.jpg");
INSERT INTO `wp_postmeta` VALUES("524", "142", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:853;s:6:\"height\";i:1280;s:4:\"file\";s:27:\"2014/10/baby-21167_1280.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-199x300.jpg\";s:5:\"width\";i:199;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:28:\"baby-21167_1280-682x1024.jpg\";s:5:\"width\";i:682;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:28:\"baby-21167_1280-700x1050.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:1050;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:26:\"baby-21167_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:26:\"baby-21167_1280-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-853x483.jpg\";s:5:\"width\";i:853;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:27:\"baby-21167_1280-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("525", "37", "_thumbnail_id", "142");
INSERT INTO `wp_postmeta` VALUES("526", "37", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("528", "37", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("529", "43", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("530", "43", "_wp_trash_meta_time", "1414791115");
INSERT INTO `wp_postmeta` VALUES("531", "39", "_edit_lock", "1414791710:1");
INSERT INTO `wp_postmeta` VALUES("532", "39", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("534", "39", "slide_template", "default");
INSERT INTO `wp_postmeta` VALUES("535", "39", "td_post_video", "a:1:{s:8:\"td_video\";s:43:\"https://www.youtube.com/watch?v=VamXjXzEwE4\";}");
INSERT INTO `wp_postmeta` VALUES("536", "147", "_wp_attached_file", "2014/10/maxresdefault1.jpg");
INSERT INTO `wp_postmeta` VALUES("537", "39", "_thumbnail_id", "147");
INSERT INTO `wp_postmeta` VALUES("538", "147", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:720;s:4:\"file\";s:26:\"2014/10/maxresdefault1.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-300x168.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:27:\"maxresdefault1-1024x576.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"featured-image\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-700x393.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:393;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:25:\"maxresdefault1-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"art-thumb\";a:4:{s:4:\"file\";s:25:\"maxresdefault1-100x65.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:65;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:8:\"art-wide\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-326x159.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:159;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"art-big-1col\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-326x235.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:235;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"art-slide-small\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-326x406.jpg\";s:5:\"width\";i:326;s:6:\"height\";i:406;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-med\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-700x357.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:357;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:13:\"art-slide-big\";a:4:{s:4:\"file\";s:27:\"maxresdefault1-1074x483.jpg\";s:5:\"width\";i:1074;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:17:\"art-slidebig-main\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-745x483.jpg\";s:5:\"width\";i:745;s:6:\"height\";i:483;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:7:\"art-gal\";a:4:{s:4:\"file\";s:26:\"maxresdefault1-210x210.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("1", "1", "2014-09-16 17:32:31", "2014-09-16 17:32:31", "<div class=\"entry\">\r\n\r\nThe anticipation of child birth is unparalleled by any other feeling in a person’s life. It is because of this, in my opinion that expecting couples make several trips to their nearest retail giant or infant specialty store and purchase on pure impulse rather than need. The feeling that something has been overlooked can be so intense that it becomes more and more difficult to determine what is necessary and what is a luxury.\r\n\r\nWith that being said, an infant rear-facing car seat is completely necessary. If the birth takes place at any location other than the parent’s home, the baby will need a safe seat to be transported home in. Not to mention doctor appointments and family visits.\r\n\r\nThe first question that should be answered before the baby arrives is most simply stated as, bottle or breast? The answer to this question will have the most impact on baby purchases made. The amount of bottles needed for example, depends directly on just how often the parent plans on washing dishes. An infant may need a feeding every 2 to 4 hours of less than 4 ounces of formula. These smaller feeding amounts are often easier to manage with the smaller 4 ounce bottles available. Try not to go overboard on the amount of these bottles purchased. Babies grow at rapid speeds and in just a couple months may be in need of a larger feeding which will justify using the larger 8 ounce bottles. Following manufacturer’s recommendations of proper care of these bottles will give the benefit of reusing them right up until they are no longer needed and replaced by the glorious “sippy cup.”\r\n\r\nIf breast feeding is the method of choice, the cost drops drastically. Deleting the purchase of formula alone each week is impressive, not to mention the cost of bottles and the accessories that follow. Breast feeding is a very natural and loving method of providing vital nourishment to an infant with a very tangible benefit of saving money.\r\n\r\nClothes and diapers are two very real necessities for a newborn baby, however the amount spent on them may vary drastically from household to household depending on the need for a brand name label. A newborn baby will most likely have its diaper changed with each feeding. This could calculate into 10 to 12 diapers per 24 hours. Given the amount being “deposited” into the diapers, I never realized the need to buy the expensive brand name disposable diapers for everyday use at home and instead opted for generic low cost disposable diapers. I did however keep a package of the expensive brand name diapers on hand to use for trips to relative’s houses where an overflowed diaper accident would not be appreciated. Using this method helped cut down on diaper costs and embarrassing moments.\r\n\r\nThis same method can be used to cut costs on infant clothes as well. It is so difficult to walk by a display of infant clothing that just looks “so adorable” and not want to purchase the clothing for a newborn. Go ahead and splurge, a little bit, and save the special outfits for family outings. Discount and consignment store infant attire can be just as stylish and appropriate for those times home relaxing with the family.\r\n\r\nInfant entertainment can send a parent’s budget spiraling out of control. From floor toys to crib mobiles to educational DVD’s, and let’s not forget the bouncing and rocking chairs and swings, it’s all there promising the world and waiting patiently to be purchased. Unfortunately it has been my experience that not all that is available is necessary or even wanted by all babies. My best advice is to wait on these purchases until after the baby is born and the parent is able to justify the actual need for the item. For example, if a baby has a difficult time napping during the day in its crib, an infant swing may be just the right transitional item to lull the baby to sleep during the day while allowing the parent have their hands free. However, a baby that would rather sleep in its crib would have little need to be in a swing. During a baby’s first month, parents often get a handle on what captivates their individual child’s attention and what just does not. It is a lot easier to wait on the more expensive infant entertainment purchases than it is to pack up an already assembled so-called miracle worker baby soother and return it back to the store, provided the receipt hasn’t been thrown away!\r\n\r\n</div>", "Preparing for Baby’s First Month", "", "publish", "closed", "closed", "", "hello-world", "", "", "2014-10-29 09:59:24", "2014-10-29 09:59:24", "", "0", "http://blogsforsales.com/parenting/?p=1", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("2", "1", "2014-09-16 17:32:31", "2014-09-16 17:32:31", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://blogsforsales.com/parenting/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "publish", "open", "open", "", "sample-page", "", "", "2014-09-16 17:32:31", "2014-09-16 17:32:31", "", "0", "http://blogsforsales.com/parenting/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2014-10-29 09:43:42", "2014-10-29 09:43:42", "<p>Your Name (required)<br />\n    [text* your-name] </p>\n\n<p>Your Email (required)<br />\n    [email* your-email] </p>\n\n<p>Subject<br />\n    [text your-subject] </p>\n\n<p>Your Message<br />\n    [textarea your-message] </p>\n\n<p>[submit \"Send\"]</p>\n[your-subject]\n[your-name] <wordpress@blogsforsales.com>\nFrom: [your-name] <[your-email]>\nSubject: [your-subject]\n\nMessage Body:\n[your-message]\n\n--\nThis e-mail was sent from a contact form on Parenting Blog (http://blogsforsales.com/parenting)\nmail@yourmail.com\nReply-To: [your-email]\n\n0\n0\n\n[your-subject]\nParenting Blog <wordpress@blogsforsales.com>\nMessage Body:\n[your-message]\n\n--\nThis e-mail was sent from a contact form on Parenting Blog (http://blogsforsales.com/parenting)\n[your-email]\nReply-To: mail@yourmail.com\n\n0\n0\nYour message was sent successfully. Thanks.\nFailed to send your message. Please try later or contact the administrator by another method.\nValidation errors occurred. Please confirm the fields and submit it again.\nFailed to send your message. Please try later or contact the administrator by another method.\nPlease accept the terms to proceed.\nPlease fill the required field.", "Contact form 1", "", "publish", "closed", "closed", "", "contact-form-1", "", "", "2014-10-29 09:43:42", "2014-10-29 09:43:42", "", "0", "http://blogsforsales.com/parenting/?post_type=wpcf7_contact_form&p=8", "0", "wpcf7_contact_form", "", "0");
INSERT INTO `wp_posts` VALUES("9", "1", "2014-10-29 09:43:46", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2014-10-29 09:43:46", "0000-00-00 00:00:00", "", "0", "http://blogsforsales.com/parenting/?p=9", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "Products review", "", "publish", "closed", "closed", "", "products-review", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/products-review/", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("11", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "Custom 404", "", "publish", "closed", "closed", "", "custom-404", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/custom-404/", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "Contact us", "", "publish", "closed", "closed", "", "contact-us", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/contact-us/", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "Privacy policy", "", "publish", "closed", "closed", "", "privacy-policy", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/privacy-policy/", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "Advertising", "", "publish", "closed", "closed", "", "advertising", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/advertising/", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "Contact us", "", "publish", "closed", "closed", "", "contact-us-2", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/contact-us-2/", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "[vc_row el_position=\"first last\"][vc_column][td_slide_big limit=\"8\" hide_title=\"hide_title\" el_position=\"first\"][/vc_column][/vc_row]", "Home", "", "publish", "open", "closed", "", "td_d_slug_1", "", "", "2014-10-30 22:05:01", "2014-10-30 22:05:01", "", "0", "http://td_uid_2_5450b6dd87bcb", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "[menu_home]", "", "publish", "closed", "closed", "", "menu_home", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/menu_home/", "7", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "[menu_category]", "", "publish", "closed", "closed", "", "menu_category", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/menu_category/", "8", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", " ", "", "", "publish", "closed", "closed", "", "19", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/19/", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", " ", "", "", "publish", "closed", "closed", "", "20", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/20/", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", " ", "", "", "publish", "closed", "closed", "", "21", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/21/", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "Homepages", "", "publish", "closed", "closed", "", "homepages", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/homepages/", "12", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "[vc_row][vc_column width=\"1/1\"][td_slide_big limit=\"8\" hide_title=\"hide_title\"][/vc_column][/vc_row][vc_row][vc_column width=\"2/3\"][td_block2 limit=\"6\" show_child_cat=\"3\" ajax_pagination=\"next_prev\" custom_title=\"Some title\"][td_slide limit=\"3\" hide_title=\"hide_title\" sort=\"popular\"][/vc_column][vc_column width=\"1/3\"][td_ad_box spot_name=\"Ad spot -- sidebar ad\"][td_social_counter facebook=\"themeforest\" twitter=\"envato\" youtube=\"collegehumor\"][vc_tabs][vc_tab title=\"TECH\" tab_id=\"1377688452-1-87\"][td_block4 limit=\"4\" hide_title=\"hide_title\"][/vc_tab][vc_tab title=\"VIDEO\" tab_id=\"1377688452-2-89\"][td_block4 limit=\"4\" hide_title=\"hide_title\"][/vc_tab][vc_tab title=\"GAMES\" tab_id=\"1377688607242-2-3\"][td_block4 limit=\"4\" hide_title=\"hide_title\"][/vc_tab][/vc_tabs][/vc_column][/vc_row]", "Homepage 2", "", "trash", "open", "closed", "", "td_d_slug_2", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "0", "http://td_uid_3_5450b6ddcb1a8", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", " ", "", "", "publish", "closed", "closed", "", "24", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/24/", "13", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "[vc_row][vc_column width=\"2/3\"][td_slide limit=\"5\" hide_title=\"hide_title\"][td_block1 limit=\"5\" sort=\"popular\" custom_title=\"MOST POPULAR\" ajax_pagination=\"load_more\"][td_block2 limit=\"6\" show_child_cat=\"3\" ajax_pagination=\"next_prev\"][vc_row_inner][vc_column_inner width=\"1/2\"][td_slide limit=\"3\"][/vc_column_inner][vc_column_inner width=\"1/2\"][td_block4 limit=\"5\"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column width=\"1/3\"][td_social_counter facebook=\"themeforest\" twitter=\"envato\" youtube=\"jonlajoie\"][td_block3 limit=\"3\" custom_title=\"LATEST VIDEO\"][td_ad_box spot_name=\"Ad spot -- sidebar ad\"][td_block2 limit=\"4\" custom_title=\"TRAVEL\"][/vc_column][/vc_row]", "Homepage 3", "", "trash", "open", "closed", "", "td_d_slug_3", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "0", "http://td_uid_4_5450b6dddb873", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2014-10-29 09:43:57", "2014-10-29 09:43:57", " ", "", "", "publish", "closed", "closed", "", "26", "", "", "2014-10-29 09:43:57", "2014-10-29 09:43:57", "", "0", "http://blogsforsales.com/parenting/26/", "14", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "[vc_row][vc_column width=\"2/3\"][td_slide limit=\"5\" hide_title=\"hide_title\"][td_block1 limit=\"5\" sort=\"popular\" custom_title=\"MOST POPULAR\" ajax_pagination=\"load_more\"][td_block2 limit=\"6\" show_child_cat=\"3\" ajax_pagination=\"next_prev\" custom_title=\"Some title\"][vc_row_inner][vc_column_inner width=\"1/2\"][td_slide limit=\"3\" custom_title=\"Some title\"][/vc_column_inner][vc_column_inner width=\"1/2\"][td_block4 limit=\"5\" custom_title=\"Some title\"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column width=\"1/3\"][td_social_counter facebook=\"themeforest\" twitter=\"envato\" youtube=\"jonlajoie\"][td_block3 limit=\"3\" custom_title=\"LATEST VIDEO\"][td_ad_box spot_name=\"Ad spot -- sidebar ad\"][td_block2 limit=\"4\" custom_title=\"TRAVEL\"][/vc_column][/vc_row]", "Homepage – with background", "", "trash", "open", "closed", "", "td_d_slug_4", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "0", "http://td_uid_5_5450b6de03d61", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", " ", "", "", "publish", "closed", "closed", "", "28", "", "", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "0", "http://blogsforsales.com/parenting/28/", "15", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "[vc_row][vc_column width=\"1/1\"][td_slide_big limit=\"8\" hide_title=\"hide_title\"][td_block2 custom_title=\"Infinite scroll\" show_child_cat=\"3\"][/vc_column][/vc_row][vc_row][vc_column width=\"2/3\"][td_block3 limit=\"10\" ajax_pagination=\"infinite\" custom_title=\"Latest articles\"][/vc_column][vc_column width=\"1/3\"][vc_widget_sidebar sidebar_id=\"td-default\"][/vc_column][/vc_row]", "Homepage infinite scroll", "", "trash", "open", "closed", "", "td_d_slug_5", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "0", "http://td_uid_6_5450b6de0e6d1", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", " ", "", "", "publish", "closed", "closed", "", "30", "", "", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "0", "http://blogsforsales.com/parenting/30/", "16", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "[vc_row][vc_column width=\"2/3\"][td_slide category_id=\"98\" limit=\"5\" hide_title=\"hide_title\"][td_block1 limit=\"5\" sort=\"popular\" custom_title=\"MOST POPULAR\" ajax_pagination=\"load_more\"][td_block2 limit=\"6\" show_child_cat=\"3\" ajax_pagination=\"next_prev\"][vc_row_inner][vc_column_inner width=\"1/2\"][td_slide limit=\"3\"][/vc_column_inner][vc_column_inner width=\"1/2\"][td_block4 limit=\"5\"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column width=\"1/3\"][td_social_counter facebook=\"themeforest\" twitter=\"envato\" youtube=\"jonlajoie\"][td_block3 limit=\"3\" custom_title=\"LATEST VIDEO\"][td_ad_box spot_name=\"Ad spot -- sidebar ad\" spot_id=\"sidebar\"][td_block2 category_id=\"98\" limit=\"4\" custom_title=\"TRAVEL\"][/vc_column][/vc_row]", "Homepage 3 – magazinly", "", "trash", "open", "closed", "", "td_d_slug_6", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "0", "http://td_uid_7_5450b6de172ae", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", " ", "", "", "publish", "closed", "closed", "", "32", "", "", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "0", "http://blogsforsales.com/parenting/32/", "17", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "[vc_row][vc_column width=\"1/1\"][td_slide_big limit=\"12\" hide_title=\"hide_title\"][td_block2 sort=\"popular\" limit=\"3\" show_child_cat=\"3\"][/vc_column][/vc_row]", "Homepage 3 columns", "", "trash", "open", "closed", "", "td_d_slug_7", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "0", "http://td_uid_8_5450b6de1fe6c", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", " ", "", "", "publish", "closed", "closed", "", "34", "", "", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "0", "http://blogsforsales.com/parenting/34/", "18", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("35", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "[vc_row el_position=\"first last\"][vc_column width=\"2/3\"][vc_column_text]\r\n\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse non nunc ac quam congue fermentum et vel massa. Proin imperdiet pulvinar rhoncus. Integer in elit accumsan, ullamcorper ante non, commodo velit. Nunc luctus scelerisque dui, vitae luctus est auctor eu.\r\n\r\n[/vc_column_text][vc_gmaps link=\"http://maps.google.com/maps?q=Town+Hall+Square,+Kent+Street,+Sydney,+New+South+Wales,+Australia&amp;hl=en&amp;sll=-33.887464,151.187968&amp;sspn=0.007472,0.016512&amp;oq=square+australia+sy&amp;t=h&amp;hq=Town+Hall+Square,&amp;hnear=Kent+St,+New+South+Wales+2000,+Australia&amp;z=16\" size=\"308\" type=\"m\" zoom=\"14\"][vc_row_inner][vc_column_inner width=\"1/2\"][td_text_with_title title=\"Contact\" style=\"style_2\" el_position=\"first last\" custom_title=\"CONTACT DETAILS\"]\r\n\r\nNewspaper Comunication Service\r\n425 Santa Teresa St.\r\nStanford, CA 452 14 521\r\n\r\n(650) 723-2558 (main number)\r\n(650) 725-0247 (fax)\r\n\r\nEmail: contact@newspaper.com\r\n\r\n[/td_text_with_title][/vc_column_inner][vc_column_inner width=\"1/2\"][td_social custom_title=\"OUR SOCIAL PROFILES\" icon_style=\"1\" icon_size=\"32\" dribbble=\"http://www.tagdiv.com\" facebook=\"http://www.tagdiv.com\" googleplus=\"#\" grooveshark=\"http://www.tagdiv.com\" linkedin=\"#\" twitter=\"http://www.tagdiv.com\" youtube=\"http://www.tagdiv.com\" el_position=\"first\"][td_text_with_title custom_title=\"WORKING HOUR\"]\r\n\r\nThe office is open from 8 a.m. to 5 p.m. Monday through Friday except university holidays.\r\n\r\n[/td_text_with_title][/vc_column_inner][/vc_row_inner][contact-form-7 id=\"797\" title=\"LEAVE US A MESSAGE\"][/vc_column][vc_column width=\"1/3\"][vc_widget_sidebar sidebar_id=\"td-default\" el_position=\"first last\"][/vc_column][/vc_row]", "Home", "", "trash", "open", "closed", "", "td_d_slug_8", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "0", "http://td_uid_9_5450b6de40082", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "Contact us", "", "publish", "closed", "closed", "", "contact-us-3", "", "", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "0", "http://blogsforsales.com/parenting/contact-us-3/", "19", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "Breastfeeding refers to the process by which a mother feeds her infant with milk directly from her breasts. Assuming the mother does not have certain illnesses, breast milk is widely believed to be the most beneficial for feeding young infants. It is even said that breastfeeding can strengthen the bond between mother and child. Still, some mothers choose not to participate in breastfeeding their infants and opt for store bought formula instead.\r\n\r\nThere are a number of benefits, which result from breastfeeding for infants. Among them, immediate milk that does not have to be heated as it is already at body temperature. In addition, some experts believe that breastfeeding decreases the risk of certain ailments, while increasing the healthy development of teeth and gums.\r\n\r\nAlong with the infant, there are positive results that stem from breastfeeding for the mother. Among them, a nurturing feeling toward her infant, a quicker return to the mom’s pre-birth weight and may help to prevent certain illnesses later on in life.\r\n\r\nOften, the infant may refuse breastfeeding at first for a variety of reasons. Normally, these can be determined and corrected with proper instruction from a physician. These may be occurrences that go away by themselves or it may be an indication of an infant that has certain medical conditions that prevent them from feeding properly.\r\n\r\nMothers who have certain medical conditions or are taking certain medications should not participate in breastfeeding her infant. The reason is because either the illness or the medication itself may be transmitted to the infant during this time, which can be very harmful to him/her. For this reason, the mother must inform her doctor about any medications or ailments that she currently has prior to beginning to breastfeed her child.\r\n\r\nMany new mothers do not realize it, but breastfeeding may cause soreness and even bruising. This is not unnatural, but can be a sign of improper positioning. These instances will usually clear themselves up, but should be checked by a physician just to be safe.\r\n\r\nThis article is to be used for informational purposes only. The information contained herein is not intended to be used in place of, or in conjunction with, professional medical advice or recommendations for or against breastfeeding. Before deciding to breastfeed their child, the new mother must consult a licensed medical doctor in order to determine the best course of action for his/her individual situation and the safe feeding of her child.", "Breastfeeding Your Child", "", "publish", "open", "closed", "", "td_d_slug_9", "", "", "2014-10-31 21:31:22", "2014-10-31 21:31:22", "", "0", "http://td_uid_10_5450b6de4c7d7", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "td_demo_atachement_1", "", "inherit", "closed", "closed", "", "td_demo_atachement_1", "", "", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "37", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("39", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "Here is a non-stop Popular Baby Songs Collection for your children and baby toddlers featuring \"Itsy Bitsy Spider\" \"Five Little Monkeys\" \"Hickory Dickory Dock\" \"Mary Had a little lamb\" \"Row Row Your Boat\" \"Baa Baa Black Sheep\" \"London Bridge\" \"Twinkle Twinkle\" &amp; many more. This baby songs collection is perfect for teaching nursery rhymes to your children, baby toddlers.", "Top 20 Baby Songs for Children", "", "publish", "open", "closed", "", "td_d_slug_10", "", "", "2014-10-31 21:44:05", "2014-10-31 21:44:05", "", "0", "http://td_uid_11_5450b6dec73b7", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "td_demo_atachement_2", "", "inherit", "closed", "closed", "", "td_demo_atachement_2", "", "", "2014-10-29 09:43:58", "2014-10-29 09:43:58", "", "39", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("41", "1", "2014-10-29 09:43:59", "2014-10-29 09:43:59", "Here are some easy &amp; fun baby shower game ideas! I hope you are able to use these ideas for your upcoming shower.", "Fun & Easy Baby Shower Games & Ideas ", "", "publish", "open", "closed", "", "td_d_slug_11", "", "", "2014-10-31 21:27:50", "2014-10-31 21:27:50", "", "0", "http://td_uid_12_5450b6df48612", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("42", "1", "2014-10-29 09:43:59", "2014-10-29 09:43:59", "", "td_demo_atachement_3", "", "inherit", "closed", "closed", "", "td_demo_atachement_3", "", "", "2014-10-29 09:43:59", "2014-10-29 09:43:59", "", "41", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("43", "1", "2014-10-29 09:43:59", "2014-10-29 09:43:59", "<p>Doner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon. </p><p>Bacon ipsum dolor sit amet tongue salami beef short loin, leberkas prosciutto ground round beef ribs strip steak shoulder turducken cow pork loin biltong. Bacon sausage ribeye rump, salami biltong strip steak.</p><p>Jowl sausage shank venison pork loin chuck chicken salami. Tail chuck capicola pancetta, bresaola jerky boudin shankle venison andouille turducken.</p><p>Pancetta swine ground round, beef ribs tenderloin meatloaf tail sausage bresaola fatback. Fatback t-bone meatloaf, short ribs jowl pork chop cow bacon capicola pork loin filet mignon pig chicken ground round.</p><p>Doner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon. </p><p>Doner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon. </p>", "The iPad for poor people has arrived, here is our review", "", "trash", "open", "closed", "", "td_d_slug_12", "", "", "2014-10-31 21:31:55", "2014-10-31 21:31:55", "", "0", "http://td_uid_13_5450b6dfc55b7", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("44", "1", "2014-10-29 09:44:07", "2014-10-29 09:44:07", "Not sure how to give baby a bath? Watch as The Bump.com mommy Alison gives tips on cleaning baby that will make bath time a sinch. First, place the bathtub in the kitchen sink so baby is at a comfortable height for you to wash them. When positioned in the bath, lay a washcloth on baby\'s chest to keep them warm. You can also tur", "Top Baby Bath Tips", "", "publish", "open", "closed", "", "td_d_slug_13", "", "", "2014-10-30 21:22:03", "2014-10-30 21:22:03", "", "0", "http://td_uid_14_5450b6e732340", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("45", "1", "2014-10-29 09:44:07", "2014-10-29 09:44:07", "", "td_demo_atachement_5", "", "inherit", "closed", "closed", "", "td_demo_atachement_5", "", "", "2014-10-29 09:44:07", "2014-10-29 09:44:07", "", "44", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/5.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("46", "1", "2014-10-29 09:44:08", "2014-10-29 09:44:08", "Need help planning a baby shower? Get a free audio book on how to plan a baby shower on me. The name of the book is \"Celebrate!: How to Plan and Host the Best Baby Shower Ever!\"", "Baby Shower Ideas and Tips", "", "publish", "open", "closed", "", "td_d_slug_14", "", "", "2014-10-30 21:12:10", "2014-10-30 21:12:10", "", "0", "http://td_uid_15_5450b6e88510e", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("47", "1", "2014-10-29 09:44:08", "2014-10-29 09:44:08", "Dr. Bill Sears shares his tips to get baby to go to sleep and stay asleep!", "Dr. Sears\' Top Baby Sleep Tips", "", "publish", "open", "closed", "", "td_d_slug_15", "", "", "2014-10-30 22:07:28", "2014-10-30 22:07:28", "", "0", "http://td_uid_16_5450b6e891e86", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("48", "1", "2014-10-29 09:44:08", "2014-10-29 09:44:08", "<div class=\"entry\">\r\n\r\nBeing in constant care of a new baby could mean spending lots of time on the couch to cuddle, feed or entertain. Although this may be just what the doctor ordered after childbirth, when doc says it’s OK to get moving take the advice and get active! It is the simplest way to boost your spirits and get more energy to keep up with a growing baby.\r\n\r\nThere are several ways to keep moving without having to venture out of your home. The most common form of new mommy exercise would be the “walk and cuddle.” Simply hold your baby close and walk around the house stopping at all points of interest and describing them to your baby. Colorful magnets on the refrigerator are always a hit along with taking a peek out of a window to watch birds at a feeder or snow falling. Always be careful not to let your baby touch anything that may be a health hazard such as a small object that could be swallowed.\r\n\r\nDon’t limit your time up on your feet to just walking. Put on some soothing music and dance with your baby. Your baby will love the graceful fluid motion of the dance and the cuddle time with you. Add to that your singing, no matter how fabulous your voice and you’ve got yourself a workout that will be truly enjoyed by both you and baby.\r\n\r\nNewborn babies spend most of their day sleeping and if you’ve got the energy this is a great time to catch up on all of those fitness DVD’s you’ve got stowed away, maybe some of them still in the plastic. Start small and never exceed doctor’s recommendations. Even a 10 minute low impact workout can be enough to boost your spirits and give you that second or third wind for the day.\r\n\r\nWalking is great exercise, whether done indoors holding baby or out with baby in a stroller. Taking baby for a walk outside in a stroller has more than just the workout benefit. Sometimes this is just the miracle you could be looking for to get an overtired bundle of joy to sleep while you get to enjoy a refreshing walk, a change of scenery and some quiet time. It is a wonderful way to break up the day and to meet your neighbors, not to mention that making this a part of your daily routine will get you well on your way to fitting back into your “before pregnancy” wardrobe!\r\n\r\nPlaytime with your baby is spent mostly on the floor. Maximize this time by doing a few simple floor exercises during play. A quick abdominal workout can be accomplished simply by lying on the floor next to baby and doing sets of crunches while reciting baby’s favorite nursery rhymes. Mix it up with your favorite moves from fitness DVD’s and magazines and you may be surprised at how quickly a total floor routine can be accomplished all while entertaining your baby.\r\n\r\nAs with all exercise programs it is recommended to talk with your doctor before starting. Staying active is essential for healthy living and improves your mental outlook and stamina for keeping up with a growing baby. It will also show a great example for your child to follow and aid in lowering the risk of being overweight.\r\n\r\nGet creative and find new ways to stay active with your child as they grow and develop. This will not only keep the two of you healthy and fit, but will also strengthen the bond between mother and child that will last a lifetime.\r\n\r\n</div>", "Keeping Active with a New Baby", "", "publish", "open", "closed", "", "td_d_slug_16", "", "", "2014-10-29 21:35:49", "2014-10-29 21:35:49", "", "0", "http://td_uid_17_5450b6e8b7153", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("49", "1", "2014-10-29 09:44:08", "2014-10-29 09:44:08", "<div class=\"entry\">\r\n\r\nEvery parent has been there. Wondering what went horribly wrong when a once sleeping beauty turns into a screaming force to be reckoned with is enough to rattle the nerves of even the most experienced care giver. My mother used to say, “Birds fly and babies cry.” She wasn’t kidding. Understanding the normalcy of a crying baby is the first step to soothing the baby.\r\n\r\nBabies cry. It is the only form of communication they have mastered at an infant stage of life. The first step in calming the baby is to be a calm parent. An infant cries to get our attention so that we can fulfill a need, whatever it may be at that particular time. If the parent is frantic those feelings will be felt by the baby and probably cause more crying. A relaxed and collected parent will most likely be able to recognize the baby’s need and calm the baby quicker.\r\n\r\nThere is a process of elimination that may be used in recognizing the source of the baby’s distress. The usual suspects are as follows: soiled diaper, hunger and the need to simply be held. Babies often swallow air while crying so holding the infant while rubbing its back gently may loosen a trapped air pocket and bring the baby instant comfort while also giving the baby some snuggle time. If by chance the little one should drift off to sleep while being held, congratulations and problem solved.\r\n\r\nIf not, check for a soiled diaper. The baby should be relatively calm by now but may not like the fact that its diaper is being changed. This is the time to speak very softly and even sing whatever song comes to mind in a very soft and gentle tone. Speaking softly to the baby and singing are great ways to create a distraction from whatever is bothering the infant and keep the parent relaxed at the same time. It is so important for the parent to maintain a relaxed demeanor during this time. Babies feed off of their care givers feelings. A relaxed parent equals a relaxed baby as well as a frustrated and frantic parent will result in an unsettled and upset baby.\r\n\r\nWhile changing the diaper, watch for signs that the infant may be hungry. Possible signs of hunger are opening and closing the mouth and sucking on lips, tongue and fingers. By this time even if the infant wasn’t hungry when the crying started, it may very well be ready for a feeding now. After feeding the baby another diaper check may be in order before putting the infant back down to sleep. Better to check than not to.\r\n\r\nThere are still the times that an infant just wants to be in the arms of its parent. This too can be a tricky task. To swaddle or not to swaddle depends completely on the individual baby. Some babies prefer being held in a rocking chair to be lulled to sleep and some need the parent to be standing and walking around. Very few will be satisfied with a stationary parent. The movement itself is comforting. Now, if lullaby lyrics are long forgotten, time to brush up on the family favorites. The baby may also respond more to one song than another. Repeating the infant’s favorites is a great way to establish a sense of calm between the parent and the infant.\r\n\r\nPlease note that if at any time a medical issue is thought to be the source of the baby’s crying, a call to the pediatrician is in order.\r\n\r\nWith that said, enjoy the new arrival. The baby’s first days and weeks may seem overwhelming, but they do pass quickly. Being calm and collected through the frustrating times will allow for more of the gentle and loving moments between baby and parent.\r\n\r\n</div>", "How to Soothe a Crying Baby", "", "publish", "open", "closed", "", "td_d_slug_17", "", "", "2014-10-29 20:48:32", "2014-10-29 20:48:32", "", "0", "http://td_uid_18_5450b6e8d0674", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2014-10-29 09:44:16", "2014-10-29 09:44:16", "Cognitive development in babies can be stimulated by simply playing with the baby and showing them toys. Discover how black and white pictures have been known to stimulate a baby\'s brain with help from a mother of three in this free video on baby development.", "Stimulate Cognitive Development", "", "publish", "open", "closed", "", "td_d_slug_40", "", "", "2014-10-29 10:22:12", "2014-10-29 10:22:12", "", "0", "http://td_uid_41_5450b6f0cd39f", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("73", "1", "2014-10-29 09:44:16", "2014-10-29 09:44:16", "Just like a snowflake or a fingerprint, every child is unique in their own special way. Every child has a unique way of feeling, thinking, and interacting with others. Some children are shy, while others are outgoing; some are active, while others are calm; some are fretful, while others are easy-going. As a loving and nurturing parent, it\'s your job to encourage them to embrace their uniqueness and celebrate their individual qualities.\r\nAllow your child to express themselves through their interests.  They may find a creative outlet in theatre, dancing or art, or they may be exceptionally talented in the sciences.  Encourage them to embrace what they like to do, what interests them, and what makes them happy.  Help them realize that they don\'t need to worry about being \'like everyone else.\'\r\nTeach your child to make positive choices, and praise them for good deeds, behaviors and positive traits they possess.  Encourage them to become actively involved in their community, and introduce them to activities that promote a sense of cooperation and accomplishment.  Be firm yet fair when handing down discipline for misdeeds or misbehaviors, and make certain the rules and consequences for breaking the rules are clearly defined.  Show a cooperative, loving and united front with your spouse when it comes to discipline.\r\nAccept and celebrate your child\'s uniqueness. Remember that your child is an individual. Allow your child to have his or her own personal preferences and feelings, which may be different from your own.\r\nAnd finally, encourage your child to be true to themselves by doing the same.  Show your child how to make positive choices with the choices you make, and that nobody is perfect and you too make mistakes.  Show your child that mistakes can be a great learning experience, and that they should not be ashamed or embarrassed about making them.  .", "Celebrate your Child\'s Uniqueness", "", "publish", "open", "closed", "", "td_d_slug_41", "", "", "2014-10-29 09:51:29", "2014-10-29 09:51:29", "", "0", "http://td_uid_42_5450b6f0d2b4d", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2014-10-29 09:50:57", "2014-10-29 09:50:57", "", "baby-20339_1280", "", "inherit", "closed", "closed", "", "baby-20339_1280", "", "", "2014-10-29 09:50:57", "2014-10-29 09:50:57", "", "73", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/baby-20339_1280.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("75", "1", "2014-10-29 09:51:09", "2014-10-29 09:51:09", "Just like a snowflake or a fingerprint, every child is unique in their own special way. Every child has a unique way of feeling, thinking, and interacting with others. Some children are shy, while others are outgoing; some are active, while others are calm; some are fretful, while others are easy-going. As a loving and nurturing parent, it\'s your job to encourage them to embrace their uniqueness and celebrate their individual qualities.\r\nAllow your child to express themselves through their interests.  They may find a creative outlet in theatre, dancing or art, or they may be exceptionally talented in the sciences.  Encourage them to embrace what they like to do, what interests them, and what makes them happy.  Help them realize that they don\'t need to worry about being \'like everyone else.\'\r\nTeach your child to make positive choices, and praise them for good deeds, behaviors and positive traits they possess.  Encourage them to become actively involved in their community, and introduce them to activities that promote a sense of cooperation and accomplishment.  Be firm yet fair when handing down discipline for misdeeds or misbehaviors, and make certain the rules and consequences for breaking the rules are clearly defined.  Show a cooperative, loving and united front with your spouse when it comes to discipline.\r\nAccept and celebrate your child\'s uniqueness. Remember that your child is an individual. Allow your child to have his or her own personal preferences and feelings, which may be different from your own.\r\nAnd finally, encourage your child to be true to themselves by doing the same.  Show your child how to make positive choices with the choices you make, and that nobody is perfect and you too make mistakes.  Show your child that mistakes can be a great learning experience, and that they should not be ashamed or embarrassed about making them.  .", "Celebrate your Child\'s Uniqueness", "", "inherit", "closed", "closed", "", "73-revision-v1", "", "", "2014-10-29 09:51:09", "2014-10-29 09:51:09", "", "73", "http://blogsforsales.com/parenting/73-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2014-10-29 09:59:12", "2014-10-29 09:59:12", "", "babyfm", "", "inherit", "closed", "closed", "", "babyfm", "", "", "2014-10-29 09:59:12", "2014-10-29 09:59:12", "", "1", "http://blogsforsales.com/parenting/wp-content/uploads/2014/09/babyfm.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("77", "1", "2014-10-29 09:59:24", "2014-10-29 09:59:24", "<div class=\"entry\">\r\n\r\nThe anticipation of child birth is unparalleled by any other feeling in a person’s life. It is because of this, in my opinion that expecting couples make several trips to their nearest retail giant or infant specialty store and purchase on pure impulse rather than need. The feeling that something has been overlooked can be so intense that it becomes more and more difficult to determine what is necessary and what is a luxury.\r\n\r\nWith that being said, an infant rear-facing car seat is completely necessary. If the birth takes place at any location other than the parent’s home, the baby will need a safe seat to be transported home in. Not to mention doctor appointments and family visits.\r\n\r\nThe first question that should be answered before the baby arrives is most simply stated as, bottle or breast? The answer to this question will have the most impact on baby purchases made. The amount of bottles needed for example, depends directly on just how often the parent plans on washing dishes. An infant may need a feeding every 2 to 4 hours of less than 4 ounces of formula. These smaller feeding amounts are often easier to manage with the smaller 4 ounce bottles available. Try not to go overboard on the amount of these bottles purchased. Babies grow at rapid speeds and in just a couple months may be in need of a larger feeding which will justify using the larger 8 ounce bottles. Following manufacturer’s recommendations of proper care of these bottles will give the benefit of reusing them right up until they are no longer needed and replaced by the glorious “sippy cup.”\r\n\r\nIf breast feeding is the method of choice, the cost drops drastically. Deleting the purchase of formula alone each week is impressive, not to mention the cost of bottles and the accessories that follow. Breast feeding is a very natural and loving method of providing vital nourishment to an infant with a very tangible benefit of saving money.\r\n\r\nClothes and diapers are two very real necessities for a newborn baby, however the amount spent on them may vary drastically from household to household depending on the need for a brand name label. A newborn baby will most likely have its diaper changed with each feeding. This could calculate into 10 to 12 diapers per 24 hours. Given the amount being “deposited” into the diapers, I never realized the need to buy the expensive brand name disposable diapers for everyday use at home and instead opted for generic low cost disposable diapers. I did however keep a package of the expensive brand name diapers on hand to use for trips to relative’s houses where an overflowed diaper accident would not be appreciated. Using this method helped cut down on diaper costs and embarrassing moments.\r\n\r\nThis same method can be used to cut costs on infant clothes as well. It is so difficult to walk by a display of infant clothing that just looks “so adorable” and not want to purchase the clothing for a newborn. Go ahead and splurge, a little bit, and save the special outfits for family outings. Discount and consignment store infant attire can be just as stylish and appropriate for those times home relaxing with the family.\r\n\r\nInfant entertainment can send a parent’s budget spiraling out of control. From floor toys to crib mobiles to educational DVD’s, and let’s not forget the bouncing and rocking chairs and swings, it’s all there promising the world and waiting patiently to be purchased. Unfortunately it has been my experience that not all that is available is necessary or even wanted by all babies. My best advice is to wait on these purchases until after the baby is born and the parent is able to justify the actual need for the item. For example, if a baby has a difficult time napping during the day in its crib, an infant swing may be just the right transitional item to lull the baby to sleep during the day while allowing the parent have their hands free. However, a baby that would rather sleep in its crib would have little need to be in a swing. During a baby’s first month, parents often get a handle on what captivates their individual child’s attention and what just does not. It is a lot easier to wait on the more expensive infant entertainment purchases than it is to pack up an already assembled so-called miracle worker baby soother and return it back to the store, provided the receipt hasn’t been thrown away!\r\n\r\n</div>", "Preparing for Baby’s First Month", "", "inherit", "closed", "closed", "", "1-revision-v1", "", "", "2014-10-29 09:59:24", "2014-10-29 09:59:24", "", "1", "http://blogsforsales.com/parenting/1-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("79", "1", "2014-10-29 10:03:38", "2014-10-29 10:03:38", "", "72", "", "inherit", "closed", "closed", "", "72", "", "", "2014-10-29 10:03:38", "2014-10-29 10:03:38", "", "72", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/hqdefault.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2014-10-29 10:04:59", "2014-10-29 10:04:59", "Cognitive development in babies can be stimulated by simply playing with the baby and showing them toys. Discover how black and white pictures have been known to stimulate a baby\'s brain with help from a mother of three in this free video on baby development.", "Stimulate Cognitive Development", "", "inherit", "closed", "closed", "", "72-revision-v1", "", "", "2014-10-29 10:04:59", "2014-10-29 10:04:59", "", "72", "http://blogsforsales.com/parenting/72-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("82", "1", "2014-10-29 18:33:45", "2014-10-29 18:33:45", "Featured posts", "", "", "publish", "closed", "closed", "", "82", "", "", "2014-10-29 21:27:26", "2014-10-29 21:27:26", "", "0", "http://blogsforsales.com/parenting/?p=82", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("83", "1", "2014-10-29 18:33:45", "2014-10-29 18:33:45", " ", "", "", "publish", "closed", "closed", "", "83", "", "", "2014-10-29 21:27:26", "2014-10-29 21:27:26", "", "0", "http://blogsforsales.com/parenting/?p=83", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2014-10-29 18:37:36", "2014-10-29 18:37:36", " ", "", "", "publish", "closed", "closed", "", "84", "", "", "2014-10-29 21:27:26", "2014-10-29 21:27:26", "", "0", "http://blogsforsales.com/parenting/?p=84", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("108", "1", "2014-10-29 18:43:33", "2014-10-29 18:43:33", "<!-- privacy-policy -->", "Privacy Policy", "", "publish", "closed", "closed", "", "privacy-policy", "", "", "2014-10-29 18:43:33", "2014-10-29 18:43:33", "", "0", "http://blogsforsales.com/parenting/privacy-policy/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("109", "1", "2014-10-29 18:44:18", "2014-10-29 18:44:18", " ", "", "", "publish", "closed", "closed", "", "109", "", "", "2014-10-29 21:27:26", "2014-10-29 21:27:26", "", "0", "http://blogsforsales.com/parenting/?p=109", "7", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("110", "1", "2014-10-29 18:44:43", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2014-10-29 18:44:43", "0000-00-00 00:00:00", "", "0", "http://blogsforsales.com/parenting/?page_id=110", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("111", "1", "2014-10-29 18:45:35", "2014-10-29 18:45:35", "<iframe src=\"http://astore.amazon.com/parenting045-20\" width=\"90%\" height=\"4000\" frameborder=\"0\" scrolling=\"no\"></iframe>\r\n", "Store", "", "publish", "closed", "closed", "", "store", "", "", "2014-10-29 20:53:29", "2014-10-29 20:53:29", "", "0", "http://blogsforsales.com/parenting/?page_id=111", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("113", "1", "2014-10-29 18:46:44", "2014-10-29 18:46:44", " ", "", "", "publish", "closed", "closed", "", "113", "", "", "2014-10-29 21:27:26", "2014-10-29 21:27:26", "", "0", "http://blogsforsales.com/parenting/?p=113", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("114", "1", "2014-10-29 20:47:43", "2014-10-29 20:47:43", "", "baby-443388_1280", "", "inherit", "closed", "closed", "", "baby-443388_1280", "", "", "2014-10-29 20:47:43", "2014-10-29 20:47:43", "", "49", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/baby-443388_1280.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("115", "1", "2014-10-29 20:48:32", "2014-10-29 20:48:32", "<div class=\"entry\">\r\n\r\nEvery parent has been there. Wondering what went horribly wrong when a once sleeping beauty turns into a screaming force to be reckoned with is enough to rattle the nerves of even the most experienced care giver. My mother used to say, “Birds fly and babies cry.” She wasn’t kidding. Understanding the normalcy of a crying baby is the first step to soothing the baby.\r\n\r\nBabies cry. It is the only form of communication they have mastered at an infant stage of life. The first step in calming the baby is to be a calm parent. An infant cries to get our attention so that we can fulfill a need, whatever it may be at that particular time. If the parent is frantic those feelings will be felt by the baby and probably cause more crying. A relaxed and collected parent will most likely be able to recognize the baby’s need and calm the baby quicker.\r\n\r\nThere is a process of elimination that may be used in recognizing the source of the baby’s distress. The usual suspects are as follows: soiled diaper, hunger and the need to simply be held. Babies often swallow air while crying so holding the infant while rubbing its back gently may loosen a trapped air pocket and bring the baby instant comfort while also giving the baby some snuggle time. If by chance the little one should drift off to sleep while being held, congratulations and problem solved.\r\n\r\nIf not, check for a soiled diaper. The baby should be relatively calm by now but may not like the fact that its diaper is being changed. This is the time to speak very softly and even sing whatever song comes to mind in a very soft and gentle tone. Speaking softly to the baby and singing are great ways to create a distraction from whatever is bothering the infant and keep the parent relaxed at the same time. It is so important for the parent to maintain a relaxed demeanor during this time. Babies feed off of their care givers feelings. A relaxed parent equals a relaxed baby as well as a frustrated and frantic parent will result in an unsettled and upset baby.\r\n\r\nWhile changing the diaper, watch for signs that the infant may be hungry. Possible signs of hunger are opening and closing the mouth and sucking on lips, tongue and fingers. By this time even if the infant wasn’t hungry when the crying started, it may very well be ready for a feeding now. After feeding the baby another diaper check may be in order before putting the infant back down to sleep. Better to check than not to.\r\n\r\nThere are still the times that an infant just wants to be in the arms of its parent. This too can be a tricky task. To swaddle or not to swaddle depends completely on the individual baby. Some babies prefer being held in a rocking chair to be lulled to sleep and some need the parent to be standing and walking around. Very few will be satisfied with a stationary parent. The movement itself is comforting. Now, if lullaby lyrics are long forgotten, time to brush up on the family favorites. The baby may also respond more to one song than another. Repeating the infant’s favorites is a great way to establish a sense of calm between the parent and the infant.\r\n\r\nPlease note that if at any time a medical issue is thought to be the source of the baby’s crying, a call to the pediatrician is in order.\r\n\r\nWith that said, enjoy the new arrival. The baby’s first days and weeks may seem overwhelming, but they do pass quickly. Being calm and collected through the frustrating times will allow for more of the gentle and loving moments between baby and parent.\r\n\r\n</div>", "How to Soothe a Crying Baby", "", "inherit", "closed", "closed", "", "49-revision-v1", "", "", "2014-10-29 20:48:32", "2014-10-29 20:48:32", "", "49", "http://blogsforsales.com/parenting/49-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("116", "1", "2014-10-29 20:53:29", "2014-10-29 20:53:29", "<iframe src=\"http://astore.amazon.com/parenting045-20\" width=\"90%\" height=\"4000\" frameborder=\"0\" scrolling=\"no\"></iframe>\r\n", "Store", "", "inherit", "closed", "closed", "", "111-revision-v1", "", "", "2014-10-29 20:53:29", "2014-10-29 20:53:29", "", "111", "http://blogsforsales.com/parenting/111-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("118", "1", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "[vc_row el_position=\"first last\"][vc_column width=\"2/3\"][vc_column_text]\r\n\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse non nunc ac quam congue fermentum et vel massa. Proin imperdiet pulvinar rhoncus. Integer in elit accumsan, ullamcorper ante non, commodo velit. Nunc luctus scelerisque dui, vitae luctus est auctor eu.\r\n\r\n[/vc_column_text][vc_gmaps link=\"http://maps.google.com/maps?q=Town+Hall+Square,+Kent+Street,+Sydney,+New+South+Wales,+Australia&amp;hl=en&amp;sll=-33.887464,151.187968&amp;sspn=0.007472,0.016512&amp;oq=square+australia+sy&amp;t=h&amp;hq=Town+Hall+Square,&amp;hnear=Kent+St,+New+South+Wales+2000,+Australia&amp;z=16\" size=\"308\" type=\"m\" zoom=\"14\"][vc_row_inner][vc_column_inner width=\"1/2\"][td_text_with_title title=\"Contact\" style=\"style_2\" el_position=\"first last\" custom_title=\"CONTACT DETAILS\"]\r\n\r\nNewspaper Comunication Service\r\n425 Santa Teresa St.\r\nStanford, CA 452 14 521\r\n\r\n(650) 723-2558 (main number)\r\n(650) 725-0247 (fax)\r\n\r\nEmail: contact@newspaper.com\r\n\r\n[/td_text_with_title][/vc_column_inner][vc_column_inner width=\"1/2\"][td_social custom_title=\"OUR SOCIAL PROFILES\" icon_style=\"1\" icon_size=\"32\" dribbble=\"http://www.tagdiv.com\" facebook=\"http://www.tagdiv.com\" googleplus=\"#\" grooveshark=\"http://www.tagdiv.com\" linkedin=\"#\" twitter=\"http://www.tagdiv.com\" youtube=\"http://www.tagdiv.com\" el_position=\"first\"][td_text_with_title custom_title=\"WORKING HOUR\"]\r\n\r\nThe office is open from 8 a.m. to 5 p.m. Monday through Friday except university holidays.\r\n\r\n[/td_text_with_title][/vc_column_inner][/vc_row_inner][contact-form-7 id=\"797\" title=\"LEAVE US A MESSAGE\"][/vc_column][vc_column width=\"1/3\"][vc_widget_sidebar sidebar_id=\"td-default\" el_position=\"first last\"][/vc_column][/vc_row]", "Home", "", "inherit", "closed", "closed", "", "35-revision-v1", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "35", "http://blogsforsales.com/parenting/35-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("119", "1", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "[vc_row][vc_column width=\"1/1\"][td_slide_big limit=\"8\" hide_title=\"hide_title\"][/vc_column][/vc_row][vc_row][vc_column width=\"2/3\"][td_block2 limit=\"6\" show_child_cat=\"3\" ajax_pagination=\"next_prev\" custom_title=\"Some title\"][td_slide limit=\"3\" hide_title=\"hide_title\" sort=\"popular\"][/vc_column][vc_column width=\"1/3\"][td_ad_box spot_name=\"Ad spot -- sidebar ad\"][td_social_counter facebook=\"themeforest\" twitter=\"envato\" youtube=\"collegehumor\"][vc_tabs][vc_tab title=\"TECH\" tab_id=\"1377688452-1-87\"][td_block4 limit=\"4\" hide_title=\"hide_title\"][/vc_tab][vc_tab title=\"VIDEO\" tab_id=\"1377688452-2-89\"][td_block4 limit=\"4\" hide_title=\"hide_title\"][/vc_tab][vc_tab title=\"GAMES\" tab_id=\"1377688607242-2-3\"][td_block4 limit=\"4\" hide_title=\"hide_title\"][/vc_tab][/vc_tabs][/vc_column][/vc_row]", "Homepage 2", "", "inherit", "closed", "closed", "", "23-revision-v1", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "23", "http://blogsforsales.com/parenting/23-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("120", "1", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "[vc_row][vc_column width=\"2/3\"][td_slide limit=\"5\" hide_title=\"hide_title\"][td_block1 limit=\"5\" sort=\"popular\" custom_title=\"MOST POPULAR\" ajax_pagination=\"load_more\"][td_block2 limit=\"6\" show_child_cat=\"3\" ajax_pagination=\"next_prev\"][vc_row_inner][vc_column_inner width=\"1/2\"][td_slide limit=\"3\"][/vc_column_inner][vc_column_inner width=\"1/2\"][td_block4 limit=\"5\"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column width=\"1/3\"][td_social_counter facebook=\"themeforest\" twitter=\"envato\" youtube=\"jonlajoie\"][td_block3 limit=\"3\" custom_title=\"LATEST VIDEO\"][td_ad_box spot_name=\"Ad spot -- sidebar ad\"][td_block2 limit=\"4\" custom_title=\"TRAVEL\"][/vc_column][/vc_row]", "Homepage 3", "", "inherit", "closed", "closed", "", "25-revision-v1", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "25", "http://blogsforsales.com/parenting/25-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("121", "1", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "[vc_row][vc_column width=\"1/1\"][td_slide_big limit=\"12\" hide_title=\"hide_title\"][td_block2 sort=\"popular\" limit=\"3\" show_child_cat=\"3\"][/vc_column][/vc_row]", "Homepage 3 columns", "", "inherit", "closed", "closed", "", "33-revision-v1", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "33", "http://blogsforsales.com/parenting/33-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("122", "1", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "[vc_row][vc_column width=\"2/3\"][td_slide category_id=\"98\" limit=\"5\" hide_title=\"hide_title\"][td_block1 limit=\"5\" sort=\"popular\" custom_title=\"MOST POPULAR\" ajax_pagination=\"load_more\"][td_block2 limit=\"6\" show_child_cat=\"3\" ajax_pagination=\"next_prev\"][vc_row_inner][vc_column_inner width=\"1/2\"][td_slide limit=\"3\"][/vc_column_inner][vc_column_inner width=\"1/2\"][td_block4 limit=\"5\"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column width=\"1/3\"][td_social_counter facebook=\"themeforest\" twitter=\"envato\" youtube=\"jonlajoie\"][td_block3 limit=\"3\" custom_title=\"LATEST VIDEO\"][td_ad_box spot_name=\"Ad spot -- sidebar ad\" spot_id=\"sidebar\"][td_block2 category_id=\"98\" limit=\"4\" custom_title=\"TRAVEL\"][/vc_column][/vc_row]", "Homepage 3 – magazinly", "", "inherit", "closed", "closed", "", "31-revision-v1", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "31", "http://blogsforsales.com/parenting/31-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("123", "1", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "[vc_row][vc_column width=\"1/1\"][td_slide_big limit=\"8\" hide_title=\"hide_title\"][td_block2 custom_title=\"Infinite scroll\" show_child_cat=\"3\"][/vc_column][/vc_row][vc_row][vc_column width=\"2/3\"][td_block3 limit=\"10\" ajax_pagination=\"infinite\" custom_title=\"Latest articles\"][/vc_column][vc_column width=\"1/3\"][vc_widget_sidebar sidebar_id=\"td-default\"][/vc_column][/vc_row]", "Homepage infinite scroll", "", "inherit", "closed", "closed", "", "29-revision-v1", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "29", "http://blogsforsales.com/parenting/29-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("124", "1", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "[vc_row][vc_column width=\"2/3\"][td_slide limit=\"5\" hide_title=\"hide_title\"][td_block1 limit=\"5\" sort=\"popular\" custom_title=\"MOST POPULAR\" ajax_pagination=\"load_more\"][td_block2 limit=\"6\" show_child_cat=\"3\" ajax_pagination=\"next_prev\" custom_title=\"Some title\"][vc_row_inner][vc_column_inner width=\"1/2\"][td_slide limit=\"3\" custom_title=\"Some title\"][/vc_column_inner][vc_column_inner width=\"1/2\"][td_block4 limit=\"5\" custom_title=\"Some title\"][/vc_column_inner][/vc_row_inner][/vc_column][vc_column width=\"1/3\"][td_social_counter facebook=\"themeforest\" twitter=\"envato\" youtube=\"jonlajoie\"][td_block3 limit=\"3\" custom_title=\"LATEST VIDEO\"][td_ad_box spot_name=\"Ad spot -- sidebar ad\"][td_block2 limit=\"4\" custom_title=\"TRAVEL\"][/vc_column][/vc_row]", "Homepage – with background", "", "inherit", "closed", "closed", "", "27-revision-v1", "", "", "2014-10-29 21:25:54", "2014-10-29 21:25:54", "", "27", "http://blogsforsales.com/parenting/27-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("125", "1", "2014-10-29 21:26:28", "2014-10-29 21:26:28", " ", "", "", "publish", "closed", "closed", "", "125", "", "", "2014-10-29 21:27:26", "2014-10-29 21:27:26", "", "0", "http://blogsforsales.com/parenting/?p=125", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("126", "1", "2014-10-29 21:27:26", "2014-10-29 21:27:26", " ", "", "", "publish", "closed", "closed", "", "126", "", "", "2014-10-29 21:27:26", "2014-10-29 21:27:26", "", "0", "http://blogsforsales.com/parenting/?p=126", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("127", "1", "2014-10-29 21:31:35", "2014-10-29 21:31:35", "", "baby-17342_1280", "", "inherit", "closed", "closed", "", "baby-17342_1280", "", "", "2014-10-29 21:31:35", "2014-10-29 21:31:35", "", "48", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/baby-17342_1280.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("129", "1", "2014-10-29 21:35:39", "2014-10-29 21:35:39", "", "girl-344327_1280", "", "inherit", "closed", "closed", "", "girl-344327_1280", "", "", "2014-10-29 21:35:39", "2014-10-29 21:35:39", "", "48", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/girl-344327_1280.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("130", "1", "2014-10-29 21:35:49", "2014-10-29 21:35:49", "<div class=\"entry\">\r\n\r\nBeing in constant care of a new baby could mean spending lots of time on the couch to cuddle, feed or entertain. Although this may be just what the doctor ordered after childbirth, when doc says it’s OK to get moving take the advice and get active! It is the simplest way to boost your spirits and get more energy to keep up with a growing baby.\r\n\r\nThere are several ways to keep moving without having to venture out of your home. The most common form of new mommy exercise would be the “walk and cuddle.” Simply hold your baby close and walk around the house stopping at all points of interest and describing them to your baby. Colorful magnets on the refrigerator are always a hit along with taking a peek out of a window to watch birds at a feeder or snow falling. Always be careful not to let your baby touch anything that may be a health hazard such as a small object that could be swallowed.\r\n\r\nDon’t limit your time up on your feet to just walking. Put on some soothing music and dance with your baby. Your baby will love the graceful fluid motion of the dance and the cuddle time with you. Add to that your singing, no matter how fabulous your voice and you’ve got yourself a workout that will be truly enjoyed by both you and baby.\r\n\r\nNewborn babies spend most of their day sleeping and if you’ve got the energy this is a great time to catch up on all of those fitness DVD’s you’ve got stowed away, maybe some of them still in the plastic. Start small and never exceed doctor’s recommendations. Even a 10 minute low impact workout can be enough to boost your spirits and give you that second or third wind for the day.\r\n\r\nWalking is great exercise, whether done indoors holding baby or out with baby in a stroller. Taking baby for a walk outside in a stroller has more than just the workout benefit. Sometimes this is just the miracle you could be looking for to get an overtired bundle of joy to sleep while you get to enjoy a refreshing walk, a change of scenery and some quiet time. It is a wonderful way to break up the day and to meet your neighbors, not to mention that making this a part of your daily routine will get you well on your way to fitting back into your “before pregnancy” wardrobe!\r\n\r\nPlaytime with your baby is spent mostly on the floor. Maximize this time by doing a few simple floor exercises during play. A quick abdominal workout can be accomplished simply by lying on the floor next to baby and doing sets of crunches while reciting baby’s favorite nursery rhymes. Mix it up with your favorite moves from fitness DVD’s and magazines and you may be surprised at how quickly a total floor routine can be accomplished all while entertaining your baby.\r\n\r\nAs with all exercise programs it is recommended to talk with your doctor before starting. Staying active is essential for healthy living and improves your mental outlook and stamina for keeping up with a growing baby. It will also show a great example for your child to follow and aid in lowering the risk of being overweight.\r\n\r\nGet creative and find new ways to stay active with your child as they grow and develop. This will not only keep the two of you healthy and fit, but will also strengthen the bond between mother and child that will last a lifetime.\r\n\r\n</div>", "Keeping Active with a New Baby", "", "inherit", "closed", "closed", "", "48-revision-v1", "", "", "2014-10-29 21:35:49", "2014-10-29 21:35:49", "", "48", "http://blogsforsales.com/parenting/48-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("131", "1", "2014-10-30 19:30:19", "2014-10-30 19:30:19", "Not sure how to give baby a bath? Watch as The Bump.com mommy Alison gives tips on cleaning baby that will make bath time a sinch. First, place the bathtub in the kitchen sink so baby is at a comfortable height for you to wash them. When positioned in the bath, lay a washcloth on baby\'s chest to keep them warm. You can also tur", "Top Baby Bath Tips", "", "inherit", "closed", "closed", "", "44-revision-v1", "", "", "2014-10-30 19:30:19", "2014-10-30 19:30:19", "", "44", "http://blogsforsales.com/parenting/44-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("132", "1", "2014-10-30 19:30:20", "2014-10-30 19:30:20", "", "44", "", "inherit", "closed", "closed", "", "44", "", "", "2014-10-30 19:30:20", "2014-10-30 19:30:20", "", "44", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/hqdefault1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("135", "1", "2014-10-30 21:12:10", "2014-10-30 21:12:10", "Need help planning a baby shower? Get a free audio book on how to plan a baby shower on me. The name of the book is \"Celebrate!: How to Plan and Host the Best Baby Shower Ever!\"", "Baby Shower Ideas and Tips", "", "inherit", "closed", "closed", "", "46-revision-v1", "", "", "2014-10-30 21:12:10", "2014-10-30 21:12:10", "", "46", "http://blogsforsales.com/parenting/46-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("136", "1", "2014-10-30 21:12:11", "2014-10-30 21:12:11", "", "46", "", "inherit", "closed", "closed", "", "46", "", "", "2014-10-30 21:12:11", "2014-10-30 21:12:11", "", "46", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/hqdefault2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("137", "1", "2014-10-30 22:05:01", "2014-10-30 22:05:01", "[vc_row el_position=\"first last\"][vc_column][td_slide_big limit=\"8\" hide_title=\"hide_title\" el_position=\"first\"][/vc_column][/vc_row]", "Home", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2014-10-30 22:05:01", "2014-10-30 22:05:01", "", "16", "http://blogsforsales.com/parenting/16-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("138", "1", "2014-10-30 22:07:15", "2014-10-30 22:07:15", "Dr. Bill Sears shares his tips to get baby to go to sleep and stay asleep!", "Dr. Sears\' Top Baby Sleep Tips", "", "inherit", "closed", "closed", "", "47-revision-v1", "", "", "2014-10-30 22:07:15", "2014-10-30 22:07:15", "", "47", "http://blogsforsales.com/parenting/47-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("139", "1", "2014-10-30 22:07:15", "2014-10-30 22:07:15", "", "47", "", "inherit", "closed", "closed", "", "47", "", "", "2014-10-30 22:07:15", "2014-10-30 22:07:15", "", "47", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/maxresdefault.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("140", "1", "2014-10-31 21:12:03", "2014-10-31 21:12:03", "Here are some easy &amp; fun baby shower game ideas! I hope you are able to use these ideas for your upcoming shower.", "Fun & Easy Baby Shower Games & Ideas ", "", "inherit", "closed", "closed", "", "41-revision-v1", "", "", "2014-10-31 21:12:03", "2014-10-31 21:12:03", "", "41", "http://blogsforsales.com/parenting/41-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("141", "1", "2014-10-31 21:12:04", "2014-10-31 21:12:04", "", "41", "", "inherit", "closed", "closed", "", "41", "", "", "2014-10-31 21:12:04", "2014-10-31 21:12:04", "", "41", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/hqdefault3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("142", "1", "2014-10-31 21:31:12", "2014-10-31 21:31:12", "", "baby-21167_1280", "", "inherit", "closed", "closed", "", "baby-21167_1280", "", "", "2014-10-31 21:31:12", "2014-10-31 21:31:12", "", "37", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/baby-21167_1280.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("143", "1", "2014-10-31 21:31:22", "2014-10-31 21:31:22", "Breastfeeding refers to the process by which a mother feeds her infant with milk directly from her breasts. Assuming the mother does not have certain illnesses, breast milk is widely believed to be the most beneficial for feeding young infants. It is even said that breastfeeding can strengthen the bond between mother and child. Still, some mothers choose not to participate in breastfeeding their infants and opt for store bought formula instead.\r\n\r\nThere are a number of benefits, which result from breastfeeding for infants. Among them, immediate milk that does not have to be heated as it is already at body temperature. In addition, some experts believe that breastfeeding decreases the risk of certain ailments, while increasing the healthy development of teeth and gums.\r\n\r\nAlong with the infant, there are positive results that stem from breastfeeding for the mother. Among them, a nurturing feeling toward her infant, a quicker return to the mom’s pre-birth weight and may help to prevent certain illnesses later on in life.\r\n\r\nOften, the infant may refuse breastfeeding at first for a variety of reasons. Normally, these can be determined and corrected with proper instruction from a physician. These may be occurrences that go away by themselves or it may be an indication of an infant that has certain medical conditions that prevent them from feeding properly.\r\n\r\nMothers who have certain medical conditions or are taking certain medications should not participate in breastfeeding her infant. The reason is because either the illness or the medication itself may be transmitted to the infant during this time, which can be very harmful to him/her. For this reason, the mother must inform her doctor about any medications or ailments that she currently has prior to beginning to breastfeed her child.\r\n\r\nMany new mothers do not realize it, but breastfeeding may cause soreness and even bruising. This is not unnatural, but can be a sign of improper positioning. These instances will usually clear themselves up, but should be checked by a physician just to be safe.\r\n\r\nThis article is to be used for informational purposes only. The information contained herein is not intended to be used in place of, or in conjunction with, professional medical advice or recommendations for or against breastfeeding. Before deciding to breastfeed their child, the new mother must consult a licensed medical doctor in order to determine the best course of action for his/her individual situation and the safe feeding of her child.", "Breastfeeding Your Child", "", "inherit", "closed", "closed", "", "37-revision-v1", "", "", "2014-10-31 21:31:22", "2014-10-31 21:31:22", "", "37", "http://blogsforsales.com/parenting/37-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("144", "1", "2014-10-31 21:31:55", "2014-10-31 21:31:55", "<p>Doner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon. </p><p>Bacon ipsum dolor sit amet tongue salami beef short loin, leberkas prosciutto ground round beef ribs strip steak shoulder turducken cow pork loin biltong. Bacon sausage ribeye rump, salami biltong strip steak.</p><p>Jowl sausage shank venison pork loin chuck chicken salami. Tail chuck capicola pancetta, bresaola jerky boudin shankle venison andouille turducken.</p><p>Pancetta swine ground round, beef ribs tenderloin meatloaf tail sausage bresaola fatback. Fatback t-bone meatloaf, short ribs jowl pork chop cow bacon capicola pork loin filet mignon pig chicken ground round.</p><p>Doner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon. </p><p>Doner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon. </p>", "The iPad for poor people has arrived, here is our review", "", "inherit", "closed", "closed", "", "43-revision-v1", "", "", "2014-10-31 21:31:55", "2014-10-31 21:31:55", "", "43", "http://blogsforsales.com/parenting/43-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("145", "1", "2014-10-31 21:43:33", "2014-10-31 21:43:33", "Turducken brisket short loin ham meatloaf meatball corned beef drumstick chicken ball tip. Pork loin ribeye strip steak shank tenderloin ham hock, boudin drumstick biltong leberkas pastrami meatball fatback short loin tail. Leberkas beef shank short loin sausage, fatback corned beef.\n\nDoner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon.\n\nPancetta swine ground round, beef ribs tenderloin meatloaf tail sausage bresaola fatback. Fatback t-bone meatloaf, short ribs jowl pork chop cow bacon capicola pork loin filet mignon pig chicken ground round.\n\nDoner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon.\n\nJowl sausage shank venison pork loin chuck chicken salami. Tail chuck capicola pancetta, bresaola jerky boudin shankle venison andouille turducken.\n\nDoner shoulder pork belly ball tip meatloaf flank leberkas pork chop pancetta tri-tip jowl tenderloin spare ribs filet mignon.\n\nTurducken brisket short loin ham meatloaf meatball corned beef drumstick chicken ball tip. Pork loin ribeye strip steak shank tenderloin ham hock, boudin drumstick biltong leberkas pastrami meatball fatback short loin tail. Leberkas beef shank short loin sausage, fatback corned beef.", "Top 20 Baby Songs for Children", "", "inherit", "closed", "closed", "", "39-autosave-v1", "", "", "2014-10-31 21:43:33", "2014-10-31 21:43:33", "", "39", "http://blogsforsales.com/parenting/39-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("146", "1", "2014-10-31 21:44:05", "2014-10-31 21:44:05", "Here is a non-stop Popular Baby Songs Collection for your children and baby toddlers featuring \"Itsy Bitsy Spider\" \"Five Little Monkeys\" \"Hickory Dickory Dock\" \"Mary Had a little lamb\" \"Row Row Your Boat\" \"Baa Baa Black Sheep\" \"London Bridge\" \"Twinkle Twinkle\" &amp; many more. This baby songs collection is perfect for teaching nursery rhymes to your children, baby toddlers.", "Top 20 Baby Songs for Children", "", "inherit", "closed", "closed", "", "39-revision-v1", "", "", "2014-10-31 21:44:05", "2014-10-31 21:44:05", "", "39", "http://blogsforsales.com/parenting/39-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("147", "1", "2014-10-31 21:44:05", "2014-10-31 21:44:05", "", "39", "", "inherit", "closed", "closed", "", "39", "", "", "2014-10-31 21:44:05", "2014-10-31 21:44:05", "", "39", "http://blogsforsales.com/parenting/wp-content/uploads/2014/10/maxresdefault1.jpg", "0", "attachment", "image/jpeg", "0");

/* INSERT TABLE DATA: wp_revslider_css */
INSERT INTO `wp_revslider_css` VALUES("1", ".tp-caption.medium_grey", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"padding\":\"2px 4px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#888\",\"white-space\":\"nowrap\"}");
INSERT INTO `wp_revslider_css` VALUES("2", ".tp-caption.small_text", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"14px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}");
INSERT INTO `wp_revslider_css` VALUES("3", ".tp-caption.medium_text", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}");
INSERT INTO `wp_revslider_css` VALUES("4", ".tp-caption.large_text", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"40px\",\"line-height\":\"40px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}");
INSERT INTO `wp_revslider_css` VALUES("5", ".tp-caption.very_large_text", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"letter-spacing\":\"-2px\"}");
INSERT INTO `wp_revslider_css` VALUES("6", ".tp-caption.very_big_white", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"background-color\":\"#000\"}");
INSERT INTO `wp_revslider_css` VALUES("7", ".tp-caption.very_big_black", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"700\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"background-color\":\"#fff\"}");
INSERT INTO `wp_revslider_css` VALUES("8", ".tp-caption.modern_medium_fat", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}");
INSERT INTO `wp_revslider_css` VALUES("9", ".tp-caption.modern_medium_fat_white", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}");
INSERT INTO `wp_revslider_css` VALUES("10", ".tp-caption.modern_medium_light", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}");
INSERT INTO `wp_revslider_css` VALUES("11", ".tp-caption.modern_big_bluebg", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"padding\":\"3px 10px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#4e5b6c\",\"letter-spacing\":\"0\"}");
INSERT INTO `wp_revslider_css` VALUES("12", ".tp-caption.modern_big_redbg", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-family\":\"\\\"Open Sans\\\", sans-serif\",\"padding\":\"3px 10px\",\"padding-top\":\"1px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#de543e\",\"letter-spacing\":\"0\"}");
INSERT INTO `wp_revslider_css` VALUES("13", ".tp-caption.modern_small_text_dark", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#555\",\"text-shadow\":\"none\",\"font-size\":\"14px\",\"line-height\":\"22px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}");
INSERT INTO `wp_revslider_css` VALUES("14", ".tp-caption.boxshadow", NULL, NULL, "{\"-moz-box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\",\"-webkit-box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\",\"box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\"}");
INSERT INTO `wp_revslider_css` VALUES("15", ".tp-caption.black", NULL, NULL, "{\"color\":\"#000\",\"text-shadow\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("16", ".tp-caption.noshadow", NULL, NULL, "{\"text-shadow\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("17", ".tp-caption.thinheadline_dark", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"rgba(0,0,0,0.85)\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"transparent\"}");
INSERT INTO `wp_revslider_css` VALUES("18", ".tp-caption.thintext_dark", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"rgba(0,0,0,0.85)\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"16px\",\"line-height\":\"26px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"transparent\"}");
INSERT INTO `wp_revslider_css` VALUES("19", ".tp-caption.largeblackbg", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#000\",\"padding\":\"0px 20px\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\",\"border-radius\":\"0px\"}");
INSERT INTO `wp_revslider_css` VALUES("20", ".tp-caption.largepinkbg", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#db4360\",\"padding\":\"0px 20px\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\",\"border-radius\":\"0px\"}");
INSERT INTO `wp_revslider_css` VALUES("21", ".tp-caption.largewhitebg", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#fff\",\"padding\":\"0px 20px\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\",\"border-radius\":\"0px\"}");
INSERT INTO `wp_revslider_css` VALUES("22", ".tp-caption.largegreenbg", NULL, NULL, "{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"50px\",\"line-height\":\"70px\",\"font-family\":\"\\\"Open Sans\\\"\",\"background-color\":\"#67ae73\",\"padding\":\"0px 20px\",\"-webkit-border-radius\":\"0px\",\"-moz-border-radius\":\"0px\",\"border-radius\":\"0px\"}");
INSERT INTO `wp_revslider_css` VALUES("23", ".tp-caption.excerpt", NULL, NULL, "{\"font-size\":\"36px\",\"line-height\":\"36px\",\"font-weight\":\"700\",\"font-family\":\"Arial\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"rgba(0, 0, 0, 1)\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"letter-spacing\":\"-1.5px\",\"padding\":\"1px 4px 0px 4px\",\"width\":\"150px\",\"white-space\":\"normal !important\",\"height\":\"auto\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 255, 255)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("24", ".tp-caption.large_bold_grey", NULL, NULL, "{\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(102, 102, 102)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"padding\":\"1px 4px 0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("25", ".tp-caption.medium_thin_grey", NULL, NULL, "{\"font-size\":\"34px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(102, 102, 102)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"1px 4px 0px\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("26", ".tp-caption.small_thin_grey", NULL, NULL, "{\"font-size\":\"18px\",\"line-height\":\"26px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(117, 117, 117)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"1px 4px 0px\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("27", ".tp-caption.lightgrey_divider", NULL, NULL, "{\"text-decoration\":\"none\",\"background-color\":\"rgba(235, 235, 235, 1)\",\"width\":\"370px\",\"height\":\"3px\",\"background-position\":\"initial initial\",\"background-repeat\":\"initial initial\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("28", ".tp-caption.large_bold_darkblue", NULL, NULL, "{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(52, 73, 94)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("29", ".tp-caption.medium_bg_darkblue", NULL, NULL, "{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(52, 73, 94)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("30", ".tp-caption.medium_bold_red", NULL, NULL, "{\"font-size\":\"24px\",\"line-height\":\"30px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(227, 58, 12)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("31", ".tp-caption.medium_light_red", NULL, NULL, "{\"font-size\":\"21px\",\"line-height\":\"26px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(227, 58, 12)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("32", ".tp-caption.medium_bg_red", NULL, NULL, "{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(227, 58, 12)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("33", ".tp-caption.medium_bold_orange", NULL, NULL, "{\"font-size\":\"24px\",\"line-height\":\"30px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(243, 156, 18)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("34", ".tp-caption.medium_bg_orange", NULL, NULL, "{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(243, 156, 18)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("35", ".tp-caption.grassfloor", NULL, NULL, "{\"text-decoration\":\"none\",\"background-color\":\"rgba(160, 179, 151, 1)\",\"width\":\"4000px\",\"height\":\"150px\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("36", ".tp-caption.large_bold_white", NULL, NULL, "{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("37", ".tp-caption.medium_light_white", NULL, NULL, "{\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("38", ".tp-caption.mediumlarge_light_white", NULL, NULL, "{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("39", ".tp-caption.mediumlarge_light_white_center", NULL, NULL, "{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px 0px 0px 0px\",\"text-align\":\"center\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("40", ".tp-caption.medium_bg_asbestos", NULL, NULL, "{\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(127, 140, 141)\",\"padding\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("41", ".tp-caption.medium_light_black", NULL, NULL, "{\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("42", ".tp-caption.large_bold_black", NULL, NULL, "{\"font-size\":\"58px\",\"line-height\":\"60px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("43", ".tp-caption.mediumlarge_light_darkblue", NULL, NULL, "{\"font-size\":\"34px\",\"line-height\":\"40px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(52, 73, 94)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("44", ".tp-caption.small_light_white", NULL, NULL, "{\"font-size\":\"17px\",\"line-height\":\"28px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"padding\":\"0px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("45", ".tp-caption.roundedimage", NULL, NULL, "{\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("46", ".tp-caption.large_bg_black", NULL, NULL, "{\"font-size\":\"40px\",\"line-height\":\"40px\",\"font-weight\":\"800\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(255, 255, 255)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(0, 0, 0)\",\"padding\":\"10px 20px 15px\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 214, 88)\",\"border-style\":\"none\"}");
INSERT INTO `wp_revslider_css` VALUES("47", ".tp-caption.mediumwhitebg", NULL, NULL, "{\"font-size\":\"30px\",\"line-height\":\"30px\",\"font-weight\":\"300\",\"font-family\":\"\\\"Open Sans\\\"\",\"color\":\"rgb(0, 0, 0)\",\"text-decoration\":\"none\",\"background-color\":\"rgb(255, 255, 255)\",\"padding\":\"5px 15px 10px\",\"text-shadow\":\"none\",\"border-width\":\"0px\",\"border-color\":\"rgb(0, 0, 0)\",\"border-style\":\"none\"}");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("10", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("11", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("36", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("37", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("37", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("39", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("39", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("41", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("41", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("43", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("43", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("44", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("44", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("44", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("47", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("47", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("47", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("48", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "11", "0");
INSERT INTO `wp_term_relationships` VALUES("49", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("72", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("72", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("73", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("82", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("83", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("109", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("113", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("125", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "9", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "category", "Featured posts", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "nav_menu", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "nav_menu", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "category", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "category", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("7", "7", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("8", "8", "nav_menu", "", "0", "13");
INSERT INTO `wp_term_taxonomy` VALUES("9", "9", "nav_menu", "", "0", "7");
INSERT INTO `wp_term_taxonomy` VALUES("10", "10", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("11", "11", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("12", "12", "post_tag", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("13", "13", "post_format", "", "0", "5");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "New Born Baby", "newbornbaby", "0");
INSERT INTO `wp_terms` VALUES("2", "Featured", "featured", "0");
INSERT INTO `wp_terms` VALUES("3", "td_demo_top", "td_demo_top", "0");
INSERT INTO `wp_terms` VALUES("4", "td_demo_footer", "td_demo_footer", "0");
INSERT INTO `wp_terms` VALUES("5", "Videos", "videos", "0");
INSERT INTO `wp_terms` VALUES("6", "Parenting Tips", "parenting-tips", "0");
INSERT INTO `wp_terms` VALUES("7", "Category 3", "category-3", "0");
INSERT INTO `wp_terms` VALUES("8", "td header", "td-header", "0");
INSERT INTO `wp_terms` VALUES("9", "men", "men", "0");
INSERT INTO `wp_terms` VALUES("10", "baby", "baby", "0");
INSERT INTO `wp_terms` VALUES("11", "baby tips", "baby-tips", "0");
INSERT INTO `wp_terms` VALUES("12", "parenting tips", "parenting-tips-2", "0");
INSERT INTO `wp_terms` VALUES("13", "post-format-video", "post-format-video", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "f");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "l");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "wp350_media,wp360_revisions,wp360_locks,wp390_widgets");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("15", "1", "wp_dashboard_quick_press_last_post_id", "9");
INSERT INTO `wp_usermeta` VALUES("19", "1", "session_tokens", "a:2:{s:64:\"01d6b942ef1b075914806f311a32163e6cec3c3664c718912ce36dc3d66f0c74\";i:1414748160;s:64:\"7ad93c6c2ef264370f544db5fcfbdfb12d23546f7328da873090e632267cefb2\";i:1415816845;}");
INSERT INTO `wp_usermeta` VALUES("20", "1", "wp_user-settings", "align=left&imgsize=thumbnail&editor=tinymce&galfile=1&ngg_upload_resize=1&uploader=1&mfold=o&libraryContent=browse&urlbutton=file&hidetb=1&wplink=1");
INSERT INTO `wp_usermeta` VALUES("21", "1", "wp_user-settings-time", "1414618307");
INSERT INTO `wp_usermeta` VALUES("22", "1", "nav_menu_recently_edited", "9");
INSERT INTO `wp_usermeta` VALUES("23", "1", "managenav-menuscolumnshidden", "a:4:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";}");
INSERT INTO `wp_usermeta` VALUES("24", "1", "metaboxhidden_nav-menus", "a:3:{i:0;s:8:\"add-post\";i:1;s:12:\"add-post_tag\";i:2;s:15:\"add-post_format\";}");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "admin", "$P$BCnFhCS9BiZIqcSHppKBV976O2ao6a0", "admin", "mail@yourmail.com", "", "0000-00-00 00:00:00", "", "0", "admin");

SET FOREIGN_KEY_CHECKS = 1;